/* chess-state.c generated by valac 0.40.3, the Vala compiler
 * generated from chess-state.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2014 Robert Ancell
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_CHECK_STATE (check_state_get_type ())

#define TYPE_CHESS_STATE (chess_state_get_type ())
#define CHESS_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_STATE, ChessState))
#define CHESS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_STATE, ChessStateClass))
#define IS_CHESS_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_STATE))
#define IS_CHESS_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_STATE))
#define CHESS_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_STATE, ChessStateClass))

typedef struct _ChessState ChessState;
typedef struct _ChessStateClass ChessStateClass;
typedef struct _ChessStatePrivate ChessStatePrivate;

#define TYPE_CHESS_PLAYER (chess_player_get_type ())
#define CHESS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_PLAYER, ChessPlayer))
#define CHESS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_PLAYER, ChessPlayerClass))
#define IS_CHESS_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_PLAYER))
#define IS_CHESS_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_PLAYER))
#define CHESS_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_PLAYER, ChessPlayerClass))

typedef struct _ChessPlayer ChessPlayer;
typedef struct _ChessPlayerClass ChessPlayerClass;

#define TYPE_CHESS_PIECE (chess_piece_get_type ())
#define CHESS_PIECE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_PIECE, ChessPiece))
#define CHESS_PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_PIECE, ChessPieceClass))
#define IS_CHESS_PIECE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_PIECE))
#define IS_CHESS_PIECE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_PIECE))
#define CHESS_PIECE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_PIECE, ChessPieceClass))

typedef struct _ChessPiece ChessPiece;
typedef struct _ChessPieceClass ChessPieceClass;

#define TYPE_CHESS_MOVE (chess_move_get_type ())
#define CHESS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_MOVE, ChessMove))
#define CHESS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_MOVE, ChessMoveClass))
#define IS_CHESS_MOVE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_MOVE))
#define IS_CHESS_MOVE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_MOVE))
#define CHESS_MOVE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_MOVE, ChessMoveClass))

typedef struct _ChessMove ChessMove;
typedef struct _ChessMoveClass ChessMoveClass;
enum  {
	CHESS_STATE_0_PROPERTY,
	CHESS_STATE_OPPONENT_PROPERTY,
	CHESS_STATE_NUM_PROPERTIES
};
static GParamSpec* chess_state_properties[CHESS_STATE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_COLOR (color_get_type ())

#define TYPE_PIECE_TYPE (piece_type_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ChessPlayerPrivate ChessPlayerPrivate;
typedef struct _ChessPiecePrivate ChessPiecePrivate;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _ChessMovePrivate ChessMovePrivate;

#define TYPE_CHESS_RULE (chess_rule_get_type ())

#define TYPE_CHESS_RESULT (chess_result_get_type ())

typedef enum  {
	CHECK_STATE_NONE,
	CHECK_STATE_CHECK,
	CHECK_STATE_CHECKMATE
} CheckState;

struct _ChessState {
	GObject parent_instance;
	ChessStatePrivate * priv;
	gint number;
	ChessPlayer* players[2];
	ChessPlayer* current_player;
	gboolean can_castle_kingside[2];
	gboolean can_castle_queenside[2];
	gint en_passant_index;
	CheckState check_state;
	gint halfmove_clock;
	ChessPiece* board[64];
	ChessMove* last_move;
};

struct _ChessStateClass {
	GObjectClass parent_class;
};

struct _ChessStatePrivate {
	gint64 piece_masks[2];
};

typedef enum  {
	COLOR_WHITE,
	COLOR_BLACK
} Color;

typedef enum  {
	PIECE_TYPE_PAWN,
	PIECE_TYPE_ROOK,
	PIECE_TYPE_KNIGHT,
	PIECE_TYPE_BISHOP,
	PIECE_TYPE_QUEEN,
	PIECE_TYPE_KING
} PieceType;

struct _ChessPlayer {
	GObject parent_instance;
	ChessPlayerPrivate * priv;
	Color color;
};

struct _ChessPlayerClass {
	GObjectClass parent_class;
};

struct _ChessPiece {
	GObject parent_instance;
	ChessPiecePrivate * priv;
	ChessPlayer* player;
	PieceType type;
};

struct _ChessPieceClass {
	GObjectClass parent_class;
};

struct _ChessMove {
	GObject parent_instance;
	ChessMovePrivate * priv;
	gint number;
	ChessPiece* piece;
	ChessPiece* promotion_piece;
	ChessPiece* moved_rook;
	ChessPiece* victim;
	gint r0;
	gint f0;
	gint r1;
	gint f1;
	gboolean ambiguous_rank;
	gboolean ambiguous_file;
	CheckState check_state;
};

struct _ChessMoveClass {
	GObjectClass parent_class;
};

typedef enum  {
	CHESS_RULE_UNKNOWN,
	CHESS_RULE_CHECKMATE,
	CHESS_RULE_STALEMATE,
	CHESS_RULE_FIFTY_MOVES,
	CHESS_RULE_SEVENTY_FIVE_MOVES,
	CHESS_RULE_TIMEOUT,
	CHESS_RULE_THREE_FOLD_REPETITION,
	CHESS_RULE_FIVE_FOLD_REPETITION,
	CHESS_RULE_INSUFFICIENT_MATERIAL,
	CHESS_RULE_RESIGN,
	CHESS_RULE_ABANDONMENT,
	CHESS_RULE_DEATH,
	CHESS_RULE_BUG
} ChessRule;

typedef enum  {
	CHESS_RESULT_IN_PROGRESS,
	CHESS_RESULT_WHITE_WON,
	CHESS_RESULT_BLACK_WON,
	CHESS_RESULT_DRAW,
	CHESS_RESULT_BUG
} ChessResult;


static gpointer chess_state_parent_class = NULL;

GType check_state_get_type (void) G_GNUC_CONST;
GType chess_state_get_type (void) G_GNUC_CONST;
GType chess_player_get_type (void) G_GNUC_CONST;
GType chess_piece_get_type (void) G_GNUC_CONST;
GType chess_move_get_type (void) G_GNUC_CONST;
#define CHESS_STATE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CHESS_STATE, ChessStatePrivate))
static ChessState* chess_state_new_empty (void);
static ChessState* chess_state_construct_empty (GType object_type);
ChessState* chess_state_new (const gchar* fen);
ChessState* chess_state_construct (GType object_type,
                                   const gchar* fen);
GType color_get_type (void) G_GNUC_CONST;
ChessPlayer* chess_player_new (Color color);
ChessPlayer* chess_player_construct (GType object_type,
                                     Color color);
GType piece_type_get_type (void) G_GNUC_CONST;
static gboolean chess_state_decode_piece_type (ChessState* self,
                                        gunichar c,
                                        PieceType* type);
gint chess_state_get_index (ChessState* self,
                            gint rank,
                            gint file);
ChessPiece* chess_piece_new (ChessPlayer* player,
                             PieceType type);
ChessPiece* chess_piece_construct (GType object_type,
                                   ChessPlayer* player,
                                   PieceType type);
static CheckState chess_state_get_check_state (ChessState* self,
                                        ChessPlayer* player);
ChessState* chess_state_copy (ChessState* self);
ChessMove* chess_move_copy (ChessMove* self);
gboolean chess_state_equals (ChessState* self,
                             ChessState* state);
gchar* chess_state_get_fen (ChessState* self);
gunichar chess_piece_get_symbol (ChessPiece* self);
gint chess_state_get_file (ChessState* self,
                           gint index);
gint chess_state_get_rank (ChessState* self,
                           gint index);
gboolean chess_state_move (ChessState* self,
                           const gchar* move,
                           gboolean apply);
static gboolean chess_state_decode_move (ChessState* self,
                                  ChessPlayer* player,
                                  const gchar* move,
                                  gint* r0,
                                  gint* f0,
                                  gint* r1,
                                  gint* f1,
                                  PieceType* promotion_type);
gboolean chess_state_move_with_coords (ChessState* self,
                                       ChessPlayer* player,
                                       gint r0,
                                       gint f0,
                                       gint r1,
                                       gint f1,
                                       PieceType promotion_type,
                                       gboolean apply,
                                       gboolean test_check);
Color chess_piece_get_color (ChessPiece* self);
gboolean chess_state_is_in_check (ChessState* self,
                                  ChessPlayer* player);
ChessMove* chess_move_new (void);
ChessMove* chess_move_construct (GType object_type);
GType chess_rule_get_type (void) G_GNUC_CONST;
GType chess_result_get_type (void) G_GNUC_CONST;
ChessResult chess_state_get_result (ChessState* self,
                                    ChessRule* rule);
static gboolean chess_state_can_move (ChessState* self,
                               ChessPlayer* player);
gboolean chess_state_have_sufficient_material (ChessState* self);
static gboolean chess_state_is_in_checkmate (ChessState* self,
                                      ChessPlayer* player);
ChessPlayer* chess_state_get_opponent (ChessState* self);
static void chess_state_finalize (GObject * obj);
static void _vala_chess_state_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

extern const gint64 BIT_BOARD_set_location_masks[64];
extern const gint64 BIT_BOARD_move_masks[768];
extern const gint64 BIT_BOARD_over_masks[4096];
extern const gint64 BIT_BOARD_clear_location_masks[64];

GType
check_state_get_type (void)
{
	static volatile gsize check_state_type_id__volatile = 0;
	if (g_once_init_enter (&check_state_type_id__volatile)) {
		static const GEnumValue values[] = {{CHECK_STATE_NONE, "CHECK_STATE_NONE", "none"}, {CHECK_STATE_CHECK, "CHECK_STATE_CHECK", "check"}, {CHECK_STATE_CHECKMATE, "CHECK_STATE_CHECKMATE", "checkmate"}, {0, NULL, NULL}};
		GType check_state_type_id;
		check_state_type_id = g_enum_register_static ("CheckState", values);
		g_once_init_leave (&check_state_type_id__volatile, check_state_type_id);
	}
	return check_state_type_id__volatile;
}


static ChessState*
chess_state_construct_empty (GType object_type)
{
	ChessState * self = NULL;
	self = (ChessState*) g_object_new (object_type, NULL);
	return self;
}


static ChessState*
chess_state_new_empty (void)
{
	return chess_state_construct_empty (TYPE_CHESS_STATE);
}


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


ChessState*
chess_state_construct (GType object_type,
                       const gchar* fen)
{
	ChessState * self = NULL;
	ChessPlayer* _tmp0_;
	ChessPlayer* _tmp1_;
	ChessPlayer* _tmp2_;
	ChessPlayer* _tmp3_;
	gchar** fields = NULL;
	gchar** _tmp9_;
	gchar** _tmp10_;
	gint fields_length1;
	gint _fields_size_;
	gchar** ranks = NULL;
	gchar** _tmp11_;
	gint _tmp11__length1;
	const gchar* _tmp12_;
	gchar** _tmp13_;
	gchar** _tmp14_;
	gint ranks_length1;
	gint _ranks_size_;
	gchar** _tmp57_;
	gint _tmp57__length1;
	const gchar* _tmp58_;
	gchar** _tmp65_;
	gint _tmp65__length1;
	const gchar* _tmp66_;
	gchar** _tmp85_;
	gint _tmp85__length1;
	const gchar* _tmp86_;
	gchar** _tmp91_;
	gint _tmp91__length1;
	const gchar* _tmp92_;
	gchar** _tmp93_;
	gint _tmp93__length1;
	const gchar* _tmp94_;
	ChessPlayer* _tmp95_;
	Color _tmp96_;
	ChessPlayer* _tmp98_;
	g_return_val_if_fail (fen != NULL, NULL);
	self = (ChessState*) g_object_new (object_type, NULL);
	_tmp0_ = chess_player_new (COLOR_WHITE);
	_g_object_unref0 (self->players[COLOR_WHITE]);
	self->players[COLOR_WHITE] = _tmp0_;
	_tmp1_ = self->players[COLOR_WHITE];
	_tmp2_ = chess_player_new (COLOR_BLACK);
	_g_object_unref0 (self->players[COLOR_BLACK]);
	self->players[COLOR_BLACK] = _tmp2_;
	_tmp3_ = self->players[COLOR_BLACK];
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				gint _tmp6_;
				gint _tmp7_;
				ChessPiece* _tmp8_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				_tmp6_ = i;
				if (!(_tmp6_ < 64)) {
					break;
				}
				_tmp7_ = i;
				_g_object_unref0 (self->board[_tmp7_]);
				self->board[_tmp7_] = NULL;
				_tmp8_ = self->board[_tmp7_];
			}
		}
	}
	_tmp10_ = _tmp9_ = g_strsplit (fen, " ", 0);
	fields = _tmp10_;
	fields_length1 = _vala_array_length (_tmp9_);
	_fields_size_ = fields_length1;
	_tmp11_ = fields;
	_tmp11__length1 = fields_length1;
	_tmp12_ = _tmp11_[0];
	_tmp14_ = _tmp13_ = g_strsplit (_tmp12_, "/", 0);
	ranks = _tmp14_;
	ranks_length1 = _vala_array_length (_tmp13_);
	_ranks_size_ = ranks_length1;
	{
		gint rank = 0;
		rank = 0;
		{
			gboolean _tmp15_ = FALSE;
			_tmp15_ = TRUE;
			while (TRUE) {
				gint _tmp17_;
				gchar* rank_string = NULL;
				gchar** _tmp18_;
				gint _tmp18__length1;
				gint _tmp19_;
				const gchar* _tmp20_;
				gchar* _tmp21_;
				if (!_tmp15_) {
					gint _tmp16_;
					_tmp16_ = rank;
					rank = _tmp16_ + 1;
				}
				_tmp15_ = FALSE;
				_tmp17_ = rank;
				if (!(_tmp17_ < 8)) {
					break;
				}
				_tmp18_ = ranks;
				_tmp18__length1 = ranks_length1;
				_tmp19_ = rank;
				_tmp20_ = _tmp18_[7 - _tmp19_];
				_tmp21_ = g_strdup (_tmp20_);
				rank_string = _tmp21_;
				{
					gint file = 0;
					gint offset = 0;
					file = 0;
					offset = 0;
					{
						gboolean _tmp22_ = FALSE;
						_tmp22_ = TRUE;
						while (TRUE) {
							gboolean _tmp24_ = FALSE;
							gint _tmp25_;
							gchar c = '\0';
							const gchar* _tmp30_;
							gint _tmp31_;
							gboolean _tmp32_ = FALSE;
							gchar _tmp33_;
							PieceType type = 0;
							Color _tmp37_ = 0;
							gchar _tmp38_;
							Color color = 0;
							gchar _tmp39_;
							PieceType _tmp40_ = 0;
							gint index = 0;
							gint _tmp41_;
							gint _tmp42_;
							ChessPiece* piece = NULL;
							Color _tmp43_;
							ChessPlayer* _tmp44_;
							PieceType _tmp45_;
							ChessPiece* _tmp46_;
							gint _tmp47_;
							ChessPiece* _tmp48_;
							ChessPiece* _tmp49_;
							ChessPiece* _tmp50_;
							gint64 mask = 0LL;
							gint _tmp51_;
							gint64 _tmp52_;
							Color _tmp53_;
							gint64 _tmp54_;
							gint64 _tmp55_;
							gint _tmp56_;
							if (!_tmp22_) {
								gint _tmp23_;
								_tmp23_ = offset;
								offset = _tmp23_ + 1;
							}
							_tmp22_ = FALSE;
							_tmp25_ = file;
							if (_tmp25_ < 8) {
								gint _tmp26_;
								const gchar* _tmp27_;
								gint _tmp28_;
								gint _tmp29_;
								_tmp26_ = offset;
								_tmp27_ = rank_string;
								_tmp28_ = strlen (_tmp27_);
								_tmp29_ = _tmp28_;
								_tmp24_ = _tmp26_ < _tmp29_;
							} else {
								_tmp24_ = FALSE;
							}
							if (!_tmp24_) {
								break;
							}
							_tmp30_ = rank_string;
							_tmp31_ = offset;
							c = string_get (_tmp30_, (glong) _tmp31_);
							_tmp33_ = c;
							if (_tmp33_ >= '1') {
								gchar _tmp34_;
								_tmp34_ = c;
								_tmp32_ = _tmp34_ <= '8';
							} else {
								_tmp32_ = FALSE;
							}
							if (_tmp32_) {
								gint _tmp35_;
								gchar _tmp36_;
								_tmp35_ = file;
								_tmp36_ = c;
								file = _tmp35_ + (_tmp36_ - '0');
								continue;
							}
							_tmp38_ = c;
							if (g_ascii_isupper (_tmp38_)) {
								_tmp37_ = COLOR_WHITE;
							} else {
								_tmp37_ = COLOR_BLACK;
							}
							color = _tmp37_;
							_tmp39_ = c;
							chess_state_decode_piece_type (self, (gunichar) g_ascii_toupper (_tmp39_), &_tmp40_);
							type = _tmp40_;
							_tmp41_ = rank;
							_tmp42_ = file;
							index = chess_state_get_index (self, _tmp41_, _tmp42_);
							_tmp43_ = color;
							_tmp44_ = self->players[_tmp43_];
							_tmp45_ = type;
							_tmp46_ = chess_piece_new (_tmp44_, _tmp45_);
							piece = _tmp46_;
							_tmp47_ = index;
							_tmp48_ = piece;
							_tmp49_ = _g_object_ref0 (_tmp48_);
							_g_object_unref0 (self->board[_tmp47_]);
							self->board[_tmp47_] = _tmp49_;
							_tmp50_ = self->board[_tmp47_];
							_tmp51_ = index;
							_tmp52_ = BIT_BOARD_set_location_masks[_tmp51_];
							mask = _tmp52_;
							_tmp53_ = color;
							_tmp54_ = mask;
							self->priv->piece_masks[_tmp53_] |= _tmp54_;
							_tmp55_ = self->priv->piece_masks[_tmp53_];
							_tmp56_ = file;
							file = _tmp56_ + 1;
							_g_object_unref0 (piece);
						}
					}
				}
				_g_free0 (rank_string);
			}
		}
	}
	_tmp57_ = fields;
	_tmp57__length1 = fields_length1;
	_tmp58_ = _tmp57_[1];
	if (g_strcmp0 (_tmp58_, "w") == 0) {
		ChessPlayer* _tmp59_;
		ChessPlayer* _tmp60_;
		_tmp59_ = self->players[COLOR_WHITE];
		_tmp60_ = _g_object_ref0 (_tmp59_);
		_g_object_unref0 (self->current_player);
		self->current_player = _tmp60_;
	} else {
		gchar** _tmp61_;
		gint _tmp61__length1;
		const gchar* _tmp62_;
		_tmp61_ = fields;
		_tmp61__length1 = fields_length1;
		_tmp62_ = _tmp61_[1];
		if (g_strcmp0 (_tmp62_, "b") == 0) {
			ChessPlayer* _tmp63_;
			ChessPlayer* _tmp64_;
			_tmp63_ = self->players[COLOR_BLACK];
			_tmp64_ = _g_object_ref0 (_tmp63_);
			_g_object_unref0 (self->current_player);
			self->current_player = _tmp64_;
		}
	}
	_tmp65_ = fields;
	_tmp65__length1 = fields_length1;
	_tmp66_ = _tmp65_[2];
	if (g_strcmp0 (_tmp66_, "-") != 0) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp67_ = FALSE;
				_tmp67_ = TRUE;
				while (TRUE) {
					gint _tmp69_;
					gchar** _tmp70_;
					gint _tmp70__length1;
					const gchar* _tmp71_;
					gint _tmp72_;
					gint _tmp73_;
					gchar c = '\0';
					gchar** _tmp74_;
					gint _tmp74__length1;
					const gchar* _tmp75_;
					gint _tmp76_;
					gchar _tmp77_;
					if (!_tmp67_) {
						gint _tmp68_;
						_tmp68_ = i;
						i = _tmp68_ + 1;
					}
					_tmp67_ = FALSE;
					_tmp69_ = i;
					_tmp70_ = fields;
					_tmp70__length1 = fields_length1;
					_tmp71_ = _tmp70_[2];
					_tmp72_ = strlen (_tmp71_);
					_tmp73_ = _tmp72_;
					if (!(_tmp69_ < _tmp73_)) {
						break;
					}
					_tmp74_ = fields;
					_tmp74__length1 = fields_length1;
					_tmp75_ = _tmp74_[2];
					_tmp76_ = i;
					c = string_get (_tmp75_, (glong) _tmp76_);
					_tmp77_ = c;
					if (_tmp77_ == 'K') {
						gboolean _tmp78_;
						self->can_castle_kingside[COLOR_WHITE] = TRUE;
						_tmp78_ = self->can_castle_kingside[COLOR_WHITE];
					} else {
						gchar _tmp79_;
						_tmp79_ = c;
						if (_tmp79_ == 'Q') {
							gboolean _tmp80_;
							self->can_castle_queenside[COLOR_WHITE] = TRUE;
							_tmp80_ = self->can_castle_queenside[COLOR_WHITE];
						} else {
							gchar _tmp81_;
							_tmp81_ = c;
							if (_tmp81_ == 'k') {
								gboolean _tmp82_;
								self->can_castle_kingside[COLOR_BLACK] = TRUE;
								_tmp82_ = self->can_castle_kingside[COLOR_BLACK];
							} else {
								gchar _tmp83_;
								_tmp83_ = c;
								if (_tmp83_ == 'q') {
									gboolean _tmp84_;
									self->can_castle_queenside[COLOR_BLACK] = TRUE;
									_tmp84_ = self->can_castle_queenside[COLOR_BLACK];
								}
							}
						}
					}
				}
			}
		}
	}
	_tmp85_ = fields;
	_tmp85__length1 = fields_length1;
	_tmp86_ = _tmp85_[3];
	if (g_strcmp0 (_tmp86_, "-") != 0) {
		gchar** _tmp87_;
		gint _tmp87__length1;
		const gchar* _tmp88_;
		gchar** _tmp89_;
		gint _tmp89__length1;
		const gchar* _tmp90_;
		_tmp87_ = fields;
		_tmp87__length1 = fields_length1;
		_tmp88_ = _tmp87_[3];
		_tmp89_ = fields;
		_tmp89__length1 = fields_length1;
		_tmp90_ = _tmp89_[3];
		self->en_passant_index = chess_state_get_index (self, (gint) (string_get (_tmp88_, (glong) 1) - '1'), (gint) (string_get (_tmp90_, (glong) 0) - 'a'));
	}
	_tmp91_ = fields;
	_tmp91__length1 = fields_length1;
	_tmp92_ = _tmp91_[4];
	self->halfmove_clock = atoi (_tmp92_);
	_tmp93_ = fields;
	_tmp93__length1 = fields_length1;
	_tmp94_ = _tmp93_[5];
	self->number = (atoi (_tmp94_) - 1) * 2;
	_tmp95_ = self->current_player;
	_tmp96_ = _tmp95_->color;
	if (_tmp96_ == COLOR_BLACK) {
		gint _tmp97_;
		_tmp97_ = self->number;
		self->number = _tmp97_ + 1;
	}
	_tmp98_ = self->current_player;
	self->check_state = chess_state_get_check_state (self, _tmp98_);
	ranks = (_vala_array_free (ranks, ranks_length1, (GDestroyNotify) g_free), NULL);
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
	return self;
}


ChessState*
chess_state_new (const gchar* fen)
{
	return chess_state_construct (TYPE_CHESS_STATE, fen);
}


ChessState*
chess_state_copy (ChessState* self)
{
	ChessState* result = NULL;
	ChessState* state = NULL;
	ChessState* _tmp0_;
	ChessState* _tmp1_;
	gint _tmp2_;
	ChessState* _tmp3_;
	ChessPlayer* _tmp4_;
	ChessPlayer* _tmp5_;
	ChessPlayer* _tmp6_;
	ChessState* _tmp7_;
	ChessPlayer* _tmp8_;
	ChessPlayer* _tmp9_;
	ChessPlayer* _tmp10_;
	ChessState* _tmp11_;
	ChessPlayer* _tmp12_;
	ChessPlayer* _tmp13_;
	ChessState* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	ChessState* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_;
	ChessState* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
	ChessState* _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	ChessState* _tmp26_;
	gint _tmp27_;
	ChessState* _tmp28_;
	CheckState _tmp29_;
	ChessMove* _tmp30_;
	ChessState* _tmp43_;
	gint64 _tmp44_;
	gint64 _tmp45_;
	ChessState* _tmp46_;
	gint64 _tmp47_;
	gint64 _tmp48_;
	ChessState* _tmp49_;
	gint _tmp50_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = chess_state_new_empty ();
	state = _tmp0_;
	_tmp1_ = state;
	_tmp2_ = self->number;
	_tmp1_->number = _tmp2_;
	_tmp3_ = state;
	_tmp4_ = self->players[COLOR_WHITE];
	_tmp5_ = _g_object_ref0 (_tmp4_);
	_g_object_unref0 (_tmp3_->players[COLOR_WHITE]);
	_tmp3_->players[COLOR_WHITE] = _tmp5_;
	_tmp6_ = _tmp3_->players[COLOR_WHITE];
	_tmp7_ = state;
	_tmp8_ = self->players[COLOR_BLACK];
	_tmp9_ = _g_object_ref0 (_tmp8_);
	_g_object_unref0 (_tmp7_->players[COLOR_BLACK]);
	_tmp7_->players[COLOR_BLACK] = _tmp9_;
	_tmp10_ = _tmp7_->players[COLOR_BLACK];
	_tmp11_ = state;
	_tmp12_ = self->current_player;
	_tmp13_ = _g_object_ref0 (_tmp12_);
	_g_object_unref0 (_tmp11_->current_player);
	_tmp11_->current_player = _tmp13_;
	_tmp14_ = state;
	_tmp15_ = self->can_castle_kingside[COLOR_WHITE];
	_tmp14_->can_castle_kingside[COLOR_WHITE] = _tmp15_;
	_tmp16_ = _tmp14_->can_castle_kingside[COLOR_WHITE];
	_tmp17_ = state;
	_tmp18_ = self->can_castle_queenside[COLOR_WHITE];
	_tmp17_->can_castle_queenside[COLOR_WHITE] = _tmp18_;
	_tmp19_ = _tmp17_->can_castle_queenside[COLOR_WHITE];
	_tmp20_ = state;
	_tmp21_ = self->can_castle_kingside[COLOR_BLACK];
	_tmp20_->can_castle_kingside[COLOR_BLACK] = _tmp21_;
	_tmp22_ = _tmp20_->can_castle_kingside[COLOR_BLACK];
	_tmp23_ = state;
	_tmp24_ = self->can_castle_queenside[COLOR_BLACK];
	_tmp23_->can_castle_queenside[COLOR_BLACK] = _tmp24_;
	_tmp25_ = _tmp23_->can_castle_queenside[COLOR_BLACK];
	_tmp26_ = state;
	_tmp27_ = self->en_passant_index;
	_tmp26_->en_passant_index = _tmp27_;
	_tmp28_ = state;
	_tmp29_ = self->check_state;
	_tmp28_->check_state = _tmp29_;
	_tmp30_ = self->last_move;
	if (_tmp30_ != NULL) {
		ChessState* _tmp31_;
		ChessMove* _tmp32_;
		ChessMove* _tmp33_;
		_tmp31_ = state;
		_tmp32_ = self->last_move;
		_tmp33_ = chess_move_copy (_tmp32_);
		_g_object_unref0 (_tmp31_->last_move);
		_tmp31_->last_move = _tmp33_;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp34_ = FALSE;
			_tmp34_ = TRUE;
			while (TRUE) {
				gint _tmp36_;
				ChessState* _tmp37_;
				gint _tmp38_;
				gint _tmp39_;
				ChessPiece* _tmp40_;
				ChessPiece* _tmp41_;
				ChessPiece* _tmp42_;
				if (!_tmp34_) {
					gint _tmp35_;
					_tmp35_ = i;
					i = _tmp35_ + 1;
				}
				_tmp34_ = FALSE;
				_tmp36_ = i;
				if (!(_tmp36_ < 64)) {
					break;
				}
				_tmp37_ = state;
				_tmp38_ = i;
				_tmp39_ = i;
				_tmp40_ = self->board[_tmp39_];
				_tmp41_ = _g_object_ref0 (_tmp40_);
				_g_object_unref0 (_tmp37_->board[_tmp38_]);
				_tmp37_->board[_tmp38_] = _tmp41_;
				_tmp42_ = _tmp37_->board[_tmp38_];
			}
		}
	}
	_tmp43_ = state;
	_tmp44_ = self->priv->piece_masks[COLOR_WHITE];
	_tmp43_->priv->piece_masks[COLOR_WHITE] = _tmp44_;
	_tmp45_ = _tmp43_->priv->piece_masks[COLOR_WHITE];
	_tmp46_ = state;
	_tmp47_ = self->priv->piece_masks[COLOR_BLACK];
	_tmp46_->priv->piece_masks[COLOR_BLACK] = _tmp47_;
	_tmp48_ = _tmp46_->priv->piece_masks[COLOR_BLACK];
	_tmp49_ = state;
	_tmp50_ = self->halfmove_clock;
	_tmp49_->halfmove_clock = _tmp50_;
	result = state;
	return result;
}


gboolean
chess_state_equals (ChessState* self,
                    ChessState* state)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gint64 _tmp7_;
	gint64 _tmp8_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (state != NULL, FALSE);
	_tmp7_ = self->priv->piece_masks[COLOR_WHITE];
	_tmp8_ = state->priv->piece_masks[COLOR_WHITE];
	if (_tmp7_ != _tmp8_) {
		_tmp6_ = TRUE;
	} else {
		gint64 _tmp9_;
		gint64 _tmp10_;
		_tmp9_ = self->priv->piece_masks[COLOR_BLACK];
		_tmp10_ = state->priv->piece_masks[COLOR_BLACK];
		_tmp6_ = _tmp9_ != _tmp10_;
	}
	if (_tmp6_) {
		_tmp5_ = TRUE;
	} else {
		ChessPlayer* _tmp11_;
		Color _tmp12_;
		ChessPlayer* _tmp13_;
		Color _tmp14_;
		_tmp11_ = self->current_player;
		_tmp12_ = _tmp11_->color;
		_tmp13_ = state->current_player;
		_tmp14_ = _tmp13_->color;
		_tmp5_ = _tmp12_ != _tmp14_;
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		gboolean _tmp15_;
		gboolean _tmp16_;
		_tmp15_ = self->can_castle_kingside[COLOR_WHITE];
		_tmp16_ = state->can_castle_kingside[COLOR_WHITE];
		_tmp4_ = _tmp15_ != _tmp16_;
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		gboolean _tmp17_;
		gboolean _tmp18_;
		_tmp17_ = self->can_castle_queenside[COLOR_WHITE];
		_tmp18_ = state->can_castle_queenside[COLOR_WHITE];
		_tmp3_ = _tmp17_ != _tmp18_;
	}
	if (_tmp3_) {
		_tmp2_ = TRUE;
	} else {
		gboolean _tmp19_;
		gboolean _tmp20_;
		_tmp19_ = self->can_castle_kingside[COLOR_BLACK];
		_tmp20_ = state->can_castle_kingside[COLOR_BLACK];
		_tmp2_ = _tmp19_ != _tmp20_;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		gboolean _tmp21_;
		gboolean _tmp22_;
		_tmp21_ = self->can_castle_queenside[COLOR_BLACK];
		_tmp22_ = state->can_castle_queenside[COLOR_BLACK];
		_tmp1_ = _tmp21_ != _tmp22_;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp23_;
		gint _tmp24_;
		_tmp23_ = self->en_passant_index;
		_tmp24_ = state->en_passant_index;
		_tmp0_ = _tmp23_ != _tmp24_;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp25_ = FALSE;
			_tmp25_ = TRUE;
			while (TRUE) {
				gint _tmp27_;
				gboolean _tmp28_ = FALSE;
				gint _tmp29_;
				ChessPiece* _tmp30_;
				if (!_tmp25_) {
					gint _tmp26_;
					_tmp26_ = i;
					i = _tmp26_ + 1;
				}
				_tmp25_ = FALSE;
				_tmp27_ = i;
				if (!(_tmp27_ < 64)) {
					break;
				}
				_tmp29_ = i;
				_tmp30_ = self->board[_tmp29_];
				if (_tmp30_ != NULL) {
					gint _tmp31_;
					ChessPiece* _tmp32_;
					PieceType _tmp33_;
					gint _tmp34_;
					ChessPiece* _tmp35_;
					PieceType _tmp36_;
					_tmp31_ = i;
					_tmp32_ = self->board[_tmp31_];
					_tmp33_ = _tmp32_->type;
					_tmp34_ = i;
					_tmp35_ = state->board[_tmp34_];
					_tmp36_ = _tmp35_->type;
					_tmp28_ = _tmp33_ != _tmp36_;
				} else {
					_tmp28_ = FALSE;
				}
				if (_tmp28_) {
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}


gchar*
chess_state_get_fen (ChessState* self)
{
	gchar* result = NULL;
	GString* value = NULL;
	GString* _tmp0_;
	GString* _tmp25_;
	ChessPlayer* _tmp26_;
	Color _tmp27_;
	GString* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp33_;
	gboolean _tmp35_;
	gboolean _tmp37_;
	gboolean _tmp39_;
	gboolean _tmp40_;
	gboolean _tmp41_;
	gboolean _tmp42_;
	GString* _tmp44_;
	gint _tmp45_;
	GString* _tmp50_;
	GString* _tmp51_;
	gint _tmp52_;
	GString* _tmp53_;
	ChessPlayer* _tmp54_;
	Color _tmp55_;
	GString* _tmp60_;
	const gchar* _tmp61_;
	gchar* _tmp62_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_string_new ("");
	value = _tmp0_;
	{
		gint rank = 0;
		rank = 7;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				gint skip_count = 0;
				gint _tmp20_;
				gint _tmp23_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = rank;
					rank = _tmp2_ - 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = rank;
				if (!(_tmp3_ >= 0)) {
					break;
				}
				skip_count = 0;
				{
					gint file = 0;
					file = 0;
					{
						gboolean _tmp4_ = FALSE;
						_tmp4_ = TRUE;
						while (TRUE) {
							gint _tmp6_;
							ChessPiece* p = NULL;
							gint _tmp7_;
							gint _tmp8_;
							ChessPiece* _tmp9_;
							ChessPiece* _tmp10_;
							ChessPiece* _tmp11_;
							if (!_tmp4_) {
								gint _tmp5_;
								_tmp5_ = file;
								file = _tmp5_ + 1;
							}
							_tmp4_ = FALSE;
							_tmp6_ = file;
							if (!(_tmp6_ < 8)) {
								break;
							}
							_tmp7_ = rank;
							_tmp8_ = file;
							_tmp9_ = self->board[chess_state_get_index (self, _tmp7_, _tmp8_)];
							_tmp10_ = _g_object_ref0 (_tmp9_);
							p = _tmp10_;
							_tmp11_ = p;
							if (_tmp11_ == NULL) {
								gint _tmp12_;
								_tmp12_ = skip_count;
								skip_count = _tmp12_ + 1;
							} else {
								gint _tmp13_;
								GString* _tmp16_;
								ChessPiece* _tmp17_;
								gunichar _tmp18_;
								gunichar _tmp19_;
								_tmp13_ = skip_count;
								if (_tmp13_ > 0) {
									GString* _tmp14_;
									gint _tmp15_;
									_tmp14_ = value;
									_tmp15_ = skip_count;
									g_string_append_printf (_tmp14_, "%d", _tmp15_);
									skip_count = 0;
								}
								_tmp16_ = value;
								_tmp17_ = p;
								_tmp18_ = chess_piece_get_symbol (_tmp17_);
								_tmp19_ = _tmp18_;
								g_string_append_printf (_tmp16_, "%c", (gint) _tmp19_);
							}
							_g_object_unref0 (p);
						}
					}
				}
				_tmp20_ = skip_count;
				if (_tmp20_ > 0) {
					GString* _tmp21_;
					gint _tmp22_;
					_tmp21_ = value;
					_tmp22_ = skip_count;
					g_string_append_printf (_tmp21_, "%d", _tmp22_);
				}
				_tmp23_ = rank;
				if (_tmp23_ != 0) {
					GString* _tmp24_;
					_tmp24_ = value;
					g_string_append_c (_tmp24_, '/');
				}
			}
		}
	}
	_tmp25_ = value;
	g_string_append_c (_tmp25_, ' ');
	_tmp26_ = self->current_player;
	_tmp27_ = _tmp26_->color;
	if (_tmp27_ == COLOR_WHITE) {
		GString* _tmp28_;
		_tmp28_ = value;
		g_string_append_c (_tmp28_, 'w');
	} else {
		GString* _tmp29_;
		_tmp29_ = value;
		g_string_append_c (_tmp29_, 'b');
	}
	_tmp30_ = value;
	g_string_append_c (_tmp30_, ' ');
	_tmp31_ = self->can_castle_kingside[COLOR_WHITE];
	if (_tmp31_) {
		GString* _tmp32_;
		_tmp32_ = value;
		g_string_append_c (_tmp32_, 'K');
	}
	_tmp33_ = self->can_castle_queenside[COLOR_WHITE];
	if (_tmp33_) {
		GString* _tmp34_;
		_tmp34_ = value;
		g_string_append_c (_tmp34_, 'Q');
	}
	_tmp35_ = self->can_castle_kingside[COLOR_BLACK];
	if (_tmp35_) {
		GString* _tmp36_;
		_tmp36_ = value;
		g_string_append_c (_tmp36_, 'k');
	}
	_tmp37_ = self->can_castle_queenside[COLOR_BLACK];
	if (_tmp37_) {
		GString* _tmp38_;
		_tmp38_ = value;
		g_string_append_c (_tmp38_, 'q');
	}
	_tmp39_ = self->can_castle_kingside[COLOR_WHITE];
	_tmp40_ = self->can_castle_queenside[COLOR_WHITE];
	_tmp41_ = self->can_castle_kingside[COLOR_BLACK];
	_tmp42_ = self->can_castle_queenside[COLOR_BLACK];
	if (!(((_tmp39_ | _tmp40_) | _tmp41_) | _tmp42_)) {
		GString* _tmp43_;
		_tmp43_ = value;
		g_string_append_c (_tmp43_, '-');
	}
	_tmp44_ = value;
	g_string_append_c (_tmp44_, ' ');
	_tmp45_ = self->en_passant_index;
	if (_tmp45_ >= 0) {
		GString* _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
		_tmp46_ = value;
		_tmp47_ = self->en_passant_index;
		_tmp48_ = self->en_passant_index;
		g_string_append_printf (_tmp46_, "%c%d", 'a' + chess_state_get_file (self, _tmp47_), chess_state_get_rank (self, _tmp48_) + 1);
	} else {
		GString* _tmp49_;
		_tmp49_ = value;
		g_string_append_c (_tmp49_, '-');
	}
	_tmp50_ = value;
	g_string_append_c (_tmp50_, ' ');
	_tmp51_ = value;
	_tmp52_ = self->halfmove_clock;
	g_string_append_printf (_tmp51_, "%d", _tmp52_);
	_tmp53_ = value;
	g_string_append_c (_tmp53_, ' ');
	_tmp54_ = self->current_player;
	_tmp55_ = _tmp54_->color;
	if (_tmp55_ == COLOR_WHITE) {
		GString* _tmp56_;
		gint _tmp57_;
		_tmp56_ = value;
		_tmp57_ = self->number;
		g_string_append_printf (_tmp56_, "%d", _tmp57_ / 2);
	} else {
		GString* _tmp58_;
		gint _tmp59_;
		_tmp58_ = value;
		_tmp59_ = self->number;
		g_string_append_printf (_tmp58_, "%d", (_tmp59_ / 2) + 1);
	}
	_tmp60_ = value;
	_tmp61_ = _tmp60_->str;
	_tmp62_ = g_strdup (_tmp61_);
	result = _tmp62_;
	_g_string_free0 (value);
	return result;
}


gint
chess_state_get_index (ChessState* self,
                       gint rank,
                       gint file)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = (rank * 8) + file;
	return result;
}


gint
chess_state_get_rank (ChessState* self,
                      gint index)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = index / 8;
	return result;
}


gint
chess_state_get_file (ChessState* self,
                      gint index)
{
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	result = index % 8;
	return result;
}


gboolean
chess_state_move (ChessState* self,
                  const gchar* move,
                  gboolean apply)
{
	gboolean result = FALSE;
	gint r0 = 0;
	gint f0 = 0;
	gint r1 = 0;
	gint f1 = 0;
	PieceType promotion_type = 0;
	ChessPlayer* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	PieceType _tmp5_ = 0;
	gboolean _tmp6_;
	ChessPlayer* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	PieceType _tmp12_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (move != NULL, FALSE);
	_tmp0_ = self->current_player;
	_tmp6_ = chess_state_decode_move (self, _tmp0_, move, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
	r0 = _tmp1_;
	f0 = _tmp2_;
	r1 = _tmp3_;
	f1 = _tmp4_;
	promotion_type = _tmp5_;
	if (!_tmp6_) {
		result = FALSE;
		return result;
	}
	_tmp7_ = self->current_player;
	_tmp8_ = r0;
	_tmp9_ = f0;
	_tmp10_ = r1;
	_tmp11_ = f1;
	_tmp12_ = promotion_type;
	if (!chess_state_move_with_coords (self, _tmp7_, _tmp8_, _tmp9_, _tmp10_, _tmp11_, _tmp12_, apply, TRUE)) {
		result = FALSE;
		return result;
	}
	result = TRUE;
	return result;
}


gboolean
chess_state_move_with_coords (ChessState* self,
                              ChessPlayer* player,
                              gint r0,
                              gint f0,
                              gint r1,
                              gint f1,
                              PieceType promotion_type,
                              gboolean apply,
                              gboolean test_check)
{
	gboolean result = FALSE;
	gint start = 0;
	gint end = 0;
	Color color = 0;
	Color _tmp0_;
	Color _tmp1_ = 0;
	Color _tmp2_;
	Color opponent_color = 0;
	ChessPiece* piece = NULL;
	gint _tmp3_;
	ChessPiece* _tmp4_;
	ChessPiece* _tmp5_;
	gboolean _tmp6_ = FALSE;
	ChessPiece* _tmp7_;
	gint64 end_mask = 0LL;
	gint _tmp10_;
	gint64 _tmp11_;
	gint64 move_mask = 0LL;
	Color _tmp12_;
	ChessPiece* _tmp13_;
	PieceType _tmp14_;
	gint _tmp15_;
	gint64 _tmp16_;
	gint64 _tmp17_;
	gint64 _tmp18_;
	gint64 over_mask = 0LL;
	gint _tmp19_;
	gint _tmp20_;
	gint64 _tmp21_;
	gint64 _tmp22_;
	gint64 _tmp23_;
	gint64 _tmp24_;
	ChessPiece* victim = NULL;
	gint _tmp25_;
	ChessPiece* _tmp26_;
	ChessPiece* _tmp27_;
	gint victim_index = 0;
	gint _tmp28_;
	gboolean _tmp29_ = FALSE;
	ChessPiece* _tmp30_;
	gint rook_start = 0;
	gint rook_end = 0;
	gboolean is_promotion = FALSE;
	gboolean ambiguous_rank = FALSE;
	gboolean ambiguous_file = FALSE;
	ChessPiece* _tmp33_;
	PieceType _tmp34_;
	gboolean _tmp74_ = FALSE;
	gint64 old_white_mask = 0LL;
	gint64 _tmp98_;
	gint64 old_black_mask = 0LL;
	gint64 _tmp99_;
	gboolean old_white_can_castle_kingside = FALSE;
	gboolean _tmp100_;
	gboolean old_white_can_castle_queenside = FALSE;
	gboolean _tmp101_;
	gboolean old_black_can_castle_kingside = FALSE;
	gboolean _tmp102_;
	gboolean old_black_can_castle_queenside = FALSE;
	gboolean _tmp103_;
	gint old_en_passant_index = 0;
	gint _tmp104_;
	gint old_halfmove_clock = 0;
	gint _tmp105_;
	gint _tmp106_;
	ChessPiece* _tmp107_;
	gint _tmp108_;
	gint64 _tmp109_;
	gint64 _tmp110_;
	gint _tmp111_;
	gint64 _tmp112_;
	gint64 _tmp113_;
	ChessPiece* _tmp114_;
	gboolean _tmp123_;
	Color _tmp131_;
	gint64 _tmp132_;
	gint64 _tmp133_;
	Color _tmp134_;
	gint _tmp135_;
	gint64 _tmp136_;
	gint64 _tmp137_;
	gint _tmp138_;
	ChessPiece* _tmp156_;
	PieceType _tmp157_;
	gboolean _tmp182_ = FALSE;
	ChessPiece* _tmp183_;
	PieceType _tmp184_;
	gboolean _tmp186_ = FALSE;
	ChessPiece* _tmp187_;
	PieceType _tmp188_;
	gboolean _result_ = FALSE;
	gboolean _tmp191_ = FALSE;
	gboolean _tmp192_ = FALSE;
	ChessPlayer* _tmp229_ = NULL;
	Color _tmp230_;
	ChessPlayer* _tmp233_;
	ChessPlayer* _tmp234_;
	ChessMove* _tmp235_;
	ChessMove* _tmp236_;
	gint _tmp237_;
	ChessMove* _tmp238_;
	ChessPiece* _tmp239_;
	ChessPiece* _tmp240_;
	gboolean _tmp241_;
	ChessMove* _tmp246_;
	ChessPiece* _tmp247_;
	ChessPiece* _tmp248_;
	gint _tmp249_;
	ChessMove* _tmp254_;
	ChessMove* _tmp255_;
	ChessMove* _tmp256_;
	ChessMove* _tmp257_;
	ChessMove* _tmp258_;
	gboolean _tmp259_;
	ChessMove* _tmp260_;
	gboolean _tmp261_;
	ChessMove* _tmp262_;
	CheckState _tmp263_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (player != NULL, FALSE);
	start = chess_state_get_index (self, r0, f0);
	end = chess_state_get_index (self, r1, f1);
	_tmp0_ = player->color;
	color = _tmp0_;
	_tmp2_ = color;
	if (_tmp2_ == COLOR_WHITE) {
		_tmp1_ = COLOR_BLACK;
	} else {
		_tmp1_ = COLOR_WHITE;
	}
	opponent_color = _tmp1_;
	_tmp3_ = start;
	_tmp4_ = self->board[_tmp3_];
	_tmp5_ = _g_object_ref0 (_tmp4_);
	piece = _tmp5_;
	_tmp7_ = piece;
	if (_tmp7_ == NULL) {
		_tmp6_ = TRUE;
	} else {
		ChessPiece* _tmp8_;
		ChessPlayer* _tmp9_;
		_tmp8_ = piece;
		_tmp9_ = _tmp8_->player;
		_tmp6_ = _tmp9_ != player;
	}
	if (_tmp6_) {
		result = FALSE;
		_g_object_unref0 (piece);
		return result;
	}
	_tmp10_ = end;
	_tmp11_ = BIT_BOARD_set_location_masks[_tmp10_];
	end_mask = _tmp11_;
	_tmp12_ = color;
	_tmp13_ = piece;
	_tmp14_ = _tmp13_->type;
	_tmp15_ = start;
	_tmp16_ = BIT_BOARD_move_masks[(((_tmp12_ * 64) * 6) + (_tmp14_ * 64)) + _tmp15_];
	move_mask = _tmp16_;
	_tmp17_ = end_mask;
	_tmp18_ = move_mask;
	if ((_tmp17_ & _tmp18_) == ((gint64) 0)) {
		result = FALSE;
		_g_object_unref0 (piece);
		return result;
	}
	_tmp19_ = start;
	_tmp20_ = end;
	_tmp21_ = BIT_BOARD_over_masks[(_tmp19_ * 64) + _tmp20_];
	over_mask = _tmp21_;
	_tmp22_ = over_mask;
	_tmp23_ = self->priv->piece_masks[COLOR_WHITE];
	_tmp24_ = self->priv->piece_masks[COLOR_BLACK];
	if ((_tmp22_ & (_tmp23_ | _tmp24_)) != ((gint64) 0)) {
		result = FALSE;
		_g_object_unref0 (piece);
		return result;
	}
	_tmp25_ = end;
	_tmp26_ = self->board[_tmp25_];
	_tmp27_ = _g_object_ref0 (_tmp26_);
	victim = _tmp27_;
	_tmp28_ = end;
	victim_index = _tmp28_;
	_tmp30_ = victim;
	if (_tmp30_ != NULL) {
		ChessPiece* _tmp31_;
		ChessPlayer* _tmp32_;
		_tmp31_ = victim;
		_tmp32_ = _tmp31_->player;
		_tmp29_ = _tmp32_ == player;
	} else {
		_tmp29_ = FALSE;
	}
	if (_tmp29_) {
		result = FALSE;
		_g_object_unref0 (victim);
		_g_object_unref0 (piece);
		return result;
	}
	rook_start = -1;
	rook_end = -1;
	is_promotion = FALSE;
	ambiguous_rank = FALSE;
	ambiguous_file = FALSE;
	_tmp33_ = piece;
	_tmp34_ = _tmp33_->type;
	switch (_tmp34_) {
		case PIECE_TYPE_PAWN:
		{
			gboolean _tmp35_ = FALSE;
			ChessPiece* _tmp36_;
			gboolean _tmp45_ = FALSE;
			ChessPiece* _tmp46_;
			_tmp36_ = victim;
			if (_tmp36_ == NULL) {
				gint _tmp37_;
				gint _tmp38_;
				_tmp37_ = end;
				_tmp38_ = self->en_passant_index;
				_tmp35_ = _tmp37_ == _tmp38_;
			} else {
				_tmp35_ = FALSE;
			}
			if (_tmp35_) {
				gint _tmp39_ = 0;
				gint _tmp40_;
				ChessPiece* _tmp41_;
				ChessPiece* _tmp42_;
				if (r1 == 2) {
					_tmp39_ = 3;
				} else {
					_tmp39_ = 4;
				}
				victim_index = chess_state_get_index (self, _tmp39_, f1);
				_tmp40_ = victim_index;
				_tmp41_ = self->board[_tmp40_];
				_tmp42_ = _g_object_ref0 (_tmp41_);
				_g_object_unref0 (victim);
				victim = _tmp42_;
			}
			if (f0 != f1) {
				ChessPiece* _tmp43_;
				_tmp43_ = victim;
				if (_tmp43_ == NULL) {
					result = FALSE;
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
			} else {
				ChessPiece* _tmp44_;
				_tmp44_ = victim;
				if (_tmp44_ != NULL) {
					result = FALSE;
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
			}
			if (r1 == 0) {
				_tmp45_ = TRUE;
			} else {
				_tmp45_ = r1 == 7;
			}
			is_promotion = _tmp45_;
			_tmp46_ = victim;
			if (_tmp46_ != NULL) {
				ambiguous_file = TRUE;
			}
			break;
		}
		case PIECE_TYPE_KING:
		{
			if (abs (f0 - f1) > 1) {
				gint _tmp47_ = 0;
				gint _tmp48_ = 0;
				ChessPiece* rook = NULL;
				gint _tmp53_;
				ChessPiece* _tmp54_;
				ChessPiece* _tmp55_;
				gboolean _tmp56_ = FALSE;
				gboolean _tmp57_ = FALSE;
				ChessPiece* _tmp58_;
				gint64 rook_over_mask = 0LL;
				gint _tmp65_;
				gint _tmp66_;
				gint64 _tmp67_;
				gint64 _tmp68_;
				gint64 _tmp69_;
				gint64 _tmp70_;
				CheckState _tmp71_;
				gint _tmp72_;
				gint _tmp73_;
				if (f1 > f0) {
					_tmp47_ = 7;
				} else {
					_tmp47_ = 0;
				}
				rook_start = chess_state_get_index (self, r0, _tmp47_);
				if (f1 > f0) {
					_tmp48_ = f1 - 1;
				} else {
					_tmp48_ = f1 + 1;
				}
				rook_end = chess_state_get_index (self, r0, _tmp48_);
				if (f1 > f0) {
					Color _tmp49_;
					gboolean _tmp50_;
					_tmp49_ = color;
					_tmp50_ = self->can_castle_kingside[_tmp49_];
					if (!_tmp50_) {
						result = FALSE;
						_g_object_unref0 (victim);
						_g_object_unref0 (piece);
						return result;
					}
				} else {
					Color _tmp51_;
					gboolean _tmp52_;
					_tmp51_ = color;
					_tmp52_ = self->can_castle_queenside[_tmp51_];
					if (!_tmp52_) {
						result = FALSE;
						_g_object_unref0 (victim);
						_g_object_unref0 (piece);
						return result;
					}
				}
				_tmp53_ = rook_start;
				_tmp54_ = self->board[_tmp53_];
				_tmp55_ = _g_object_ref0 (_tmp54_);
				rook = _tmp55_;
				_tmp58_ = rook;
				if (_tmp58_ == NULL) {
					_tmp57_ = TRUE;
				} else {
					ChessPiece* _tmp59_;
					PieceType _tmp60_;
					_tmp59_ = rook;
					_tmp60_ = _tmp59_->type;
					_tmp57_ = _tmp60_ != PIECE_TYPE_ROOK;
				}
				if (_tmp57_) {
					_tmp56_ = TRUE;
				} else {
					ChessPiece* _tmp61_;
					Color _tmp62_;
					Color _tmp63_;
					Color _tmp64_;
					_tmp61_ = rook;
					_tmp62_ = chess_piece_get_color (_tmp61_);
					_tmp63_ = _tmp62_;
					_tmp64_ = color;
					_tmp56_ = _tmp63_ != _tmp64_;
				}
				if (_tmp56_) {
					result = FALSE;
					_g_object_unref0 (rook);
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
				_tmp65_ = rook_start;
				_tmp66_ = rook_end;
				_tmp67_ = BIT_BOARD_over_masks[(_tmp65_ * 64) + _tmp66_];
				rook_over_mask = _tmp67_;
				_tmp68_ = rook_over_mask;
				_tmp69_ = self->priv->piece_masks[COLOR_WHITE];
				_tmp70_ = self->priv->piece_masks[COLOR_BLACK];
				if ((_tmp68_ & (_tmp69_ | _tmp70_)) != ((gint64) 0)) {
					result = FALSE;
					_g_object_unref0 (rook);
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
				_tmp71_ = self->check_state;
				if (_tmp71_ == CHECK_STATE_CHECK) {
					result = FALSE;
					_g_object_unref0 (rook);
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
				_tmp72_ = rook_end;
				_tmp73_ = rook_end;
				if (!chess_state_move_with_coords (self, player, r0, f0, chess_state_get_rank (self, _tmp72_), chess_state_get_file (self, _tmp73_), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
					result = FALSE;
					_g_object_unref0 (rook);
					_g_object_unref0 (victim);
					_g_object_unref0 (piece);
					return result;
				}
				_g_object_unref0 (rook);
			}
			break;
		}
		default:
		{
			break;
		}
	}
	if (!apply) {
		_tmp74_ = !test_check;
	} else {
		_tmp74_ = FALSE;
	}
	if (_tmp74_) {
		result = TRUE;
		_g_object_unref0 (victim);
		_g_object_unref0 (piece);
		return result;
	}
	if (apply) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp75_ = FALSE;
				_tmp75_ = TRUE;
				while (TRUE) {
					gint _tmp77_;
					gint _tmp78_;
					gint _tmp79_;
					ChessPiece* p = NULL;
					gint _tmp80_;
					ChessPiece* _tmp81_;
					ChessPiece* _tmp82_;
					gboolean _tmp83_ = FALSE;
					gboolean _tmp84_ = FALSE;
					ChessPiece* _tmp85_;
					gint r = 0;
					gint _tmp92_;
					gint f = 0;
					gint _tmp93_;
					gint _tmp94_;
					gint _tmp95_;
					if (!_tmp75_) {
						gint _tmp76_;
						_tmp76_ = i;
						i = _tmp76_ + 1;
					}
					_tmp75_ = FALSE;
					_tmp77_ = i;
					if (!(_tmp77_ < 64)) {
						break;
					}
					_tmp78_ = i;
					_tmp79_ = start;
					if (_tmp78_ == _tmp79_) {
						continue;
					}
					_tmp80_ = i;
					_tmp81_ = self->board[_tmp80_];
					_tmp82_ = _g_object_ref0 (_tmp81_);
					p = _tmp82_;
					_tmp85_ = p;
					if (_tmp85_ == NULL) {
						_tmp84_ = TRUE;
					} else {
						ChessPiece* _tmp86_;
						ChessPlayer* _tmp87_;
						_tmp86_ = p;
						_tmp87_ = _tmp86_->player;
						_tmp84_ = _tmp87_ != player;
					}
					if (_tmp84_) {
						_tmp83_ = TRUE;
					} else {
						ChessPiece* _tmp88_;
						PieceType _tmp89_;
						ChessPiece* _tmp90_;
						PieceType _tmp91_;
						_tmp88_ = p;
						_tmp89_ = _tmp88_->type;
						_tmp90_ = piece;
						_tmp91_ = _tmp90_->type;
						_tmp83_ = _tmp89_ != _tmp91_;
					}
					if (_tmp83_) {
						_g_object_unref0 (p);
						continue;
					}
					_tmp92_ = i;
					r = chess_state_get_rank (self, _tmp92_);
					_tmp93_ = i;
					f = chess_state_get_file (self, _tmp93_);
					_tmp94_ = r;
					_tmp95_ = f;
					if (chess_state_move_with_coords (self, player, _tmp94_, _tmp95_, r1, f1, PIECE_TYPE_QUEEN, FALSE, TRUE)) {
						gint _tmp96_;
						gint _tmp97_;
						_tmp96_ = r;
						if (_tmp96_ != r0) {
							ambiguous_rank = TRUE;
						}
						_tmp97_ = f;
						if (_tmp97_ != f0) {
							ambiguous_file = TRUE;
						}
					}
					_g_object_unref0 (p);
				}
			}
		}
	}
	_tmp98_ = self->priv->piece_masks[COLOR_WHITE];
	old_white_mask = _tmp98_;
	_tmp99_ = self->priv->piece_masks[COLOR_BLACK];
	old_black_mask = _tmp99_;
	_tmp100_ = self->can_castle_kingside[COLOR_WHITE];
	old_white_can_castle_kingside = _tmp100_;
	_tmp101_ = self->can_castle_queenside[COLOR_WHITE];
	old_white_can_castle_queenside = _tmp101_;
	_tmp102_ = self->can_castle_kingside[COLOR_BLACK];
	old_black_can_castle_kingside = _tmp102_;
	_tmp103_ = self->can_castle_queenside[COLOR_BLACK];
	old_black_can_castle_queenside = _tmp103_;
	_tmp104_ = self->en_passant_index;
	old_en_passant_index = _tmp104_;
	_tmp105_ = self->halfmove_clock;
	old_halfmove_clock = _tmp105_;
	_tmp106_ = start;
	_g_object_unref0 (self->board[_tmp106_]);
	self->board[_tmp106_] = NULL;
	_tmp107_ = self->board[_tmp106_];
	_tmp108_ = start;
	_tmp109_ = BIT_BOARD_clear_location_masks[_tmp108_];
	self->priv->piece_masks[COLOR_WHITE] &= _tmp109_;
	_tmp110_ = self->priv->piece_masks[COLOR_WHITE];
	_tmp111_ = start;
	_tmp112_ = BIT_BOARD_clear_location_masks[_tmp111_];
	self->priv->piece_masks[COLOR_BLACK] &= _tmp112_;
	_tmp113_ = self->priv->piece_masks[COLOR_BLACK];
	_tmp114_ = victim;
	if (_tmp114_ != NULL) {
		gint _tmp115_;
		ChessPiece* _tmp116_;
		gint _tmp117_;
		gint64 _tmp118_;
		gint64 _tmp119_;
		gint _tmp120_;
		gint64 _tmp121_;
		gint64 _tmp122_;
		_tmp115_ = victim_index;
		_g_object_unref0 (self->board[_tmp115_]);
		self->board[_tmp115_] = NULL;
		_tmp116_ = self->board[_tmp115_];
		_tmp117_ = victim_index;
		_tmp118_ = BIT_BOARD_clear_location_masks[_tmp117_];
		self->priv->piece_masks[COLOR_WHITE] &= _tmp118_;
		_tmp119_ = self->priv->piece_masks[COLOR_WHITE];
		_tmp120_ = victim_index;
		_tmp121_ = BIT_BOARD_clear_location_masks[_tmp120_];
		self->priv->piece_masks[COLOR_BLACK] &= _tmp121_;
		_tmp122_ = self->priv->piece_masks[COLOR_BLACK];
	}
	_tmp123_ = is_promotion;
	if (_tmp123_) {
		gint _tmp124_;
		ChessPiece* _tmp125_;
		ChessPiece* _tmp126_;
		_tmp124_ = end;
		_tmp125_ = chess_piece_new (player, promotion_type);
		_g_object_unref0 (self->board[_tmp124_]);
		self->board[_tmp124_] = _tmp125_;
		_tmp126_ = self->board[_tmp124_];
	} else {
		gint _tmp127_;
		ChessPiece* _tmp128_;
		ChessPiece* _tmp129_;
		ChessPiece* _tmp130_;
		_tmp127_ = end;
		_tmp128_ = piece;
		_tmp129_ = _g_object_ref0 (_tmp128_);
		_g_object_unref0 (self->board[_tmp127_]);
		self->board[_tmp127_] = _tmp129_;
		_tmp130_ = self->board[_tmp127_];
	}
	_tmp131_ = color;
	_tmp132_ = end_mask;
	self->priv->piece_masks[_tmp131_] |= _tmp132_;
	_tmp133_ = self->priv->piece_masks[_tmp131_];
	_tmp134_ = opponent_color;
	_tmp135_ = end;
	_tmp136_ = BIT_BOARD_clear_location_masks[_tmp135_];
	self->priv->piece_masks[_tmp134_] &= _tmp136_;
	_tmp137_ = self->priv->piece_masks[_tmp134_];
	_tmp138_ = rook_start;
	if (_tmp138_ >= 0) {
		ChessPiece* rook = NULL;
		gint _tmp139_;
		ChessPiece* _tmp140_;
		ChessPiece* _tmp141_;
		gint _tmp142_;
		ChessPiece* _tmp143_;
		Color _tmp144_;
		gint _tmp145_;
		gint64 _tmp146_;
		gint64 _tmp147_;
		gint _tmp148_;
		ChessPiece* _tmp149_;
		ChessPiece* _tmp150_;
		ChessPiece* _tmp151_;
		Color _tmp152_;
		gint _tmp153_;
		gint64 _tmp154_;
		gint64 _tmp155_;
		_tmp139_ = rook_start;
		_tmp140_ = self->board[_tmp139_];
		_tmp141_ = _g_object_ref0 (_tmp140_);
		rook = _tmp141_;
		_tmp142_ = rook_start;
		_g_object_unref0 (self->board[_tmp142_]);
		self->board[_tmp142_] = NULL;
		_tmp143_ = self->board[_tmp142_];
		_tmp144_ = color;
		_tmp145_ = rook_start;
		_tmp146_ = BIT_BOARD_clear_location_masks[_tmp145_];
		self->priv->piece_masks[_tmp144_] &= _tmp146_;
		_tmp147_ = self->priv->piece_masks[_tmp144_];
		_tmp148_ = rook_end;
		_tmp149_ = rook;
		_tmp150_ = _g_object_ref0 (_tmp149_);
		_g_object_unref0 (self->board[_tmp148_]);
		self->board[_tmp148_] = _tmp150_;
		_tmp151_ = self->board[_tmp148_];
		_tmp152_ = color;
		_tmp153_ = rook_end;
		_tmp154_ = BIT_BOARD_set_location_masks[_tmp153_];
		self->priv->piece_masks[_tmp152_] |= _tmp154_;
		_tmp155_ = self->priv->piece_masks[_tmp152_];
		_g_object_unref0 (rook);
	}
	_tmp156_ = piece;
	_tmp157_ = _tmp156_->type;
	if (_tmp157_ == PIECE_TYPE_KING) {
		Color _tmp158_;
		gboolean _tmp159_;
		Color _tmp160_;
		gboolean _tmp161_;
		_tmp158_ = color;
		self->can_castle_kingside[_tmp158_] = FALSE;
		_tmp159_ = self->can_castle_kingside[_tmp158_];
		_tmp160_ = color;
		self->can_castle_queenside[_tmp160_] = FALSE;
		_tmp161_ = self->can_castle_queenside[_tmp160_];
	} else {
		ChessPiece* _tmp162_;
		PieceType _tmp163_;
		_tmp162_ = piece;
		_tmp163_ = _tmp162_->type;
		if (_tmp163_ == PIECE_TYPE_ROOK) {
			gint _tmp164_ = 0;
			Color _tmp165_;
			gint base_rank = 0;
			gint _tmp166_;
			_tmp165_ = color;
			if (_tmp165_ == COLOR_WHITE) {
				_tmp164_ = 0;
			} else {
				_tmp164_ = 7;
			}
			base_rank = _tmp164_;
			_tmp166_ = base_rank;
			if (r0 == _tmp166_) {
				if (f0 == 0) {
					Color _tmp167_;
					gboolean _tmp168_;
					_tmp167_ = color;
					self->can_castle_queenside[_tmp167_] = FALSE;
					_tmp168_ = self->can_castle_queenside[_tmp167_];
				} else {
					if (f0 == 7) {
						Color _tmp169_;
						gboolean _tmp170_;
						_tmp169_ = color;
						self->can_castle_kingside[_tmp169_] = FALSE;
						_tmp170_ = self->can_castle_kingside[_tmp169_];
					}
				}
			}
		} else {
			gboolean _tmp171_ = FALSE;
			ChessPiece* _tmp172_;
			_tmp172_ = victim;
			if (_tmp172_ != NULL) {
				ChessPiece* _tmp173_;
				PieceType _tmp174_;
				_tmp173_ = victim;
				_tmp174_ = _tmp173_->type;
				_tmp171_ = _tmp174_ == PIECE_TYPE_ROOK;
			} else {
				_tmp171_ = FALSE;
			}
			if (_tmp171_) {
				gint _tmp175_ = 0;
				Color _tmp176_;
				gint base_rank = 0;
				gint _tmp177_;
				_tmp176_ = opponent_color;
				if (_tmp176_ == COLOR_WHITE) {
					_tmp175_ = 0;
				} else {
					_tmp175_ = 7;
				}
				base_rank = _tmp175_;
				_tmp177_ = base_rank;
				if (r1 == _tmp177_) {
					if (f1 == 0) {
						Color _tmp178_;
						gboolean _tmp179_;
						_tmp178_ = opponent_color;
						self->can_castle_queenside[_tmp178_] = FALSE;
						_tmp179_ = self->can_castle_queenside[_tmp178_];
					} else {
						if (f1 == 7) {
							Color _tmp180_;
							gboolean _tmp181_;
							_tmp180_ = opponent_color;
							self->can_castle_kingside[_tmp180_] = FALSE;
							_tmp181_ = self->can_castle_kingside[_tmp180_];
						}
					}
				}
			}
		}
	}
	_tmp183_ = piece;
	_tmp184_ = _tmp183_->type;
	if (_tmp184_ == PIECE_TYPE_PAWN) {
		gint64 _tmp185_;
		_tmp185_ = over_mask;
		_tmp182_ = _tmp185_ != ((gint64) 0);
	} else {
		_tmp182_ = FALSE;
	}
	if (_tmp182_) {
		self->en_passant_index = chess_state_get_index (self, (r0 + r1) / 2, f0);
	} else {
		self->en_passant_index = -1;
	}
	_tmp187_ = piece;
	_tmp188_ = _tmp187_->type;
	if (_tmp188_ == PIECE_TYPE_PAWN) {
		_tmp186_ = TRUE;
	} else {
		ChessPiece* _tmp189_;
		_tmp189_ = victim;
		_tmp186_ = _tmp189_ != NULL;
	}
	if (_tmp186_) {
		self->halfmove_clock = 0;
	} else {
		gint _tmp190_;
		_tmp190_ = self->halfmove_clock;
		self->halfmove_clock = _tmp190_ + 1;
	}
	_result_ = TRUE;
	if (test_check) {
		_tmp191_ = chess_state_is_in_check (self, player);
	} else {
		_tmp191_ = FALSE;
	}
	if (_tmp191_) {
		_result_ = FALSE;
	}
	if (!apply) {
		_tmp192_ = TRUE;
	} else {
		gboolean _tmp193_;
		_tmp193_ = _result_;
		_tmp192_ = !_tmp193_;
	}
	if (_tmp192_) {
		gint _tmp194_;
		ChessPiece* _tmp195_;
		ChessPiece* _tmp196_;
		ChessPiece* _tmp197_;
		gint _tmp198_;
		ChessPiece* _tmp199_;
		ChessPiece* _tmp200_;
		gint _tmp205_;
		gint64 _tmp215_;
		gint64 _tmp216_;
		gint64 _tmp217_;
		gint64 _tmp218_;
		gboolean _tmp219_;
		gboolean _tmp220_;
		gboolean _tmp221_;
		gboolean _tmp222_;
		gboolean _tmp223_;
		gboolean _tmp224_;
		gboolean _tmp225_;
		gboolean _tmp226_;
		gint _tmp227_;
		gint _tmp228_;
		_tmp194_ = start;
		_tmp195_ = piece;
		_tmp196_ = _g_object_ref0 (_tmp195_);
		_g_object_unref0 (self->board[_tmp194_]);
		self->board[_tmp194_] = _tmp196_;
		_tmp197_ = self->board[_tmp194_];
		_tmp198_ = end;
		_g_object_unref0 (self->board[_tmp198_]);
		self->board[_tmp198_] = NULL;
		_tmp199_ = self->board[_tmp198_];
		_tmp200_ = victim;
		if (_tmp200_ != NULL) {
			gint _tmp201_;
			ChessPiece* _tmp202_;
			ChessPiece* _tmp203_;
			ChessPiece* _tmp204_;
			_tmp201_ = victim_index;
			_tmp202_ = victim;
			_tmp203_ = _g_object_ref0 (_tmp202_);
			_g_object_unref0 (self->board[_tmp201_]);
			self->board[_tmp201_] = _tmp203_;
			_tmp204_ = self->board[_tmp201_];
		}
		_tmp205_ = rook_start;
		if (_tmp205_ >= 0) {
			ChessPiece* rook = NULL;
			gint _tmp206_;
			ChessPiece* _tmp207_;
			ChessPiece* _tmp208_;
			gint _tmp209_;
			ChessPiece* _tmp210_;
			ChessPiece* _tmp211_;
			ChessPiece* _tmp212_;
			gint _tmp213_;
			ChessPiece* _tmp214_;
			_tmp206_ = rook_end;
			_tmp207_ = self->board[_tmp206_];
			_tmp208_ = _g_object_ref0 (_tmp207_);
			rook = _tmp208_;
			_tmp209_ = rook_start;
			_tmp210_ = rook;
			_tmp211_ = _g_object_ref0 (_tmp210_);
			_g_object_unref0 (self->board[_tmp209_]);
			self->board[_tmp209_] = _tmp211_;
			_tmp212_ = self->board[_tmp209_];
			_tmp213_ = rook_end;
			_g_object_unref0 (self->board[_tmp213_]);
			self->board[_tmp213_] = NULL;
			_tmp214_ = self->board[_tmp213_];
			_g_object_unref0 (rook);
		}
		_tmp215_ = old_white_mask;
		self->priv->piece_masks[COLOR_WHITE] = _tmp215_;
		_tmp216_ = self->priv->piece_masks[COLOR_WHITE];
		_tmp217_ = old_black_mask;
		self->priv->piece_masks[COLOR_BLACK] = _tmp217_;
		_tmp218_ = self->priv->piece_masks[COLOR_BLACK];
		_tmp219_ = old_white_can_castle_kingside;
		self->can_castle_kingside[COLOR_WHITE] = _tmp219_;
		_tmp220_ = self->can_castle_kingside[COLOR_WHITE];
		_tmp221_ = old_white_can_castle_queenside;
		self->can_castle_queenside[COLOR_WHITE] = _tmp221_;
		_tmp222_ = self->can_castle_queenside[COLOR_WHITE];
		_tmp223_ = old_black_can_castle_kingside;
		self->can_castle_kingside[COLOR_BLACK] = _tmp223_;
		_tmp224_ = self->can_castle_kingside[COLOR_BLACK];
		_tmp225_ = old_black_can_castle_queenside;
		self->can_castle_queenside[COLOR_BLACK] = _tmp225_;
		_tmp226_ = self->can_castle_queenside[COLOR_BLACK];
		_tmp227_ = old_en_passant_index;
		self->en_passant_index = _tmp227_;
		_tmp228_ = old_halfmove_clock;
		self->halfmove_clock = _tmp228_;
		result = _result_;
		_g_object_unref0 (victim);
		_g_object_unref0 (piece);
		return result;
	}
	_tmp230_ = color;
	if (_tmp230_ == COLOR_WHITE) {
		ChessPlayer* _tmp231_;
		_tmp231_ = self->players[COLOR_BLACK];
		_tmp229_ = _tmp231_;
	} else {
		ChessPlayer* _tmp232_;
		_tmp232_ = self->players[COLOR_WHITE];
		_tmp229_ = _tmp232_;
	}
	_tmp233_ = _g_object_ref0 (_tmp229_);
	_g_object_unref0 (self->current_player);
	self->current_player = _tmp233_;
	_tmp234_ = self->current_player;
	self->check_state = chess_state_get_check_state (self, _tmp234_);
	_tmp235_ = chess_move_new ();
	_g_object_unref0 (self->last_move);
	self->last_move = _tmp235_;
	_tmp236_ = self->last_move;
	_tmp237_ = self->number;
	_tmp236_->number = _tmp237_;
	_tmp238_ = self->last_move;
	_tmp239_ = piece;
	_tmp240_ = _g_object_ref0 (_tmp239_);
	_g_object_unref0 (_tmp238_->piece);
	_tmp238_->piece = _tmp240_;
	_tmp241_ = is_promotion;
	if (_tmp241_) {
		ChessMove* _tmp242_;
		gint _tmp243_;
		ChessPiece* _tmp244_;
		ChessPiece* _tmp245_;
		_tmp242_ = self->last_move;
		_tmp243_ = end;
		_tmp244_ = self->board[_tmp243_];
		_tmp245_ = _g_object_ref0 (_tmp244_);
		_g_object_unref0 (_tmp242_->promotion_piece);
		_tmp242_->promotion_piece = _tmp245_;
	}
	_tmp246_ = self->last_move;
	_tmp247_ = victim;
	_tmp248_ = _g_object_ref0 (_tmp247_);
	_g_object_unref0 (_tmp246_->victim);
	_tmp246_->victim = _tmp248_;
	_tmp249_ = rook_end;
	if (_tmp249_ >= 0) {
		ChessMove* _tmp250_;
		gint _tmp251_;
		ChessPiece* _tmp252_;
		ChessPiece* _tmp253_;
		_tmp250_ = self->last_move;
		_tmp251_ = rook_end;
		_tmp252_ = self->board[_tmp251_];
		_tmp253_ = _g_object_ref0 (_tmp252_);
		_g_object_unref0 (_tmp250_->moved_rook);
		_tmp250_->moved_rook = _tmp253_;
	}
	_tmp254_ = self->last_move;
	_tmp254_->r0 = r0;
	_tmp255_ = self->last_move;
	_tmp255_->f0 = f0;
	_tmp256_ = self->last_move;
	_tmp256_->r1 = r1;
	_tmp257_ = self->last_move;
	_tmp257_->f1 = f1;
	_tmp258_ = self->last_move;
	_tmp259_ = ambiguous_rank;
	_tmp258_->ambiguous_rank = _tmp259_;
	_tmp260_ = self->last_move;
	_tmp261_ = ambiguous_file;
	_tmp260_->ambiguous_file = _tmp261_;
	_tmp262_ = self->last_move;
	_tmp263_ = self->check_state;
	_tmp262_->check_state = _tmp263_;
	result = TRUE;
	_g_object_unref0 (victim);
	_g_object_unref0 (piece);
	return result;
}


ChessResult
chess_state_get_result (ChessState* self,
                        ChessRule* rule)
{
	ChessRule _vala_rule = 0;
	ChessResult result = 0;
	CheckState _tmp0_;
	ChessPlayer* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	ChessMove* _tmp6_;
	g_return_val_if_fail (self != NULL, 0);
	_vala_rule = CHESS_RULE_CHECKMATE;
	_tmp0_ = self->check_state;
	if (_tmp0_ == CHECK_STATE_CHECKMATE) {
		ChessPlayer* _tmp1_;
		Color _tmp2_;
		_tmp1_ = self->current_player;
		_tmp2_ = _tmp1_->color;
		if (_tmp2_ == COLOR_WHITE) {
			_vala_rule = CHESS_RULE_CHECKMATE;
			result = CHESS_RESULT_BLACK_WON;
			if (rule) {
				*rule = _vala_rule;
			}
			return result;
		} else {
			_vala_rule = CHESS_RULE_CHECKMATE;
			result = CHESS_RESULT_WHITE_WON;
			if (rule) {
				*rule = _vala_rule;
			}
			return result;
		}
	}
	_tmp3_ = self->current_player;
	if (!chess_state_can_move (self, _tmp3_)) {
		_vala_rule = CHESS_RULE_STALEMATE;
		result = CHESS_RESULT_DRAW;
		if (rule) {
			*rule = _vala_rule;
		}
		return result;
	}
	_tmp6_ = self->last_move;
	if (_tmp6_ != NULL) {
		ChessMove* _tmp7_;
		ChessPiece* _tmp8_;
		_tmp7_ = self->last_move;
		_tmp8_ = _tmp7_->victim;
		_tmp5_ = _tmp8_ != NULL;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		_tmp4_ = !chess_state_have_sufficient_material (self);
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		_vala_rule = CHESS_RULE_INSUFFICIENT_MATERIAL;
		result = CHESS_RESULT_DRAW;
		if (rule) {
			*rule = _vala_rule;
		}
		return result;
	}
	result = CHESS_RESULT_IN_PROGRESS;
	if (rule) {
		*rule = _vala_rule;
	}
	return result;
}


static CheckState
chess_state_get_check_state (ChessState* self,
                             ChessPlayer* player)
{
	CheckState result = 0;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (player != NULL, 0);
	if (chess_state_is_in_check (self, player)) {
		if (chess_state_is_in_checkmate (self, player)) {
			result = CHECK_STATE_CHECKMATE;
			return result;
		} else {
			result = CHECK_STATE_CHECK;
			return result;
		}
	}
	result = CHECK_STATE_NONE;
	return result;
}


gboolean
chess_state_is_in_check (ChessState* self,
                         ChessPlayer* player)
{
	gboolean result = FALSE;
	ChessPlayer* _tmp0_ = NULL;
	Color _tmp1_;
	ChessPlayer* opponent = NULL;
	ChessPlayer* _tmp4_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (player != NULL, FALSE);
	_tmp1_ = player->color;
	if (_tmp1_ == COLOR_WHITE) {
		ChessPlayer* _tmp2_;
		_tmp2_ = self->players[COLOR_BLACK];
		_tmp0_ = _tmp2_;
	} else {
		ChessPlayer* _tmp3_;
		_tmp3_ = self->players[COLOR_WHITE];
		_tmp0_ = _tmp3_;
	}
	_tmp4_ = _g_object_ref0 (_tmp0_);
	opponent = _tmp4_;
	{
		gint king_index = 0;
		king_index = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gint _tmp7_;
				ChessPiece* p = NULL;
				gint _tmp8_;
				ChessPiece* _tmp9_;
				ChessPiece* _tmp10_;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				ChessPiece* _tmp13_;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = king_index;
					king_index = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = king_index;
				if (!(_tmp7_ < 64)) {
					break;
				}
				_tmp8_ = king_index;
				_tmp9_ = self->board[_tmp8_];
				_tmp10_ = _g_object_ref0 (_tmp9_);
				p = _tmp10_;
				_tmp13_ = p;
				if (_tmp13_ != NULL) {
					ChessPiece* _tmp14_;
					ChessPlayer* _tmp15_;
					_tmp14_ = p;
					_tmp15_ = _tmp14_->player;
					_tmp12_ = _tmp15_ == player;
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					ChessPiece* _tmp16_;
					PieceType _tmp17_;
					_tmp16_ = p;
					_tmp17_ = _tmp16_->type;
					_tmp11_ = _tmp17_ == PIECE_TYPE_KING;
				} else {
					_tmp11_ = FALSE;
				}
				if (_tmp11_) {
					{
						gint start = 0;
						start = 0;
						{
							gboolean _tmp18_ = FALSE;
							_tmp18_ = TRUE;
							while (TRUE) {
								gint _tmp20_;
								ChessPlayer* _tmp21_;
								gint _tmp22_;
								gint _tmp23_;
								gint _tmp24_;
								gint _tmp25_;
								if (!_tmp18_) {
									gint _tmp19_;
									_tmp19_ = start;
									start = _tmp19_ + 1;
								}
								_tmp18_ = FALSE;
								_tmp20_ = start;
								if (!(_tmp20_ < 64)) {
									break;
								}
								_tmp21_ = opponent;
								_tmp22_ = start;
								_tmp23_ = start;
								_tmp24_ = king_index;
								_tmp25_ = king_index;
								if (chess_state_move_with_coords (self, _tmp21_, chess_state_get_rank (self, _tmp22_), chess_state_get_file (self, _tmp23_), chess_state_get_rank (self, _tmp24_), chess_state_get_file (self, _tmp25_), PIECE_TYPE_QUEEN, FALSE, FALSE)) {
									result = TRUE;
									_g_object_unref0 (p);
									_g_object_unref0 (opponent);
									return result;
								}
							}
						}
					}
				}
				_g_object_unref0 (p);
			}
		}
	}
	result = FALSE;
	_g_object_unref0 (opponent);
	return result;
}


static gboolean
chess_state_is_in_checkmate (ChessState* self,
                             ChessPlayer* player)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (player != NULL, FALSE);
	{
		gint piece_index = 0;
		piece_index = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				ChessPiece* p = NULL;
				gint _tmp3_;
				ChessPiece* _tmp4_;
				ChessPiece* _tmp5_;
				gboolean _tmp6_ = FALSE;
				ChessPiece* _tmp7_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = piece_index;
					piece_index = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = piece_index;
				if (!(_tmp2_ < 64)) {
					break;
				}
				_tmp3_ = piece_index;
				_tmp4_ = self->board[_tmp3_];
				_tmp5_ = _g_object_ref0 (_tmp4_);
				p = _tmp5_;
				_tmp7_ = p;
				if (_tmp7_ != NULL) {
					ChessPiece* _tmp8_;
					ChessPlayer* _tmp9_;
					_tmp8_ = p;
					_tmp9_ = _tmp8_->player;
					_tmp6_ = _tmp9_ == player;
				} else {
					_tmp6_ = FALSE;
				}
				if (_tmp6_) {
					{
						gint end = 0;
						end = 0;
						{
							gboolean _tmp10_ = FALSE;
							_tmp10_ = TRUE;
							while (TRUE) {
								gint _tmp12_;
								gint _tmp13_;
								gint _tmp14_;
								gint _tmp15_;
								gint _tmp16_;
								if (!_tmp10_) {
									gint _tmp11_;
									_tmp11_ = end;
									end = _tmp11_ + 1;
								}
								_tmp10_ = FALSE;
								_tmp12_ = end;
								if (!(_tmp12_ < 64)) {
									break;
								}
								_tmp13_ = piece_index;
								_tmp14_ = piece_index;
								_tmp15_ = end;
								_tmp16_ = end;
								if (chess_state_move_with_coords (self, player, chess_state_get_rank (self, _tmp13_), chess_state_get_file (self, _tmp14_), chess_state_get_rank (self, _tmp15_), chess_state_get_file (self, _tmp16_), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
									result = FALSE;
									_g_object_unref0 (p);
									return result;
								}
							}
						}
					}
				}
				_g_object_unref0 (p);
			}
		}
	}
	result = TRUE;
	return result;
}


static gboolean
chess_state_can_move (ChessState* self,
                      ChessPlayer* player)
{
	gboolean result = FALSE;
	gboolean have_pieces = FALSE;
	gboolean _tmp17_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (player != NULL, FALSE);
	have_pieces = FALSE;
	{
		gint start = 0;
		start = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				ChessPiece* p = NULL;
				gint _tmp3_;
				ChessPiece* _tmp4_;
				ChessPiece* _tmp5_;
				gboolean _tmp6_ = FALSE;
				ChessPiece* _tmp7_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = start;
					start = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = start;
				if (!(_tmp2_ < 64)) {
					break;
				}
				_tmp3_ = start;
				_tmp4_ = self->board[_tmp3_];
				_tmp5_ = _g_object_ref0 (_tmp4_);
				p = _tmp5_;
				_tmp7_ = p;
				if (_tmp7_ != NULL) {
					ChessPiece* _tmp8_;
					ChessPlayer* _tmp9_;
					_tmp8_ = p;
					_tmp9_ = _tmp8_->player;
					_tmp6_ = _tmp9_ == player;
				} else {
					_tmp6_ = FALSE;
				}
				if (_tmp6_) {
					have_pieces = TRUE;
					{
						gint end = 0;
						end = 0;
						{
							gboolean _tmp10_ = FALSE;
							_tmp10_ = TRUE;
							while (TRUE) {
								gint _tmp12_;
								gint _tmp13_;
								gint _tmp14_;
								gint _tmp15_;
								gint _tmp16_;
								if (!_tmp10_) {
									gint _tmp11_;
									_tmp11_ = end;
									end = _tmp11_ + 1;
								}
								_tmp10_ = FALSE;
								_tmp12_ = end;
								if (!(_tmp12_ < 64)) {
									break;
								}
								_tmp13_ = start;
								_tmp14_ = start;
								_tmp15_ = end;
								_tmp16_ = end;
								if (chess_state_move_with_coords (self, player, chess_state_get_rank (self, _tmp13_), chess_state_get_file (self, _tmp14_), chess_state_get_rank (self, _tmp15_), chess_state_get_file (self, _tmp16_), PIECE_TYPE_QUEEN, FALSE, TRUE)) {
									result = TRUE;
									_g_object_unref0 (p);
									return result;
								}
							}
						}
					}
				}
				_g_object_unref0 (p);
			}
		}
	}
	_tmp17_ = have_pieces;
	if (_tmp17_) {
		result = FALSE;
		return result;
	} else {
		result = TRUE;
		return result;
	}
}


gboolean
chess_state_have_sufficient_material (ChessState* self)
{
	gboolean result = FALSE;
	gint white_knight_count = 0;
	gint white_bishop_count = 0;
	gboolean white_bishop_on_white_square = FALSE;
	gboolean white_bishop_on_black_square = FALSE;
	gint black_knight_count = 0;
	gint black_bishop_count = 0;
	gboolean black_bishop_on_white_square = FALSE;
	gboolean black_bishop_on_black_square = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	white_knight_count = 0;
	white_bishop_count = 0;
	white_bishop_on_white_square = FALSE;
	white_bishop_on_black_square = FALSE;
	black_knight_count = 0;
	black_bishop_count = 0;
	black_bishop_on_white_square = FALSE;
	black_bishop_on_black_square = FALSE;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gint _tmp2_;
				ChessPiece* p = NULL;
				gint _tmp3_;
				ChessPiece* _tmp4_;
				ChessPiece* _tmp5_;
				ChessPiece* _tmp6_;
				gboolean _tmp7_ = FALSE;
				gboolean _tmp8_ = FALSE;
				ChessPiece* _tmp9_;
				PieceType _tmp10_;
				ChessPiece* _tmp15_;
				PieceType _tmp16_;
				ChessPiece* _tmp22_;
				PieceType _tmp23_;
				gboolean _tmp33_ = FALSE;
				gint _tmp34_;
				gboolean _tmp36_ = FALSE;
				gint _tmp37_;
				gboolean _tmp39_ = FALSE;
				gint _tmp40_;
				gboolean _tmp42_ = FALSE;
				gboolean _tmp43_;
				gboolean _tmp45_ = FALSE;
				gboolean _tmp46_;
				gboolean _tmp48_ = FALSE;
				gboolean _tmp49_ = FALSE;
				gint _tmp50_;
				gboolean _tmp53_ = FALSE;
				gboolean _tmp54_ = FALSE;
				gint _tmp55_;
				gboolean _tmp58_ = FALSE;
				gint _tmp59_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = i;
				if (!(_tmp2_ < 64)) {
					break;
				}
				_tmp3_ = i;
				_tmp4_ = self->board[_tmp3_];
				_tmp5_ = _g_object_ref0 (_tmp4_);
				p = _tmp5_;
				_tmp6_ = p;
				if (_tmp6_ == NULL) {
					_g_object_unref0 (p);
					continue;
				}
				_tmp9_ = p;
				_tmp10_ = _tmp9_->type;
				if (_tmp10_ == PIECE_TYPE_PAWN) {
					_tmp8_ = TRUE;
				} else {
					ChessPiece* _tmp11_;
					PieceType _tmp12_;
					_tmp11_ = p;
					_tmp12_ = _tmp11_->type;
					_tmp8_ = _tmp12_ == PIECE_TYPE_ROOK;
				}
				if (_tmp8_) {
					_tmp7_ = TRUE;
				} else {
					ChessPiece* _tmp13_;
					PieceType _tmp14_;
					_tmp13_ = p;
					_tmp14_ = _tmp13_->type;
					_tmp7_ = _tmp14_ == PIECE_TYPE_QUEEN;
				}
				if (_tmp7_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				_tmp15_ = p;
				_tmp16_ = _tmp15_->type;
				if (_tmp16_ == PIECE_TYPE_KNIGHT) {
					ChessPiece* _tmp17_;
					Color _tmp18_;
					Color _tmp19_;
					_tmp17_ = p;
					_tmp18_ = chess_piece_get_color (_tmp17_);
					_tmp19_ = _tmp18_;
					if (_tmp19_ == COLOR_WHITE) {
						gint _tmp20_;
						_tmp20_ = white_knight_count;
						white_knight_count = _tmp20_ + 1;
					} else {
						gint _tmp21_;
						_tmp21_ = black_knight_count;
						black_knight_count = _tmp21_ + 1;
					}
				}
				_tmp22_ = p;
				_tmp23_ = _tmp22_->type;
				if (_tmp23_ == PIECE_TYPE_BISHOP) {
					Color color = 0;
					gint _tmp24_;
					gint _tmp25_;
					ChessPiece* _tmp26_;
					Color _tmp27_;
					Color _tmp28_;
					color = COLOR_BLACK;
					_tmp24_ = i;
					_tmp25_ = i;
					if (((_tmp24_ + (_tmp25_ / 8)) % 2) != 0) {
						color = COLOR_WHITE;
					}
					_tmp26_ = p;
					_tmp27_ = chess_piece_get_color (_tmp26_);
					_tmp28_ = _tmp27_;
					if (_tmp28_ == COLOR_WHITE) {
						Color _tmp29_;
						gint _tmp30_;
						_tmp29_ = color;
						if (_tmp29_ == COLOR_WHITE) {
							white_bishop_on_white_square = TRUE;
						} else {
							white_bishop_on_black_square = TRUE;
						}
						_tmp30_ = white_bishop_count;
						white_bishop_count = _tmp30_ + 1;
					} else {
						Color _tmp31_;
						gint _tmp32_;
						_tmp31_ = color;
						if (_tmp31_ == COLOR_WHITE) {
							black_bishop_on_white_square = TRUE;
						} else {
							black_bishop_on_black_square = TRUE;
						}
						_tmp32_ = black_bishop_count;
						black_bishop_count = _tmp32_ + 1;
					}
				}
				_tmp34_ = white_knight_count;
				if (_tmp34_ > 1) {
					_tmp33_ = TRUE;
				} else {
					gint _tmp35_;
					_tmp35_ = black_knight_count;
					_tmp33_ = _tmp35_ > 1;
				}
				if (_tmp33_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				_tmp37_ = white_bishop_count;
				if (_tmp37_ > 0) {
					gint _tmp38_;
					_tmp38_ = white_knight_count;
					_tmp36_ = _tmp38_ > 0;
				} else {
					_tmp36_ = FALSE;
				}
				if (_tmp36_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				_tmp40_ = black_bishop_count;
				if (_tmp40_ > 0) {
					gint _tmp41_;
					_tmp41_ = black_knight_count;
					_tmp39_ = _tmp41_ > 0;
				} else {
					_tmp39_ = FALSE;
				}
				if (_tmp39_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				_tmp43_ = white_bishop_on_white_square;
				if (_tmp43_) {
					gboolean _tmp44_;
					_tmp44_ = white_bishop_on_black_square;
					_tmp42_ = _tmp44_;
				} else {
					_tmp42_ = FALSE;
				}
				if (_tmp42_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				_tmp46_ = black_bishop_on_white_square;
				if (_tmp46_) {
					gboolean _tmp47_;
					_tmp47_ = black_bishop_on_black_square;
					_tmp45_ = _tmp47_;
				} else {
					_tmp45_ = FALSE;
				}
				if (_tmp45_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				_tmp50_ = white_bishop_count;
				if (_tmp50_ > 0) {
					_tmp49_ = TRUE;
				} else {
					gint _tmp51_;
					_tmp51_ = white_knight_count;
					_tmp49_ = _tmp51_ > 0;
				}
				if (_tmp49_) {
					gint _tmp52_;
					_tmp52_ = black_knight_count;
					_tmp48_ = _tmp52_ > 0;
				} else {
					_tmp48_ = FALSE;
				}
				if (_tmp48_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				_tmp55_ = black_bishop_count;
				if (_tmp55_ > 0) {
					_tmp54_ = TRUE;
				} else {
					gint _tmp56_;
					_tmp56_ = black_knight_count;
					_tmp54_ = _tmp56_ > 0;
				}
				if (_tmp54_) {
					gint _tmp57_;
					_tmp57_ = white_knight_count;
					_tmp53_ = _tmp57_ > 0;
				} else {
					_tmp53_ = FALSE;
				}
				if (_tmp53_) {
					result = TRUE;
					_g_object_unref0 (p);
					return result;
				}
				_tmp59_ = white_bishop_count;
				if (_tmp59_ > 0) {
					gint _tmp60_;
					_tmp60_ = black_bishop_count;
					_tmp58_ = _tmp60_ > 0;
				} else {
					_tmp58_ = FALSE;
				}
				if (_tmp58_) {
					gboolean _tmp61_ = FALSE;
					gboolean _tmp62_;
					_tmp62_ = white_bishop_on_white_square;
					if (_tmp62_) {
						gboolean _tmp63_;
						_tmp63_ = black_bishop_on_black_square;
						_tmp61_ = _tmp63_;
					} else {
						_tmp61_ = FALSE;
					}
					if (_tmp61_) {
						result = TRUE;
						_g_object_unref0 (p);
						return result;
					} else {
						gboolean _tmp64_ = FALSE;
						gboolean _tmp65_;
						_tmp65_ = white_bishop_on_black_square;
						if (_tmp65_) {
							gboolean _tmp66_;
							_tmp66_ = black_bishop_on_white_square;
							_tmp64_ = _tmp66_;
						} else {
							_tmp64_ = FALSE;
						}
						if (_tmp64_) {
							result = TRUE;
							_g_object_unref0 (p);
							return result;
						}
					}
				}
				_g_object_unref0 (p);
			}
		}
	}
	result = FALSE;
	return result;
}


static gboolean
chess_state_decode_piece_type (ChessState* self,
                               gunichar c,
                               PieceType* type)
{
	PieceType _vala_type = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_type = PIECE_TYPE_PAWN;
	switch (c) {
		case 'P':
		{
			_vala_type = PIECE_TYPE_PAWN;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		case 'R':
		{
			_vala_type = PIECE_TYPE_ROOK;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		case 'N':
		{
			_vala_type = PIECE_TYPE_KNIGHT;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		case 'B':
		{
			_vala_type = PIECE_TYPE_BISHOP;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		case 'Q':
		{
			_vala_type = PIECE_TYPE_QUEEN;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		case 'K':
		{
			_vala_type = PIECE_TYPE_KING;
			result = TRUE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
		default:
		{
			result = FALSE;
			if (type) {
				*type = _vala_type;
			}
			return result;
		}
	}
	if (type) {
		*type = _vala_type;
	}
}


static gboolean
chess_state_decode_move (ChessState* self,
                         ChessPlayer* player,
                         const gchar* move,
                         gint* r0,
                         gint* f0,
                         gint* r1,
                         gint* f1,
                         PieceType* promotion_type)
{
	gint _vala_r0 = 0;
	gint _vala_f0 = 0;
	gint _vala_r1 = 0;
	gint _vala_f1 = 0;
	PieceType _vala_promotion_type = 0;
	gboolean result = FALSE;
	gint i = 0;
	gint _tmp99_;
	gint _tmp103_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (player != NULL, FALSE);
	g_return_val_if_fail (move != NULL, FALSE);
	i = 0;
	_vala_promotion_type = PIECE_TYPE_QUEEN;
	if (g_str_has_prefix (move, "O-O-O")) {
		Color _tmp0_;
		gint _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		_tmp0_ = player->color;
		if (_tmp0_ == COLOR_WHITE) {
			gint _tmp1_;
			_vala_r1 = 0;
			_tmp1_ = _vala_r1;
			_vala_r0 = _tmp1_;
		} else {
			gint _tmp2_;
			_vala_r1 = 7;
			_tmp2_ = _vala_r1;
			_vala_r0 = _tmp2_;
		}
		_vala_f0 = 4;
		_vala_f1 = 2;
		_tmp3_ = i;
		_tmp4_ = strlen ("O-O-O");
		_tmp5_ = _tmp4_;
		i = _tmp3_ + ((gint) _tmp5_);
	} else {
		if (g_str_has_prefix (move, "O-O")) {
			Color _tmp6_;
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			_tmp6_ = player->color;
			if (_tmp6_ == COLOR_WHITE) {
				gint _tmp7_;
				_vala_r1 = 0;
				_tmp7_ = _vala_r1;
				_vala_r0 = _tmp7_;
			} else {
				gint _tmp8_;
				_vala_r1 = 7;
				_tmp8_ = _vala_r1;
				_vala_r0 = _tmp8_;
			}
			_vala_f0 = 4;
			_vala_f1 = 6;
			_tmp9_ = i;
			_tmp10_ = strlen ("O-O");
			_tmp11_ = _tmp10_;
			i = _tmp9_ + ((gint) _tmp11_);
		} else {
			PieceType type = 0;
			gint _tmp12_;
			PieceType _tmp13_ = 0;
			gboolean _tmp14_;
			gint _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			gboolean _tmp19_ = FALSE;
			gint _tmp20_;
			gboolean _tmp24_ = FALSE;
			gint _tmp25_;
			gboolean _tmp29_ = FALSE;
			gint _tmp30_;
			gboolean _tmp33_ = FALSE;
			gint _tmp34_;
			gboolean _tmp39_ = FALSE;
			gint _tmp40_;
			gint _tmp45_;
			gboolean _tmp57_ = FALSE;
			gint _tmp58_;
			gboolean _tmp60_ = FALSE;
			gint _tmp61_;
			type = PIECE_TYPE_PAWN;
			_tmp12_ = i;
			_tmp14_ = chess_state_decode_piece_type (self, (gunichar) string_get (move, (glong) _tmp12_), &_tmp13_);
			type = _tmp13_;
			if (_tmp14_) {
				gint _tmp15_;
				_tmp15_ = i;
				i = _tmp15_ + 1;
			}
			_vala_f1 = -1;
			_tmp16_ = _vala_f1;
			_vala_r1 = _tmp16_;
			_tmp17_ = _vala_r1;
			_vala_f0 = _tmp17_;
			_tmp18_ = _vala_f0;
			_vala_r0 = _tmp18_;
			_tmp20_ = i;
			if (string_get (move, (glong) _tmp20_) >= 'a') {
				gint _tmp21_;
				_tmp21_ = i;
				_tmp19_ = string_get (move, (glong) _tmp21_) <= 'h';
			} else {
				_tmp19_ = FALSE;
			}
			if (_tmp19_) {
				gint _tmp22_;
				gint _tmp23_;
				_tmp22_ = i;
				_vala_f1 = (gint) (string_get (move, (glong) _tmp22_) - 'a');
				_tmp23_ = i;
				i = _tmp23_ + 1;
			}
			_tmp25_ = i;
			if (string_get (move, (glong) _tmp25_) >= '1') {
				gint _tmp26_;
				_tmp26_ = i;
				_tmp24_ = string_get (move, (glong) _tmp26_) <= '8';
			} else {
				_tmp24_ = FALSE;
			}
			if (_tmp24_) {
				gint _tmp27_;
				gint _tmp28_;
				_tmp27_ = i;
				_vala_r1 = (gint) (string_get (move, (glong) _tmp27_) - '1');
				_tmp28_ = i;
				i = _tmp28_ + 1;
			}
			_tmp30_ = i;
			if (string_get (move, (glong) _tmp30_) == 'x') {
				_tmp29_ = TRUE;
			} else {
				gint _tmp31_;
				_tmp31_ = i;
				_tmp29_ = string_get (move, (glong) _tmp31_) == '-';
			}
			if (_tmp29_) {
				gint _tmp32_;
				_tmp32_ = i;
				i = _tmp32_ + 1;
			}
			_tmp34_ = i;
			if (string_get (move, (glong) _tmp34_) >= 'a') {
				gint _tmp35_;
				_tmp35_ = i;
				_tmp33_ = string_get (move, (glong) _tmp35_) <= 'h';
			} else {
				_tmp33_ = FALSE;
			}
			if (_tmp33_) {
				gint _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
				_tmp36_ = _vala_f1;
				_vala_f0 = _tmp36_;
				_tmp37_ = i;
				_vala_f1 = (gint) (string_get (move, (glong) _tmp37_) - 'a');
				_tmp38_ = i;
				i = _tmp38_ + 1;
			}
			_tmp40_ = i;
			if (string_get (move, (glong) _tmp40_) >= '1') {
				gint _tmp41_;
				_tmp41_ = i;
				_tmp39_ = string_get (move, (glong) _tmp41_) <= '8';
			} else {
				_tmp39_ = FALSE;
			}
			if (_tmp39_) {
				gint _tmp42_;
				gint _tmp43_;
				gint _tmp44_;
				_tmp42_ = _vala_r1;
				_vala_r0 = _tmp42_;
				_tmp43_ = i;
				_vala_r1 = (gint) (string_get (move, (glong) _tmp43_) - '1');
				_tmp44_ = i;
				i = _tmp44_ + 1;
			}
			_tmp45_ = i;
			if (string_get (move, (glong) _tmp45_) == '=') {
				gint _tmp46_;
				gint _tmp47_;
				PieceType _tmp48_ = 0;
				gboolean _tmp49_;
				_tmp46_ = i;
				i = _tmp46_ + 1;
				_tmp47_ = i;
				_tmp49_ = chess_state_decode_piece_type (self, (gunichar) string_get (move, (glong) _tmp47_), &_tmp48_);
				_vala_promotion_type = _tmp48_;
				if (_tmp49_) {
					gint _tmp50_;
					_tmp50_ = i;
					i = _tmp50_ + 1;
				}
			} else {
				gint _tmp51_;
				_tmp51_ = i;
				if (string_get (move, (glong) _tmp51_) != '\0') {
					gint _tmp52_;
					_tmp52_ = i;
					switch (string_get (move, (glong) _tmp52_)) {
						case 'q':
						case 'Q':
						{
							gint _tmp53_;
							_vala_promotion_type = PIECE_TYPE_QUEEN;
							_tmp53_ = i;
							i = _tmp53_ + 1;
							break;
						}
						case 'n':
						case 'N':
						{
							gint _tmp54_;
							_vala_promotion_type = PIECE_TYPE_KNIGHT;
							_tmp54_ = i;
							i = _tmp54_ + 1;
							break;
						}
						case 'r':
						case 'R':
						{
							gint _tmp55_;
							_vala_promotion_type = PIECE_TYPE_ROOK;
							_tmp55_ = i;
							i = _tmp55_ + 1;
							break;
						}
						case 'b':
						case 'B':
						{
							gint _tmp56_;
							_vala_promotion_type = PIECE_TYPE_BISHOP;
							_tmp56_ = i;
							i = _tmp56_ + 1;
							break;
						}
						default:
						break;
					}
				}
			}
			_tmp58_ = _vala_r1;
			if (_tmp58_ < 0) {
				_tmp57_ = TRUE;
			} else {
				gint _tmp59_;
				_tmp59_ = _vala_f1;
				_tmp57_ = _tmp59_ < 0;
			}
			if (_tmp57_) {
				g_debug ("chess-state.vala:910: Move %s missing destination", move);
				result = FALSE;
				if (r0) {
					*r0 = _vala_r0;
				}
				if (f0) {
					*f0 = _vala_f0;
				}
				if (r1) {
					*r1 = _vala_r1;
				}
				if (f1) {
					*f1 = _vala_f1;
				}
				if (promotion_type) {
					*promotion_type = _vala_promotion_type;
				}
				return result;
			}
			_tmp61_ = _vala_r0;
			if (_tmp61_ < 0) {
				_tmp60_ = TRUE;
			} else {
				gint _tmp62_;
				_tmp62_ = _vala_f0;
				_tmp60_ = _tmp62_ < 0;
			}
			if (_tmp60_) {
				gint match_rank = 0;
				gint match_file = 0;
				gint _tmp96_;
				gint _tmp97_;
				gint _tmp98_;
				match_rank = -1;
				match_file = -1;
				{
					gint file = 0;
					file = 0;
					{
						gboolean _tmp63_ = FALSE;
						_tmp63_ = TRUE;
						while (TRUE) {
							gint _tmp65_;
							gboolean _tmp66_ = FALSE;
							gint _tmp67_;
							if (!_tmp63_) {
								gint _tmp64_;
								_tmp64_ = file;
								file = _tmp64_ + 1;
							}
							_tmp63_ = FALSE;
							_tmp65_ = file;
							if (!(_tmp65_ < 8)) {
								break;
							}
							_tmp67_ = _vala_f0;
							if (_tmp67_ >= 0) {
								gint _tmp68_;
								gint _tmp69_;
								_tmp68_ = file;
								_tmp69_ = _vala_f0;
								_tmp66_ = _tmp68_ != _tmp69_;
							} else {
								_tmp66_ = FALSE;
							}
							if (_tmp66_) {
								continue;
							}
							{
								gint rank = 0;
								rank = 0;
								{
									gboolean _tmp70_ = FALSE;
									_tmp70_ = TRUE;
									while (TRUE) {
										gint _tmp72_;
										gboolean _tmp73_ = FALSE;
										gint _tmp74_;
										ChessPiece* piece = NULL;
										gint _tmp77_;
										gint _tmp78_;
										ChessPiece* _tmp79_;
										ChessPiece* _tmp80_;
										gboolean _tmp81_ = FALSE;
										gboolean _tmp82_ = FALSE;
										ChessPiece* _tmp83_;
										gint _tmp89_;
										gint _tmp90_;
										gint _tmp91_;
										gint _tmp92_;
										gint _tmp93_;
										gint _tmp94_;
										gint _tmp95_;
										if (!_tmp70_) {
											gint _tmp71_;
											_tmp71_ = rank;
											rank = _tmp71_ + 1;
										}
										_tmp70_ = FALSE;
										_tmp72_ = rank;
										if (!(_tmp72_ < 8)) {
											break;
										}
										_tmp74_ = _vala_r0;
										if (_tmp74_ >= 0) {
											gint _tmp75_;
											gint _tmp76_;
											_tmp75_ = rank;
											_tmp76_ = _vala_r0;
											_tmp73_ = _tmp75_ != _tmp76_;
										} else {
											_tmp73_ = FALSE;
										}
										if (_tmp73_) {
											continue;
										}
										_tmp77_ = rank;
										_tmp78_ = file;
										_tmp79_ = self->board[chess_state_get_index (self, _tmp77_, _tmp78_)];
										_tmp80_ = _g_object_ref0 (_tmp79_);
										piece = _tmp80_;
										_tmp83_ = piece;
										if (_tmp83_ == NULL) {
											_tmp82_ = TRUE;
										} else {
											ChessPiece* _tmp84_;
											PieceType _tmp85_;
											PieceType _tmp86_;
											_tmp84_ = piece;
											_tmp85_ = _tmp84_->type;
											_tmp86_ = type;
											_tmp82_ = _tmp85_ != _tmp86_;
										}
										if (_tmp82_) {
											_tmp81_ = TRUE;
										} else {
											ChessPiece* _tmp87_;
											ChessPlayer* _tmp88_;
											_tmp87_ = piece;
											_tmp88_ = _tmp87_->player;
											_tmp81_ = _tmp88_ != player;
										}
										if (_tmp81_) {
											_g_object_unref0 (piece);
											continue;
										}
										_tmp89_ = rank;
										_tmp90_ = file;
										_tmp91_ = _vala_r1;
										_tmp92_ = _vala_f1;
										if (!chess_state_move_with_coords (self, player, _tmp89_, _tmp90_, _tmp91_, _tmp92_, PIECE_TYPE_QUEEN, FALSE, TRUE)) {
											_g_object_unref0 (piece);
											continue;
										}
										_tmp93_ = match_rank;
										if (_tmp93_ >= 0) {
											g_debug ("chess-state.vala:941: Move %s is ambiguous", move);
											result = FALSE;
											_g_object_unref0 (piece);
											if (r0) {
												*r0 = _vala_r0;
											}
											if (f0) {
												*f0 = _vala_f0;
											}
											if (r1) {
												*r1 = _vala_r1;
											}
											if (f1) {
												*f1 = _vala_f1;
											}
											if (promotion_type) {
												*promotion_type = _vala_promotion_type;
											}
											return result;
										}
										_tmp94_ = rank;
										match_rank = _tmp94_;
										_tmp95_ = file;
										match_file = _tmp95_;
										_g_object_unref0 (piece);
									}
								}
							}
						}
					}
				}
				_tmp96_ = match_rank;
				if (_tmp96_ < 0) {
					g_debug ("chess-state.vala:952: Move %s has no matches", move);
					result = FALSE;
					if (r0) {
						*r0 = _vala_r0;
					}
					if (f0) {
						*f0 = _vala_f0;
					}
					if (r1) {
						*r1 = _vala_r1;
					}
					if (f1) {
						*f1 = _vala_f1;
					}
					if (promotion_type) {
						*promotion_type = _vala_promotion_type;
					}
					return result;
				}
				_tmp97_ = match_rank;
				_vala_r0 = _tmp97_;
				_tmp98_ = match_file;
				_vala_f0 = _tmp98_;
			}
		}
	}
	_tmp99_ = i;
	if (string_get (move, (glong) _tmp99_) == '+') {
		gint _tmp100_;
		_tmp100_ = i;
		i = _tmp100_ + 1;
	} else {
		gint _tmp101_;
		_tmp101_ = i;
		if (string_get (move, (glong) _tmp101_) == '#') {
			gint _tmp102_;
			_tmp102_ = i;
			i = _tmp102_ + 1;
		}
	}
	_tmp103_ = i;
	if (string_get (move, (glong) _tmp103_) != '\0') {
		g_debug ("chess-state.vala:968: Move %s has unexpected characters", move);
		result = FALSE;
		if (r0) {
			*r0 = _vala_r0;
		}
		if (f0) {
			*f0 = _vala_f0;
		}
		if (r1) {
			*r1 = _vala_r1;
		}
		if (f1) {
			*f1 = _vala_f1;
		}
		if (promotion_type) {
			*promotion_type = _vala_promotion_type;
		}
		return result;
	}
	result = TRUE;
	if (r0) {
		*r0 = _vala_r0;
	}
	if (f0) {
		*f0 = _vala_f0;
	}
	if (r1) {
		*r1 = _vala_r1;
	}
	if (f1) {
		*f1 = _vala_f1;
	}
	if (promotion_type) {
		*promotion_type = _vala_promotion_type;
	}
	return result;
}


ChessPlayer*
chess_state_get_opponent (ChessState* self)
{
	ChessPlayer* result;
	ChessPlayer* _tmp0_ = NULL;
	ChessPlayer* _tmp1_;
	Color _tmp2_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = self->current_player;
	_tmp2_ = _tmp1_->color;
	if (_tmp2_ == COLOR_WHITE) {
		ChessPlayer* _tmp3_;
		_tmp3_ = self->players[COLOR_BLACK];
		_tmp0_ = _tmp3_;
	} else {
		ChessPlayer* _tmp4_;
		_tmp4_ = self->players[COLOR_WHITE];
		_tmp0_ = _tmp4_;
	}
	result = _tmp0_;
	return result;
}


static void
chess_state_class_init (ChessStateClass * klass)
{
	chess_state_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ChessStatePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_state_get_property;
	G_OBJECT_CLASS (klass)->finalize = chess_state_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_STATE_OPPONENT_PROPERTY, chess_state_properties[CHESS_STATE_OPPONENT_PROPERTY] = g_param_spec_object ("opponent", "opponent", "opponent", TYPE_CHESS_PLAYER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static void
chess_state_instance_init (ChessState * self)
{
	self->priv = CHESS_STATE_GET_PRIVATE (self);
	self->number = 0;
	self->en_passant_index = -1;
	self->last_move = NULL;
}


static void
chess_state_finalize (GObject * obj)
{
	ChessState * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_STATE, ChessState);
	_vala_array_destroy (self->players, 2, (GDestroyNotify) g_object_unref);
	_g_object_unref0 (self->current_player);
	_vala_array_destroy (self->board, 64, (GDestroyNotify) g_object_unref);
	_g_object_unref0 (self->last_move);
	G_OBJECT_CLASS (chess_state_parent_class)->finalize (obj);
}


GType
chess_state_get_type (void)
{
	static volatile gsize chess_state_type_id__volatile = 0;
	if (g_once_init_enter (&chess_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessState), 0, (GInstanceInitFunc) chess_state_instance_init, NULL };
		GType chess_state_type_id;
		chess_state_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessState", &g_define_type_info, 0);
		g_once_init_leave (&chess_state_type_id__volatile, chess_state_type_id);
	}
	return chess_state_type_id__volatile;
}


static void
_vala_chess_state_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ChessState * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_STATE, ChessState);
	switch (property_id) {
		case CHESS_STATE_OPPONENT_PROPERTY:
		g_value_set_object (value, chess_state_get_opponent (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



