/* chess-engine-uci.c generated by valac 0.40.3, the Vala compiler
 * generated from chess-engine-uci.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2013 Robert Ancell
 * Copyright (C) 2013-2016 Michael Catanzaro
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include "libchess.h"
#include <stdlib.h>
#include <string.h>


#define TYPE_CHESS_ENGINE (chess_engine_get_type ())
#define CHESS_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_ENGINE, ChessEngine))
#define CHESS_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_ENGINE, ChessEngineClass))
#define IS_CHESS_ENGINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_ENGINE))
#define IS_CHESS_ENGINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_ENGINE))
#define CHESS_ENGINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_ENGINE, ChessEngineClass))

typedef struct _ChessEngine ChessEngine;
typedef struct _ChessEngineClass ChessEngineClass;
typedef struct _ChessEnginePrivate ChessEnginePrivate;

#define TYPE_CHESS_ENGINE_UCI (chess_engine_uci_get_type ())
#define CHESS_ENGINE_UCI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_ENGINE_UCI, ChessEngineUCI))
#define CHESS_ENGINE_UCI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_ENGINE_UCI, ChessEngineUCIClass))
#define IS_CHESS_ENGINE_UCI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_ENGINE_UCI))
#define IS_CHESS_ENGINE_UCI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_ENGINE_UCI))
#define CHESS_ENGINE_UCI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_ENGINE_UCI, ChessEngineUCIClass))

typedef struct _ChessEngineUCI ChessEngineUCI;
typedef struct _ChessEngineUCIClass ChessEngineUCIClass;
typedef struct _ChessEngineUCIPrivate ChessEngineUCIPrivate;
enum  {
	CHESS_ENGINE_UCI_0_PROPERTY,
	CHESS_ENGINE_UCI_NUM_PROPERTIES
};
static GParamSpec* chess_engine_uci_properties[CHESS_ENGINE_UCI_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ChessEngine {
	GObject parent_instance;
	ChessEnginePrivate * priv;
};

struct _ChessEngineClass {
	GObjectClass parent_class;
	void (*process_input) (ChessEngine* self, gchar* data, int data_length1);
	void (*start_game) (ChessEngine* self);
	void (*report_move) (ChessEngine* self, ChessMove* move);
	void (*do_undo) (ChessEngine* self);
	void (*request_move) (ChessEngine* self);
};

struct _ChessEngineUCI {
	ChessEngine parent_instance;
	ChessEngineUCIPrivate * priv;
};

struct _ChessEngineUCIClass {
	ChessEngineClass parent_class;
};

struct _ChessEngineUCIPrivate {
	gchar* buffer;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* moves;
	gchar** options;
	gint options_length1;
	gint _options_size_;
	gchar* go_options;
	gboolean waiting_for_move;
};


static gpointer chess_engine_uci_parent_class = NULL;

GType chess_engine_get_type (void) G_GNUC_CONST;
GType chess_engine_uci_get_type (void) G_GNUC_CONST;
#define CHESS_ENGINE_UCI_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CHESS_ENGINE_UCI, ChessEngineUCIPrivate))
ChessEngineUCI* chess_engine_uci_new (const gchar* binary,
                                      gchar** args,
                                      int args_length1,
                                      guint delay_seconds,
                                      gchar** options,
                                      int options_length1,
                                      gchar** go_options,
                                      int go_options_length1);
ChessEngineUCI* chess_engine_uci_construct (GType object_type,
                                            const gchar* binary,
                                            gchar** args,
                                            int args_length1,
                                            guint delay_seconds,
                                            gchar** options,
                                            int options_length1,
                                            gchar** go_options,
                                            int go_options_length1);
ChessEngine* chess_engine_construct (GType object_type,
                                     const gchar* binary,
                                     gchar** args,
                                     int args_length1,
                                     guint delay_seconds);
static gchar** _vala_array_dup12 (gchar** self,
                           int length);
static void chess_engine_uci_start_cb (ChessEngineUCI* self);
static void _chess_engine_uci_start_cb_chess_engine_starting (ChessEngine* _sender,
                                                       gpointer self);
void chess_engine_write_line (ChessEngine* self,
                              const gchar* line);
static void chess_engine_uci_real_start_game (ChessEngine* base);
static void chess_engine_uci_real_request_move (ChessEngine* base);
static void chess_engine_uci_real_report_move (ChessEngine* base,
                                        ChessMove* move);
static void chess_engine_uci_real_do_undo (ChessEngine* base);
static void chess_engine_uci_real_process_input (ChessEngine* base,
                                          gchar* data,
                                          int data_length1);
static void chess_engine_uci_configure (ChessEngineUCI* self);
void chess_engine_set_ready (ChessEngine* self,
                             gboolean value);
static gchar* _vala_array_dup13 (gchar* self,
                          int length);
static gchar** _vala_array_dup14 (gchar** self,
                           int length);
static void chess_engine_uci_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gchar**
_vala_array_dup12 (gchar** self,
                   int length)
{
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  int str_array_length1)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	if (separator == NULL) {
		separator = "";
	}
	if (str_array != NULL) {
		gboolean _tmp1_ = FALSE;
		if (str_array_length1 > 0) {
			_tmp1_ = TRUE;
		} else {
			gboolean _tmp2_ = FALSE;
			if (str_array_length1 == -1) {
				const gchar* _tmp3_;
				_tmp3_ = str_array[0];
				_tmp2_ = _tmp3_ != NULL;
			} else {
				_tmp2_ = FALSE;
			}
			_tmp1_ = _tmp2_;
		}
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gint i = 0;
		gsize len = 0UL;
		gint _tmp20_;
		gint _tmp22_;
		gint _tmp23_;
		gsize _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		const gchar* res = NULL;
		gsize _tmp28_;
		void* _tmp29_;
		void* ptr = NULL;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		void* _tmp32_;
		const gchar* _tmp45_;
		len = (gsize) 1;
		{
			gboolean _tmp4_ = FALSE;
			i = 0;
			_tmp4_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp12_ = 0;
				gint _tmp13_;
				const gchar* _tmp14_;
				gsize _tmp19_;
				if (!_tmp4_) {
					gint _tmp5_;
					_tmp5_ = i;
					i = _tmp5_ + 1;
				}
				_tmp4_ = FALSE;
				if (str_array_length1 != -1) {
					gint _tmp8_;
					_tmp8_ = i;
					_tmp7_ = _tmp8_ < str_array_length1;
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					_tmp6_ = TRUE;
				} else {
					gboolean _tmp9_ = FALSE;
					if (str_array_length1 == -1) {
						gint _tmp10_;
						const gchar* _tmp11_;
						_tmp10_ = i;
						_tmp11_ = str_array[_tmp10_];
						_tmp9_ = _tmp11_ != NULL;
					} else {
						_tmp9_ = FALSE;
					}
					_tmp6_ = _tmp9_;
				}
				if (!_tmp6_) {
					break;
				}
				_tmp13_ = i;
				_tmp14_ = str_array[_tmp13_];
				if (_tmp14_ != NULL) {
					gint _tmp15_;
					const gchar* _tmp16_;
					gint _tmp17_;
					gint _tmp18_;
					_tmp15_ = i;
					_tmp16_ = str_array[_tmp15_];
					_tmp17_ = strlen ((const gchar*) _tmp16_);
					_tmp18_ = _tmp17_;
					_tmp12_ = _tmp18_;
				} else {
					_tmp12_ = 0;
				}
				_tmp19_ = len;
				len = _tmp19_ + _tmp12_;
			}
		}
		_tmp20_ = i;
		if (_tmp20_ == 0) {
			gchar* _tmp21_;
			_tmp21_ = g_strdup ("");
			result = _tmp21_;
			return result;
		}
		_tmp22_ = i;
		str_array_length1 = _tmp22_;
		_tmp23_ = str_array_length1;
		_tmp24_ = len;
		_tmp25_ = strlen ((const gchar*) separator);
		_tmp26_ = _tmp25_;
		_tmp27_ = i;
		len = _tmp24_ + (_tmp26_ * (_tmp27_ - 1));
		_tmp28_ = len;
		_tmp29_ = g_malloc (_tmp28_);
		res = _tmp29_;
		_tmp30_ = res;
		_tmp31_ = str_array[0];
		_tmp32_ = g_stpcpy ((void*) _tmp30_, (const gchar*) _tmp31_);
		ptr = _tmp32_;
		{
			gboolean _tmp33_ = FALSE;
			i = 1;
			_tmp33_ = TRUE;
			while (TRUE) {
				gint _tmp35_;
				void* _tmp36_;
				void* _tmp37_;
				const gchar* _tmp38_ = NULL;
				gint _tmp39_;
				const gchar* _tmp40_;
				void* _tmp43_;
				void* _tmp44_;
				if (!_tmp33_) {
					gint _tmp34_;
					_tmp34_ = i;
					i = _tmp34_ + 1;
				}
				_tmp33_ = FALSE;
				_tmp35_ = i;
				if (!(_tmp35_ < str_array_length1)) {
					break;
				}
				_tmp36_ = ptr;
				_tmp37_ = g_stpcpy (_tmp36_, (const gchar*) separator);
				ptr = _tmp37_;
				_tmp39_ = i;
				_tmp40_ = str_array[_tmp39_];
				if (_tmp40_ != NULL) {
					gint _tmp41_;
					const gchar* _tmp42_;
					_tmp41_ = i;
					_tmp42_ = str_array[_tmp41_];
					_tmp38_ = (const gchar*) _tmp42_;
				} else {
					_tmp38_ = "";
				}
				_tmp43_ = ptr;
				_tmp44_ = g_stpcpy (_tmp43_, _tmp38_);
				ptr = _tmp44_;
			}
		}
		_tmp45_ = res;
		res = NULL;
		result = (gchar*) _tmp45_;
		return result;
	} else {
		gchar* _tmp46_;
		_tmp46_ = g_strdup ("");
		result = _tmp46_;
		return result;
	}
}


static void
_chess_engine_uci_start_cb_chess_engine_starting (ChessEngine* _sender,
                                                  gpointer self)
{
	chess_engine_uci_start_cb ((ChessEngineUCI*) self);
}


ChessEngineUCI*
chess_engine_uci_construct (GType object_type,
                            const gchar* binary,
                            gchar** args,
                            int args_length1,
                            guint delay_seconds,
                            gchar** options,
                            int options_length1,
                            gchar** go_options,
                            int go_options_length1)
{
	ChessEngineUCI * self = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	g_return_val_if_fail (binary != NULL, NULL);
	self = (ChessEngineUCI*) chess_engine_construct (object_type, binary, args, args_length1, delay_seconds);
	_tmp0_ = (options != NULL) ? _vala_array_dup12 (options, options_length1) : ((gpointer) options);
	_tmp0__length1 = options_length1;
	self->priv->options = (_vala_array_free (self->priv->options, self->priv->options_length1, (GDestroyNotify) g_free), NULL);
	self->priv->options = _tmp0_;
	self->priv->options_length1 = _tmp0__length1;
	self->priv->_options_size_ = self->priv->options_length1;
	_tmp1_ = _vala_g_strjoinv (" ", go_options, go_options_length1);
	_g_free0 (self->priv->go_options);
	self->priv->go_options = _tmp1_;
	_tmp2_ = g_new0 (gchar, 0);
	self->priv->buffer = (g_free (self->priv->buffer), NULL);
	self->priv->buffer = _tmp2_;
	self->priv->buffer_length1 = 0;
	self->priv->_buffer_size_ = self->priv->buffer_length1;
	_tmp3_ = g_strdup ("");
	_g_free0 (self->priv->moves);
	self->priv->moves = _tmp3_;
	g_signal_connect_object ((ChessEngine*) self, "starting", (GCallback) _chess_engine_uci_start_cb_chess_engine_starting, self, 0);
	return self;
}


ChessEngineUCI*
chess_engine_uci_new (const gchar* binary,
                      gchar** args,
                      int args_length1,
                      guint delay_seconds,
                      gchar** options,
                      int options_length1,
                      gchar** go_options,
                      int go_options_length1)
{
	return chess_engine_uci_construct (TYPE_CHESS_ENGINE_UCI, binary, args, args_length1, delay_seconds, options, options_length1, go_options, go_options_length1);
}


static void
chess_engine_uci_start_cb (ChessEngineUCI* self)
{
	g_return_if_fail (self != NULL);
	chess_engine_write_line ((ChessEngine*) self, "uci");
}


static void
chess_engine_uci_real_start_game (ChessEngine* base)
{
	ChessEngineUCI * self;
	self = (ChessEngineUCI*) base;
	chess_engine_write_line ((ChessEngine*) self, "ucinewgame");
}


static void
chess_engine_uci_real_request_move (ChessEngine* base)
{
	ChessEngineUCI * self;
	const gchar* _tmp0_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	self = (ChessEngineUCI*) base;
	_tmp0_ = self->priv->moves;
	if (g_strcmp0 (_tmp0_, "") != 0) {
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp1_ = self->priv->moves;
		_tmp2_ = g_strconcat ("position startpos moves", _tmp1_, NULL);
		_tmp3_ = _tmp2_;
		chess_engine_write_line ((ChessEngine*) self, _tmp3_);
		_g_free0 (_tmp3_);
	} else {
		chess_engine_write_line ((ChessEngine*) self, "position startpos");
	}
	self->priv->waiting_for_move = TRUE;
	_tmp4_ = self->priv->go_options;
	_tmp5_ = g_strdup_printf ("go wtime 30000 btime 30000 %s", _tmp4_);
	_tmp6_ = _tmp5_;
	chess_engine_write_line ((ChessEngine*) self, _tmp6_);
	_g_free0 (_tmp6_);
}


static void
chess_engine_uci_real_report_move (ChessEngine* base,
                                   ChessMove* move)
{
	ChessEngineUCI * self;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	self = (ChessEngineUCI*) base;
	g_return_if_fail (move != NULL);
	_tmp0_ = self->priv->moves;
	_tmp1_ = chess_move_get_engine (move);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat (" ", _tmp2_, NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp0_, _tmp4_, NULL);
	_g_free0 (self->priv->moves);
	self->priv->moves = _tmp5_;
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
}


static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		glong _tmp2_;
		_tmp2_ = string_length;
		start = _tmp2_ + start;
	}
	if (end < ((glong) 0)) {
		glong _tmp3_;
		_tmp3_ = string_length;
		end = _tmp3_ + end;
	}
	if (start >= ((glong) 0)) {
		glong _tmp5_;
		_tmp5_ = string_length;
		_tmp4_ = start <= _tmp5_;
	} else {
		_tmp4_ = FALSE;
	}
	g_return_val_if_fail (_tmp4_, NULL);
	if (end >= ((glong) 0)) {
		glong _tmp7_;
		_tmp7_ = string_length;
		_tmp6_ = end <= _tmp7_;
	} else {
		_tmp6_ = FALSE;
	}
	g_return_val_if_fail (_tmp6_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp8_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp8_;
	return result;
}


static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


static void
chess_engine_uci_real_do_undo (ChessEngine* base)
{
	ChessEngineUCI * self;
	gboolean _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	self = (ChessEngineUCI*) base;
	_tmp0_ = self->priv->waiting_for_move;
	if (_tmp0_) {
		chess_engine_write_line ((ChessEngine*) self, "stop");
	}
	self->priv->waiting_for_move = FALSE;
	_tmp1_ = self->priv->moves;
	_tmp2_ = self->priv->moves;
	_tmp3_ = string_slice (_tmp1_, (glong) 0, (glong) string_last_index_of (_tmp2_, " ", 0));
	_g_free0 (self->priv->moves);
	self->priv->moves = _tmp3_;
}


static gchar*
_vala_array_dup13 (gchar* self,
                   int length)
{
	return g_memdup (self, length * sizeof (gchar));
}


static void
chess_engine_uci_real_process_input (ChessEngine* base,
                                     gchar* data,
                                     int data_length1)
{
	ChessEngineUCI * self;
	gint current = 0;
	gchar* _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_;
	self = (ChessEngineUCI*) base;
	_tmp0_ = self->priv->buffer;
	_tmp0__length1 = self->priv->buffer_length1;
	current = _tmp0__length1;
	_tmp1_ = self->priv->buffer;
	_tmp1__length1 = self->priv->buffer_length1;
	_tmp2_ = (gint) (_tmp1__length1 + data_length1);
	self->priv->buffer = g_renew (gchar, self->priv->buffer, (gint) (_tmp1__length1 + data_length1));
	(_tmp2_ > self->priv->buffer_length1) ? memset (self->priv->buffer + self->priv->buffer_length1, 0, sizeof (gchar) * (_tmp2_ - self->priv->buffer_length1)) : NULL;
	self->priv->buffer_length1 = _tmp2_;
	self->priv->_buffer_size_ = _tmp2_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				gint _tmp5_;
				gchar* _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
				gchar _tmp10_;
				gchar _tmp11_;
				if (!_tmp3_) {
					gint _tmp4_;
					_tmp4_ = i;
					i = _tmp4_ + 1;
				}
				_tmp3_ = FALSE;
				_tmp5_ = i;
				if (!(_tmp5_ < data_length1)) {
					break;
				}
				_tmp6_ = self->priv->buffer;
				_tmp6__length1 = self->priv->buffer_length1;
				_tmp7_ = current;
				_tmp8_ = i;
				_tmp9_ = i;
				_tmp10_ = data[_tmp9_];
				_tmp6_[_tmp7_ + _tmp8_] = _tmp10_;
				_tmp11_ = _tmp6_[_tmp7_ + _tmp8_];
			}
		}
	}
	while (TRUE) {
		gint offset = 0;
		gint _tmp20_;
		gchar* _tmp21_;
		gint _tmp21__length1;
		gchar* _tmp22_;
		gint _tmp22__length1;
		gint _tmp23_;
		gchar _tmp24_;
		gchar* line = NULL;
		gchar* _tmp25_;
		gint _tmp25__length1;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar** tokens = NULL;
		const gchar* _tmp28_;
		gchar** _tmp29_;
		gchar** _tmp30_;
		gint tokens_length1;
		gint _tokens_size_;
		gchar** _tmp31_;
		gint _tmp31__length1;
		gchar* _tmp50_;
		gint _tmp50__length1;
		gint _tmp51_;
		gchar* _tmp52_;
		gint _tmp52__length1;
		gchar* _tmp53_;
		gint _tmp53__length1;
		{
			gboolean _tmp12_ = FALSE;
			offset = 0;
			_tmp12_ = TRUE;
			while (TRUE) {
				gboolean _tmp14_ = FALSE;
				gint _tmp15_;
				gchar* _tmp16_;
				gint _tmp16__length1;
				if (!_tmp12_) {
					gint _tmp13_;
					_tmp13_ = offset;
					offset = _tmp13_ + 1;
				}
				_tmp12_ = FALSE;
				_tmp15_ = offset;
				_tmp16_ = self->priv->buffer;
				_tmp16__length1 = self->priv->buffer_length1;
				if (_tmp15_ < _tmp16__length1) {
					gchar* _tmp17_;
					gint _tmp17__length1;
					gint _tmp18_;
					gchar _tmp19_;
					_tmp17_ = self->priv->buffer;
					_tmp17__length1 = self->priv->buffer_length1;
					_tmp18_ = offset;
					_tmp19_ = _tmp17_[_tmp18_];
					_tmp14_ = _tmp19_ != '\n';
				} else {
					_tmp14_ = FALSE;
				}
				if (!_tmp14_) {
					break;
				}
			}
		}
		_tmp20_ = offset;
		_tmp21_ = self->priv->buffer;
		_tmp21__length1 = self->priv->buffer_length1;
		if (_tmp20_ >= _tmp21__length1) {
			return;
		}
		_tmp22_ = self->priv->buffer;
		_tmp22__length1 = self->priv->buffer_length1;
		_tmp23_ = offset;
		_tmp22_[_tmp23_] = '\0';
		_tmp24_ = _tmp22_[_tmp23_];
		_tmp25_ = self->priv->buffer;
		_tmp25__length1 = self->priv->buffer_length1;
		_tmp26_ = g_strdup ((const gchar*) _tmp25_);
		line = _tmp26_;
		_tmp27_ = line;
		g_debug ("chess-engine-uci.vala:84: Read from engine: '%s'", _tmp27_);
		_tmp28_ = line;
		_tmp30_ = _tmp29_ = g_strsplit (_tmp28_, " ", 0);
		tokens = _tmp30_;
		tokens_length1 = _vala_array_length (_tmp29_);
		_tokens_size_ = tokens_length1;
		_tmp31_ = tokens;
		_tmp31__length1 = tokens_length1;
		if (_tmp31__length1 > 0) {
			gchar** _tmp32_;
			gint _tmp32__length1;
			const gchar* _tmp33_;
			const gchar* _tmp34_;
			GQuark _tmp36_ = 0U;
			static GQuark _tmp35_label0 = 0;
			static GQuark _tmp35_label1 = 0;
			static GQuark _tmp35_label2 = 0;
			_tmp32_ = tokens;
			_tmp32__length1 = tokens_length1;
			_tmp33_ = _tmp32_[0];
			_tmp34_ = _tmp33_;
			_tmp36_ = (NULL == _tmp34_) ? 0 : g_quark_from_string (_tmp34_);
			if (_tmp36_ == ((0 != _tmp35_label0) ? _tmp35_label0 : (_tmp35_label0 = g_quark_from_static_string ("uciok")))) {
				switch (0) {
					default:
					{
						gchar** _tmp37_;
						gint _tmp37__length1;
						_tmp37_ = tokens;
						_tmp37__length1 = tokens_length1;
						if (_tmp37__length1 != 1) {
							const gchar* _tmp38_;
							_tmp38_ = line;
							g_warning ("chess-engine-uci.vala:93: Unexpected arguments on uciok: %s", _tmp38_);
						}
						chess_engine_uci_configure (self);
						break;
					}
				}
			} else if (_tmp36_ == ((0 != _tmp35_label1) ? _tmp35_label1 : (_tmp35_label1 = g_quark_from_static_string ("readyok")))) {
				switch (0) {
					default:
					{
						gchar** _tmp39_;
						gint _tmp39__length1;
						_tmp39_ = tokens;
						_tmp39__length1 = tokens_length1;
						if (_tmp39__length1 != 1) {
							const gchar* _tmp40_;
							_tmp40_ = line;
							g_warning ("chess-engine-uci.vala:100: Unexpected arguments on readyok: %s", _tmp40_);
						}
						chess_engine_set_ready ((ChessEngine*) self, TRUE);
						break;
					}
				}
			} else if (_tmp36_ == ((0 != _tmp35_label2) ? _tmp35_label2 : (_tmp35_label2 = g_quark_from_static_string ("bestmove")))) {
				switch (0) {
					default:
					{
						gchar** _tmp41_;
						gint _tmp41__length1;
						gboolean _tmp43_;
						_tmp41_ = tokens;
						_tmp41__length1 = tokens_length1;
						if (_tmp41__length1 < 2) {
							const gchar* _tmp42_;
							_tmp42_ = line;
							g_warning ("chess-engine-uci.vala:107: No move with bestmove: %s", _tmp42_);
						}
						_tmp43_ = self->priv->waiting_for_move;
						if (_tmp43_) {
							gchar** _tmp44_;
							gint _tmp44__length1;
							const gchar* _tmp45_;
							gchar** _tmp46_;
							gint _tmp46__length1;
							const gchar* _tmp47_;
							_tmp44_ = tokens;
							_tmp44__length1 = tokens_length1;
							_tmp45_ = _tmp44_[1];
							g_debug ("chess-engine-uci.vala:117: Engine moves %s", _tmp45_);
							self->priv->waiting_for_move = FALSE;
							_tmp46_ = tokens;
							_tmp46__length1 = tokens_length1;
							_tmp47_ = _tmp46_[1];
							g_signal_emit_by_name ((ChessEngine*) self, "moved", _tmp47_);
						} else {
							gchar** _tmp48_;
							gint _tmp48__length1;
							const gchar* _tmp49_;
							_tmp48_ = tokens;
							_tmp48__length1 = tokens_length1;
							_tmp49_ = _tmp48_[1];
							g_debug ("chess-engine-uci.vala:123: Discarding engine move %s during human's tu" \
"rn", _tmp49_);
						}
						break;
					}
				}
			}
		}
		_tmp50_ = self->priv->buffer;
		_tmp50__length1 = self->priv->buffer_length1;
		_tmp51_ = offset;
		_tmp52_ = self->priv->buffer;
		_tmp52__length1 = self->priv->buffer_length1;
		_tmp53_ = ((_tmp50_ + (_tmp51_ + 1)) != NULL) ? _vala_array_dup13 (_tmp50_ + (_tmp51_ + 1), _tmp52__length1 - (_tmp51_ + 1)) : ((gpointer) (_tmp50_ + (_tmp51_ + 1)));
		_tmp53__length1 = _tmp52__length1 - (_tmp51_ + 1);
		self->priv->buffer = (g_free (self->priv->buffer), NULL);
		self->priv->buffer = _tmp53_;
		self->priv->buffer_length1 = _tmp53__length1;
		self->priv->_buffer_size_ = self->priv->buffer_length1;
		tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (line);
	}
}


static gchar**
_vala_array_dup14 (gchar** self,
                   int length)
{
	gchar** result;
	int i;
	result = g_new0 (gchar*, length + 1);
	for (i = 0; i < length; i++) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (self[i]);
		result[i] = _tmp0_;
	}
	return result;
}


static void
chess_engine_uci_configure (ChessEngineUCI* self)
{
	gchar** _tmp0_;
	gint _tmp0__length1;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->options;
	_tmp0__length1 = self->priv->options_length1;
	{
		gchar** o_collection = NULL;
		gint o_collection_length1 = 0;
		gint _o_collection_size_ = 0;
		gint o_it = 0;
		o_collection = _tmp0_;
		o_collection_length1 = _tmp0__length1;
		for (o_it = 0; o_it < _tmp0__length1; o_it = o_it + 1) {
			gchar* _tmp1_;
			gchar* o = NULL;
			_tmp1_ = g_strdup (o_collection[o_it]);
			o = _tmp1_;
			{
				gchar** line = NULL;
				const gchar* _tmp2_;
				gchar** _tmp3_;
				gchar** _tmp4_;
				gint line_length1;
				gint _line_size_;
				gchar* option_value = NULL;
				gchar** _tmp5_;
				gint _tmp5__length1;
				gchar** _tmp6_;
				gint _tmp6__length1;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				gchar** _tmp9_;
				gint _tmp9__length1;
				gchar** _tmp10_;
				gint _tmp10__length1;
				gchar** _tmp11_;
				gint _tmp11__length1;
				gchar* option_name = NULL;
				gchar** _tmp12_;
				gint _tmp12__length1;
				gchar* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				_tmp2_ = o;
				_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, " ", 0);
				line = _tmp4_;
				line_length1 = _vala_array_length (_tmp3_);
				_line_size_ = line_length1;
				_tmp5_ = line;
				_tmp5__length1 = line_length1;
				_tmp6_ = line;
				_tmp6__length1 = line_length1;
				_tmp7_ = _tmp5_[_tmp6__length1 - 1];
				_tmp8_ = g_strdup (_tmp7_);
				option_value = _tmp8_;
				_tmp9_ = line;
				_tmp9__length1 = line_length1;
				_tmp10_ = line;
				_tmp10__length1 = line_length1;
				_tmp11_ = ((_tmp9_ + 0) != NULL) ? _vala_array_dup14 (_tmp9_ + 0, (_tmp10__length1 - 1) - 0) : ((gpointer) (_tmp9_ + 0));
				_tmp11__length1 = (_tmp10__length1 - 1) - 0;
				line = (_vala_array_free (line, line_length1, (GDestroyNotify) g_free), NULL);
				line = _tmp11_;
				line_length1 = _tmp11__length1;
				_line_size_ = line_length1;
				_tmp12_ = line;
				_tmp12__length1 = line_length1;
				_tmp13_ = _vala_g_strjoinv (" ", _tmp12_, _tmp12__length1);
				option_name = _tmp13_;
				_tmp14_ = option_name;
				_tmp15_ = option_value;
				_tmp16_ = g_strdup_printf ("setoption name %s value %s", _tmp14_, _tmp15_);
				_tmp17_ = _tmp16_;
				chess_engine_write_line ((ChessEngine*) self, _tmp17_);
				_g_free0 (_tmp17_);
				_g_free0 (option_name);
				_g_free0 (option_value);
				line = (_vala_array_free (line, line_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (o);
			}
		}
	}
	chess_engine_write_line ((ChessEngine*) self, "isready");
}


static void
chess_engine_uci_class_init (ChessEngineUCIClass * klass)
{
	chess_engine_uci_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ChessEngineUCIPrivate));
	((ChessEngineClass *) klass)->start_game = (void (*) (ChessEngine *)) chess_engine_uci_real_start_game;
	((ChessEngineClass *) klass)->request_move = (void (*) (ChessEngine *)) chess_engine_uci_real_request_move;
	((ChessEngineClass *) klass)->report_move = (void (*) (ChessEngine *, ChessMove*)) chess_engine_uci_real_report_move;
	((ChessEngineClass *) klass)->do_undo = (void (*) (ChessEngine *)) chess_engine_uci_real_do_undo;
	((ChessEngineClass *) klass)->process_input = (void (*) (ChessEngine *, gchar*, int)) chess_engine_uci_real_process_input;
	G_OBJECT_CLASS (klass)->finalize = chess_engine_uci_finalize;
}


static void
chess_engine_uci_instance_init (ChessEngineUCI * self)
{
	self->priv = CHESS_ENGINE_UCI_GET_PRIVATE (self);
}


static void
chess_engine_uci_finalize (GObject * obj)
{
	ChessEngineUCI * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_ENGINE_UCI, ChessEngineUCI);
	self->priv->buffer = (g_free (self->priv->buffer), NULL);
	_g_free0 (self->priv->moves);
	self->priv->options = (_vala_array_free (self->priv->options, self->priv->options_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (self->priv->go_options);
	G_OBJECT_CLASS (chess_engine_uci_parent_class)->finalize (obj);
}


GType
chess_engine_uci_get_type (void)
{
	static volatile gsize chess_engine_uci_type_id__volatile = 0;
	if (g_once_init_enter (&chess_engine_uci_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessEngineUCIClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_engine_uci_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessEngineUCI), 0, (GInstanceInitFunc) chess_engine_uci_instance_init, NULL };
		GType chess_engine_uci_type_id;
		chess_engine_uci_type_id = g_type_register_static (TYPE_CHESS_ENGINE, "ChessEngineUCI", &g_define_type_info, 0);
		g_once_init_leave (&chess_engine_uci_type_id__volatile, chess_engine_uci_type_id);
	}
	return chess_engine_uci_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



