/* chess-scene.c generated by valac 0.40.3, the Vala compiler
 * generated from chess-scene.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2014 Robert Ancell
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include "libchess.h"
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_CHESS_MODEL (chess_model_get_type ())
#define CHESS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_MODEL, ChessModel))
#define CHESS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_MODEL, ChessModelClass))
#define IS_CHESS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_MODEL))
#define IS_CHESS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_MODEL))
#define CHESS_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_MODEL, ChessModelClass))

typedef struct _ChessModel ChessModel;
typedef struct _ChessModelClass ChessModelClass;
typedef struct _ChessModelPrivate ChessModelPrivate;
enum  {
	CHESS_MODEL_0_PROPERTY,
	CHESS_MODEL_MOVING_PROPERTY,
	CHESS_MODEL_NUM_PROPERTIES
};
static GParamSpec* chess_model_properties[CHESS_MODEL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_CHESS_SCENE (chess_scene_get_type ())
#define CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_SCENE, ChessScene))
#define CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_SCENE, ChessSceneClass))
#define IS_CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_SCENE))
#define IS_CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_SCENE))
#define CHESS_SCENE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_SCENE, ChessSceneClass))

typedef struct _ChessScene ChessScene;
typedef struct _ChessSceneClass ChessSceneClass;
typedef struct _ChessScenePrivate ChessScenePrivate;
enum  {
	CHESS_SCENE_0_PROPERTY,
	CHESS_SCENE_GAME_PROPERTY,
	CHESS_SCENE_MOVE_NUMBER_PROPERTY,
	CHESS_SCENE_SHOW_NUMBERING_PROPERTY,
	CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY,
	CHESS_SCENE_THEME_NAME_PROPERTY,
	CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY,
	CHESS_SCENE_BOARD_SIDE_PROPERTY,
	CHESS_SCENE_BOARD_ANGLE_PROPERTY,
	CHESS_SCENE_MOVE_FORMAT_PROPERTY,
	CHESS_SCENE_NUM_PROPERTIES
};
static GParamSpec* chess_scene_properties[CHESS_SCENE_NUM_PROPERTIES];
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	CHESS_SCENE_IS_HUMAN_SIGNAL,
	CHESS_SCENE_CHOOSE_PROMOTION_TYPE_SIGNAL,
	CHESS_SCENE_CHANGED_SIGNAL,
	CHESS_SCENE_NUM_SIGNALS
};
static guint chess_scene_signals[CHESS_SCENE_NUM_SIGNALS] = {0};

struct _ChessModel {
	GObject parent_instance;
	ChessModelPrivate * priv;
	ChessPiece* piece;
	gdouble x;
	gdouble y;
	gdouble target_x;
	gdouble target_y;
	gboolean under_threat;
	gboolean is_selected;
};

struct _ChessModelClass {
	GObjectClass parent_class;
};

struct _ChessScene {
	GObject parent_instance;
	ChessScenePrivate * priv;
	GList* pieces;
	gboolean animating;
	gint selected_rank;
	gint selected_file;
};

struct _ChessSceneClass {
	GObjectClass parent_class;
};

struct _ChessScenePrivate {
	gboolean _can_move[64];
	GTimer* animation_timer;
	gdouble animation_time;
	guint animate_timeout_id;
	ChessGame* _game;
	gint _move_number;
	gboolean _show_numbering;
	gboolean _show_move_hints;
	gchar* _theme_name;
	gboolean _show_3d_smooth;
	gchar* _board_side;
	gchar* _move_format;
};


static gpointer chess_model_parent_class = NULL;
static gpointer chess_scene_parent_class = NULL;

GType chess_model_get_type (void) G_GNUC_CONST;
ChessModel* chess_model_new (ChessPiece* piece,
                             gdouble x,
                             gdouble y);
ChessModel* chess_model_construct (GType object_type,
                                   ChessPiece* piece,
                                   gdouble x,
                                   gdouble y);
gboolean chess_model_move_to (ChessModel* self,
                              gdouble x,
                              gdouble y);
gboolean chess_model_animate (ChessModel* self,
                              gdouble timestep);
gboolean chess_model_get_moving (ChessModel* self);
static gdouble chess_model_update_position (ChessModel* self,
                                     gdouble timestep,
                                     gdouble value,
                                     gdouble target);
static void chess_model_finalize (GObject * obj);
static void _vala_chess_model_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
GType chess_scene_get_type (void) G_GNUC_CONST;
#define CHESS_SCENE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CHESS_SCENE, ChessScenePrivate))
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
ChessPiece* chess_scene_get_selected_piece (ChessScene* self);
ChessGame* chess_scene_get_game (ChessScene* self);
gint chess_scene_get_move_number (ChessScene* self);
ChessScene* chess_scene_new (void);
ChessScene* chess_scene_construct (GType object_type);
void chess_scene_select_square (ChessScene* self,
                                gint file,
                                gint rank);
static void chess_scene_update_board (ChessScene* self);
static void chess_scene_moved_cb (ChessScene* self,
                           ChessGame* game,
                           ChessMove* move);
static void chess_scene_paused_cb (ChessScene* self,
                            ChessGame* game);
static void chess_scene_unpaused_cb (ChessScene* self,
                              ChessGame* game);
static void chess_scene_undo_cb (ChessScene* self,
                          ChessGame* game);
static ChessModel* chess_scene_find_model (ChessScene* self,
                                    ChessPiece* piece);
static gboolean chess_scene_animate_cb (ChessScene* self);
static gboolean _chess_scene_animate_cb_gsource_func (gpointer self);
gboolean chess_scene_can_move (ChessScene* self,
                               gint rank,
                               gint file);
void chess_scene_set_game (ChessScene* self,
                           ChessGame* value);
static void _chess_scene_moved_cb_chess_game_moved (ChessGame* _sender,
                                             ChessMove* move,
                                             gpointer self);
static void _chess_scene_paused_cb_chess_game_paused (ChessGame* _sender,
                                               gpointer self);
static void _chess_scene_unpaused_cb_chess_game_unpaused (ChessGame* _sender,
                                                   gpointer self);
static void _chess_scene_undo_cb_chess_game_undo (ChessGame* _sender,
                                           gpointer self);
void chess_scene_set_move_number (ChessScene* self,
                                  gint value);
gboolean chess_scene_get_show_numbering (ChessScene* self);
void chess_scene_set_show_numbering (ChessScene* self,
                                     gboolean value);
gboolean chess_scene_get_show_move_hints (ChessScene* self);
void chess_scene_set_show_move_hints (ChessScene* self,
                                      gboolean value);
const gchar* chess_scene_get_theme_name (ChessScene* self);
void chess_scene_set_theme_name (ChessScene* self,
                                 const gchar* value);
gboolean chess_scene_get_show_3d_smooth (ChessScene* self);
void chess_scene_set_show_3d_smooth (ChessScene* self,
                                     gboolean value);
const gchar* chess_scene_get_board_side (ChessScene* self);
void chess_scene_set_board_side (ChessScene* self,
                                 const gchar* value);
gdouble chess_scene_get_board_angle (ChessScene* self);
const gchar* chess_scene_get_move_format (ChessScene* self);
void chess_scene_set_move_format (ChessScene* self,
                                  const gchar* value);
static void g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static void g_cclosure_user_marshal_POINTER__VOID (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static void chess_scene_finalize (GObject * obj);
static void _vala_chess_scene_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_chess_scene_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


ChessModel*
chess_model_construct (GType object_type,
                       ChessPiece* piece,
                       gdouble x,
                       gdouble y)
{
	ChessModel * self = NULL;
	ChessPiece* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	g_return_val_if_fail (piece != NULL, NULL);
	self = (ChessModel*) g_object_new (object_type, NULL);
	_tmp0_ = _g_object_ref0 (piece);
	_g_object_unref0 (self->piece);
	self->piece = _tmp0_;
	self->target_x = x;
	_tmp1_ = self->target_x;
	self->x = _tmp1_;
	self->target_y = y;
	_tmp2_ = self->target_y;
	self->y = _tmp2_;
	return self;
}


ChessModel*
chess_model_new (ChessPiece* piece,
                 gdouble x,
                 gdouble y)
{
	return chess_model_construct (TYPE_CHESS_MODEL, piece, x, y);
}


gboolean
chess_model_move_to (ChessModel* self,
                     gdouble x,
                     gdouble y)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gdouble _tmp1_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->target_x;
	if (_tmp1_ == x) {
		gdouble _tmp2_;
		_tmp2_ = self->target_y;
		_tmp0_ = _tmp2_ == y;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	self->target_x = x;
	self->target_y = y;
	result = TRUE;
	return result;
}


gboolean
chess_model_animate (ChessModel* self,
                     gdouble timestep)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = chess_model_get_moving (self);
	_tmp1_ = _tmp0_;
	if (!_tmp1_) {
		result = FALSE;
		return result;
	}
	_tmp2_ = self->x;
	_tmp3_ = self->target_x;
	self->x = chess_model_update_position (self, timestep, _tmp2_, _tmp3_);
	_tmp4_ = self->y;
	_tmp5_ = self->target_y;
	self->y = chess_model_update_position (self, timestep, _tmp4_, _tmp5_);
	result = TRUE;
	return result;
}


static gdouble
chess_model_update_position (ChessModel* self,
                             gdouble timestep,
                             gdouble value,
                             gdouble target)
{
	gdouble result = 0.0;
	gdouble distance = 0.0;
	gdouble step = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	g_return_val_if_fail (self != NULL, 0.0);
	distance = fabs (target - value);
	step = timestep * 4.0;
	_tmp0_ = step;
	_tmp1_ = distance;
	if (_tmp0_ > _tmp1_) {
		gdouble _tmp2_;
		_tmp2_ = distance;
		step = _tmp2_;
	}
	if (target > value) {
		gdouble _tmp3_;
		_tmp3_ = step;
		result = value + _tmp3_;
		return result;
	} else {
		gdouble _tmp4_;
		_tmp4_ = step;
		result = value - _tmp4_;
		return result;
	}
}


gboolean
chess_model_get_moving (ChessModel* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gdouble _tmp1_;
	gdouble _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp1_ = self->x;
	_tmp2_ = self->target_x;
	if (_tmp1_ != _tmp2_) {
		_tmp0_ = TRUE;
	} else {
		gdouble _tmp3_;
		gdouble _tmp4_;
		_tmp3_ = self->y;
		_tmp4_ = self->target_y;
		_tmp0_ = _tmp3_ != _tmp4_;
	}
	result = _tmp0_;
	return result;
}


static void
chess_model_class_init (ChessModelClass * klass)
{
	chess_model_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_model_get_property;
	G_OBJECT_CLASS (klass)->finalize = chess_model_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_MODEL_MOVING_PROPERTY, chess_model_properties[CHESS_MODEL_MOVING_PROPERTY] = g_param_spec_boolean ("moving", "moving", "moving", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static void
chess_model_instance_init (ChessModel * self)
{
}


static void
chess_model_finalize (GObject * obj)
{
	ChessModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_MODEL, ChessModel);
	_g_object_unref0 (self->piece);
	G_OBJECT_CLASS (chess_model_parent_class)->finalize (obj);
}


GType
chess_model_get_type (void)
{
	static volatile gsize chess_model_type_id__volatile = 0;
	if (g_once_init_enter (&chess_model_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessModel), 0, (GInstanceInitFunc) chess_model_instance_init, NULL };
		GType chess_model_type_id;
		chess_model_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessModel", &g_define_type_info, 0);
		g_once_init_leave (&chess_model_type_id__volatile, chess_model_type_id);
	}
	return chess_model_type_id__volatile;
}


static void
_vala_chess_model_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ChessModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_MODEL, ChessModel);
	switch (property_id) {
		case CHESS_MODEL_MOVING_PROPERTY:
		g_value_set_boolean (value, chess_model_get_moving (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}


ChessPiece*
chess_scene_get_selected_piece (ChessScene* self)
{
	ChessPiece* result = NULL;
	gboolean _tmp0_ = FALSE;
	ChessGame* _tmp1_;
	ChessGame* _tmp2_;
	ChessGame* _tmp4_;
	ChessGame* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	ChessPiece* _tmp10_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = chess_scene_get_game (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		gint _tmp3_;
		_tmp3_ = self->selected_rank;
		_tmp0_ = _tmp3_ < 0;
	}
	if (_tmp0_) {
		result = NULL;
		return result;
	}
	_tmp4_ = chess_scene_get_game (self);
	_tmp5_ = _tmp4_;
	_tmp6_ = self->selected_rank;
	_tmp7_ = self->selected_file;
	_tmp8_ = chess_scene_get_move_number (self);
	_tmp9_ = _tmp8_;
	_tmp10_ = chess_game_get_piece (_tmp5_, _tmp6_, _tmp7_, _tmp9_);
	result = _tmp10_;
	return result;
}


ChessScene*
chess_scene_construct (GType object_type)
{
	ChessScene * self = NULL;
	GTimer* _tmp0_;
	self = (ChessScene*) g_object_new (object_type, NULL);
	_tmp0_ = g_timer_new ();
	_g_timer_destroy0 (self->priv->animation_timer);
	self->priv->animation_timer = _tmp0_;
	return self;
}


ChessScene*
chess_scene_new (void)
{
	return chess_scene_construct (TYPE_CHESS_SCENE);
}


void
chess_scene_select_square (ChessScene* self,
                           gint file,
                           gint rank)
{
	gboolean _tmp0_ = FALSE;
	ChessGame* _tmp1_;
	ChessGame* _tmp2_;
	gint _tmp9_;
	gint _tmp10_;
	ChessPiece* piece = NULL;
	ChessGame* _tmp11_;
	ChessGame* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	ChessPiece* _tmp15_;
	gboolean _tmp16_ = FALSE;
	gint _tmp17_;
	g_return_if_fail (self != NULL);
	_tmp1_ = chess_scene_get_game (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		ChessGame* _tmp3_;
		ChessGame* _tmp4_;
		ChessPlayer* _tmp5_;
		ChessPlayer* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp3_ = chess_scene_get_game (self);
		_tmp4_ = _tmp3_;
		_tmp5_ = chess_game_get_current_player (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = chess_player_get_local_human (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp0_ = !_tmp8_;
	}
	if (_tmp0_) {
		return;
	}
	_tmp9_ = chess_scene_get_move_number (self);
	_tmp10_ = _tmp9_;
	if (_tmp10_ != -1) {
		return;
	}
	_tmp11_ = chess_scene_get_game (self);
	_tmp12_ = _tmp11_;
	_tmp13_ = chess_scene_get_move_number (self);
	_tmp14_ = _tmp13_;
	_tmp15_ = chess_game_get_piece (_tmp12_, rank, file, _tmp14_);
	piece = _tmp15_;
	_tmp17_ = self->selected_file;
	if (file == _tmp17_) {
		gint _tmp18_;
		_tmp18_ = self->selected_rank;
		_tmp16_ = rank == _tmp18_;
	} else {
		_tmp16_ = FALSE;
	}
	if (_tmp16_) {
		gint _tmp19_;
		self->selected_file = -1;
		_tmp19_ = self->selected_file;
		self->selected_rank = _tmp19_;
	} else {
		gboolean _tmp20_ = FALSE;
		ChessPiece* _tmp21_;
		_tmp21_ = piece;
		if (_tmp21_ != NULL) {
			ChessPiece* _tmp22_;
			ChessPlayer* _tmp23_;
			ChessGame* _tmp24_;
			ChessGame* _tmp25_;
			ChessPlayer* _tmp26_;
			ChessPlayer* _tmp27_;
			_tmp22_ = piece;
			_tmp23_ = _tmp22_->player;
			_tmp24_ = chess_scene_get_game (self);
			_tmp25_ = _tmp24_;
			_tmp26_ = chess_game_get_current_player (_tmp25_);
			_tmp27_ = _tmp26_;
			_tmp20_ = _tmp23_ == _tmp27_;
		} else {
			_tmp20_ = FALSE;
		}
		if (_tmp20_) {
			self->selected_rank = rank;
			self->selected_file = file;
		} else {
			gint _tmp28_;
			_tmp28_ = self->selected_file;
			if (_tmp28_ != -1) {
				gboolean can_move = FALSE;
				ChessGame* _tmp29_;
				ChessGame* _tmp30_;
				ChessPlayer* _tmp31_;
				ChessPlayer* _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
				gboolean _tmp35_ = FALSE;
				gboolean _tmp36_ = FALSE;
				gboolean _tmp37_;
				gboolean _tmp52_ = FALSE;
				gint _tmp53_;
				_tmp29_ = chess_scene_get_game (self);
				_tmp30_ = _tmp29_;
				_tmp31_ = chess_game_get_current_player (_tmp30_);
				_tmp32_ = _tmp31_;
				_tmp33_ = self->selected_rank;
				_tmp34_ = self->selected_file;
				can_move = chess_player_move_with_coords (_tmp32_, _tmp33_, _tmp34_, rank, file, FALSE, PIECE_TYPE_QUEEN);
				_tmp37_ = can_move;
				if (_tmp37_) {
					ChessPiece* _tmp38_;
					ChessPiece* _tmp39_;
					PieceType _tmp40_;
					_tmp38_ = chess_scene_get_selected_piece (self);
					_tmp39_ = _tmp38_;
					_tmp40_ = _tmp39_->type;
					_tmp36_ = _tmp40_ == PIECE_TYPE_PAWN;
					_g_object_unref0 (_tmp39_);
				} else {
					_tmp36_ = FALSE;
				}
				if (_tmp36_) {
					gboolean _tmp41_ = FALSE;
					if (rank == 0) {
						_tmp41_ = TRUE;
					} else {
						_tmp41_ = rank == 7;
					}
					_tmp35_ = _tmp41_;
				} else {
					_tmp35_ = FALSE;
				}
				if (_tmp35_) {
					PieceType* promotion_selection = NULL;
					PieceType* _tmp42_ = NULL;
					PieceType* _tmp43_;
					ChessGame* _tmp44_;
					ChessGame* _tmp45_;
					ChessPlayer* _tmp46_;
					ChessPlayer* _tmp47_;
					gint _tmp48_;
					gint _tmp49_;
					PieceType* _tmp50_;
					gint _tmp51_;
					g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHOOSE_PROMOTION_TYPE_SIGNAL], 0, &_tmp42_);
					promotion_selection = _tmp42_;
					_tmp43_ = promotion_selection;
					if (_tmp43_ == NULL) {
						_g_free0 (promotion_selection);
						_g_object_unref0 (piece);
						return;
					}
					_tmp44_ = chess_scene_get_game (self);
					_tmp45_ = _tmp44_;
					_tmp46_ = chess_game_get_current_player (_tmp45_);
					_tmp47_ = _tmp46_;
					_tmp48_ = self->selected_rank;
					_tmp49_ = self->selected_file;
					_tmp50_ = promotion_selection;
					chess_player_move_with_coords (_tmp47_, _tmp48_, _tmp49_, rank, file, TRUE, *_tmp50_);
					self->selected_file = -1;
					_tmp51_ = self->selected_file;
					self->selected_rank = _tmp51_;
					_g_free0 (promotion_selection);
				}
				_tmp53_ = self->selected_file;
				if (_tmp53_ != -1) {
					ChessGame* _tmp54_;
					ChessGame* _tmp55_;
					ChessPlayer* _tmp56_;
					ChessPlayer* _tmp57_;
					gint _tmp58_;
					gint _tmp59_;
					_tmp54_ = chess_scene_get_game (self);
					_tmp55_ = _tmp54_;
					_tmp56_ = chess_game_get_current_player (_tmp55_);
					_tmp57_ = _tmp56_;
					_tmp58_ = self->selected_rank;
					_tmp59_ = self->selected_file;
					_tmp52_ = chess_player_move_with_coords (_tmp57_, _tmp58_, _tmp59_, rank, file, TRUE, PIECE_TYPE_QUEEN);
				} else {
					_tmp52_ = FALSE;
				}
				if (_tmp52_) {
					gint _tmp60_;
					self->selected_file = -1;
					_tmp60_ = self->selected_file;
					self->selected_rank = _tmp60_;
				}
			}
		}
	}
	chess_scene_update_board (self);
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
	_g_object_unref0 (piece);
}


static void
chess_scene_moved_cb (ChessScene* self,
                      ChessGame* game,
                      ChessMove* move)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (game != NULL);
	g_return_if_fail (move != NULL);
	chess_scene_update_board (self);
}


static void
chess_scene_paused_cb (ChessScene* self,
                       ChessGame* game)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (game != NULL);
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
}


static void
chess_scene_unpaused_cb (ChessScene* self,
                         ChessGame* game)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (game != NULL);
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
}


static void
chess_scene_undo_cb (ChessScene* self,
                     ChessGame* game)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (game != NULL);
	chess_scene_update_board (self);
}


static ChessModel*
chess_scene_find_model (ChessScene* self,
                        ChessPiece* piece)
{
	ChessModel* result = NULL;
	GList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (piece != NULL, NULL);
	_tmp0_ = self->pieces;
	{
		GList* model_collection = NULL;
		GList* model_it = NULL;
		model_collection = _tmp0_;
		for (model_it = model_collection; model_it != NULL; model_it = model_it->next) {
			ChessModel* _tmp1_;
			ChessModel* model = NULL;
			_tmp1_ = _g_object_ref0 ((ChessModel*) model_it->data);
			model = _tmp1_;
			{
				ChessModel* _tmp2_;
				ChessPiece* _tmp3_;
				_tmp2_ = model;
				_tmp3_ = _tmp2_->piece;
				if (_tmp3_ == piece) {
					result = model;
					return result;
				}
				_g_object_unref0 (model);
			}
		}
	}
	result = NULL;
	return result;
}


static gboolean
_chess_scene_animate_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = chess_scene_animate_cb ((ChessScene*) self);
	return result;
}


static void
chess_scene_update_board (ChessScene* self)
{
	ChessGame* _tmp0_;
	ChessGame* _tmp1_;
	gboolean board_changed = FALSE;
	gboolean need_animation = FALSE;
	GList* new_pieces = NULL;
	GList* _tmp57_;
	GList* _tmp58_;
	gboolean _tmp59_;
	GList* _tmp60_;
	gboolean _tmp64_ = FALSE;
	gboolean _tmp65_;
	g_return_if_fail (self != NULL);
	_tmp0_ = chess_scene_get_game (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == NULL) {
		return;
	}
	board_changed = FALSE;
	need_animation = FALSE;
	new_pieces = NULL;
	{
		gint rank = 0;
		rank = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gint _tmp4_;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = rank;
					rank = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = rank;
				if (!(_tmp4_ < 8)) {
					break;
				}
				{
					gint file = 0;
					file = 0;
					{
						gboolean _tmp5_ = FALSE;
						_tmp5_ = TRUE;
						while (TRUE) {
							gint _tmp7_;
							gboolean can_move = FALSE;
							gboolean _tmp8_ = FALSE;
							gboolean _tmp9_ = FALSE;
							gint _tmp10_;
							gint _tmp21_;
							gint _tmp22_;
							gboolean _tmp23_;
							gboolean _tmp24_;
							ChessPiece* piece = NULL;
							ChessGame* _tmp25_;
							ChessGame* _tmp26_;
							gint _tmp27_;
							gint _tmp28_;
							gint _tmp29_;
							gint _tmp30_;
							ChessPiece* _tmp31_;
							ChessPiece* _tmp32_;
							ChessModel* model = NULL;
							ChessPiece* _tmp33_;
							ChessModel* _tmp34_;
							ChessModel* _tmp35_;
							ChessModel* _tmp40_;
							gboolean _tmp41_;
							ChessModel* _tmp42_;
							gint _tmp43_;
							gint _tmp44_;
							gboolean _tmp45_ = FALSE;
							gboolean _tmp46_ = FALSE;
							gint _tmp47_;
							gint _tmp48_;
							ChessModel* _tmp55_;
							ChessModel* _tmp56_;
							if (!_tmp5_) {
								gint _tmp6_;
								_tmp6_ = file;
								file = _tmp6_ + 1;
							}
							_tmp5_ = FALSE;
							_tmp7_ = file;
							if (!(_tmp7_ < 8)) {
								break;
							}
							can_move = FALSE;
							_tmp10_ = self->selected_rank;
							if (_tmp10_ >= 0) {
								gint _tmp11_;
								gint _tmp12_;
								_tmp11_ = chess_scene_get_move_number (self);
								_tmp12_ = _tmp11_;
								_tmp9_ = _tmp12_ == -1;
							} else {
								_tmp9_ = FALSE;
							}
							if (_tmp9_) {
								ChessGame* _tmp13_;
								ChessGame* _tmp14_;
								ChessPlayer* _tmp15_;
								ChessPlayer* _tmp16_;
								gint _tmp17_;
								gint _tmp18_;
								gint _tmp19_;
								gint _tmp20_;
								_tmp13_ = chess_scene_get_game (self);
								_tmp14_ = _tmp13_;
								_tmp15_ = chess_game_get_current_player (_tmp14_);
								_tmp16_ = _tmp15_;
								_tmp17_ = self->selected_rank;
								_tmp18_ = self->selected_file;
								_tmp19_ = rank;
								_tmp20_ = file;
								_tmp8_ = chess_player_move_with_coords (_tmp16_, _tmp17_, _tmp18_, _tmp19_, _tmp20_, FALSE, PIECE_TYPE_QUEEN);
							} else {
								_tmp8_ = FALSE;
							}
							if (_tmp8_) {
								can_move = TRUE;
							}
							_tmp21_ = rank;
							_tmp22_ = file;
							_tmp23_ = can_move;
							self->priv->_can_move[(_tmp21_ * 8) + _tmp22_] = _tmp23_;
							_tmp24_ = self->priv->_can_move[(_tmp21_ * 8) + _tmp22_];
							_tmp25_ = chess_scene_get_game (self);
							_tmp26_ = _tmp25_;
							_tmp27_ = rank;
							_tmp28_ = file;
							_tmp29_ = chess_scene_get_move_number (self);
							_tmp30_ = _tmp29_;
							_tmp31_ = chess_game_get_piece (_tmp26_, _tmp27_, _tmp28_, _tmp30_);
							piece = _tmp31_;
							_tmp32_ = piece;
							if (_tmp32_ == NULL) {
								_g_object_unref0 (piece);
								continue;
							}
							_tmp33_ = piece;
							_tmp34_ = chess_scene_find_model (self, _tmp33_);
							model = _tmp34_;
							_tmp35_ = model;
							if (_tmp35_ == NULL) {
								ChessPiece* _tmp36_;
								gint _tmp37_;
								gint _tmp38_;
								ChessModel* _tmp39_;
								_tmp36_ = piece;
								_tmp37_ = file;
								_tmp38_ = rank;
								_tmp39_ = chess_model_new (_tmp36_, (gdouble) _tmp37_, (gdouble) _tmp38_);
								_g_object_unref0 (model);
								model = _tmp39_;
								board_changed = TRUE;
							}
							_tmp40_ = model;
							_tmp41_ = can_move;
							_tmp40_->under_threat = _tmp41_;
							_tmp42_ = model;
							_tmp43_ = file;
							_tmp44_ = rank;
							if (chess_model_move_to (_tmp42_, (gdouble) _tmp43_, (gdouble) _tmp44_)) {
								board_changed = TRUE;
								need_animation = TRUE;
							}
							_tmp47_ = chess_scene_get_move_number (self);
							_tmp48_ = _tmp47_;
							if (_tmp48_ == -1) {
								gint _tmp49_;
								gint _tmp50_;
								_tmp49_ = rank;
								_tmp50_ = self->selected_rank;
								_tmp46_ = _tmp49_ == _tmp50_;
							} else {
								_tmp46_ = FALSE;
							}
							if (_tmp46_) {
								gint _tmp51_;
								gint _tmp52_;
								_tmp51_ = file;
								_tmp52_ = self->selected_file;
								_tmp45_ = _tmp51_ == _tmp52_;
							} else {
								_tmp45_ = FALSE;
							}
							if (_tmp45_) {
								ChessModel* _tmp53_;
								_tmp53_ = model;
								_tmp53_->is_selected = TRUE;
							} else {
								ChessModel* _tmp54_;
								_tmp54_ = model;
								_tmp54_->is_selected = FALSE;
							}
							_tmp55_ = model;
							_tmp56_ = _g_object_ref0 (_tmp55_);
							new_pieces = g_list_append (new_pieces, _tmp56_);
							_g_object_unref0 (model);
							_g_object_unref0 (piece);
						}
					}
				}
			}
		}
	}
	_tmp57_ = new_pieces;
	_tmp58_ = self->pieces;
	if (g_list_length (_tmp57_) != g_list_length (_tmp58_)) {
		board_changed = TRUE;
	}
	_tmp59_ = board_changed;
	if (!_tmp59_) {
		__g_list_free__g_object_unref0_0 (new_pieces);
		return;
	}
	__g_list_free__g_object_unref0_0 (self->pieces);
	self->pieces = NULL;
	_tmp60_ = new_pieces;
	{
		GList* model_collection = NULL;
		GList* model_it = NULL;
		model_collection = _tmp60_;
		for (model_it = model_collection; model_it != NULL; model_it = model_it->next) {
			ChessModel* _tmp61_;
			ChessModel* model = NULL;
			_tmp61_ = _g_object_ref0 ((ChessModel*) model_it->data);
			model = _tmp61_;
			{
				ChessModel* _tmp62_;
				ChessModel* _tmp63_;
				_tmp62_ = model;
				_tmp63_ = _g_object_ref0 (_tmp62_);
				self->pieces = g_list_append (self->pieces, _tmp63_);
				_g_object_unref0 (model);
			}
		}
	}
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
	_tmp65_ = need_animation;
	if (_tmp65_) {
		gboolean _tmp66_;
		_tmp66_ = self->animating;
		_tmp64_ = !_tmp66_;
	} else {
		_tmp64_ = FALSE;
	}
	if (_tmp64_) {
		GTimer* _tmp67_;
		ChessGame* _tmp68_;
		ChessGame* _tmp69_;
		self->animating = TRUE;
		_tmp67_ = self->priv->animation_timer;
		g_timer_start (_tmp67_);
		self->priv->animation_time = (gdouble) 0;
		_tmp68_ = chess_scene_get_game (self);
		_tmp69_ = _tmp68_;
		chess_game_add_hold (_tmp69_);
		self->priv->animate_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT_IDLE, (guint) 10, _chess_scene_animate_cb_gsource_func, g_object_ref (self), g_object_unref);
	}
	__g_list_free__g_object_unref0_0 (new_pieces);
}


gboolean
chess_scene_can_move (ChessScene* self,
                      gint rank,
                      gint file)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_can_move[(rank * 8) + file];
	result = _tmp0_;
	return result;
}


static gboolean
chess_scene_animate_cb (ChessScene* self)
{
	gboolean result = FALSE;
	gdouble old_time = 0.0;
	gdouble _tmp0_;
	GTimer* _tmp1_;
	gdouble _tmp2_;
	gdouble timestep = 0.0;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gint animate_count = 0;
	GList* _tmp5_;
	gint _tmp10_;
	gboolean _tmp11_;
	ChessGame* _tmp12_;
	ChessGame* _tmp13_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->animation_time;
	old_time = _tmp0_;
	_tmp1_ = self->priv->animation_timer;
	_tmp2_ = g_timer_elapsed (_tmp1_, NULL);
	self->priv->animation_time = _tmp2_;
	_tmp3_ = self->priv->animation_time;
	_tmp4_ = old_time;
	timestep = _tmp3_ - _tmp4_;
	animate_count = 0;
	_tmp5_ = self->pieces;
	{
		GList* model_collection = NULL;
		GList* model_it = NULL;
		model_collection = _tmp5_;
		for (model_it = model_collection; model_it != NULL; model_it = model_it->next) {
			ChessModel* _tmp6_;
			ChessModel* model = NULL;
			_tmp6_ = _g_object_ref0 ((ChessModel*) model_it->data);
			model = _tmp6_;
			{
				ChessModel* _tmp7_;
				gdouble _tmp8_;
				_tmp7_ = model;
				_tmp8_ = timestep;
				if (chess_model_animate (_tmp7_, _tmp8_)) {
					gint _tmp9_;
					_tmp9_ = animate_count;
					animate_count = _tmp9_ + 1;
				}
				_g_object_unref0 (model);
			}
		}
	}
	_tmp10_ = animate_count;
	self->animating = _tmp10_ > 0;
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
	_tmp11_ = self->animating;
	if (_tmp11_) {
		result = G_SOURCE_CONTINUE;
		return result;
	}
	_tmp12_ = chess_scene_get_game (self);
	_tmp13_ = _tmp12_;
	chess_game_remove_hold (_tmp13_);
	result = G_SOURCE_REMOVE;
	return result;
}


ChessGame*
chess_scene_get_game (ChessScene* self)
{
	ChessGame* result;
	ChessGame* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_game;
	result = _tmp0_;
	return result;
}


static void
_chess_scene_moved_cb_chess_game_moved (ChessGame* _sender,
                                        ChessMove* move,
                                        gpointer self)
{
	chess_scene_moved_cb ((ChessScene*) self, _sender, move);
}


static void
_chess_scene_paused_cb_chess_game_paused (ChessGame* _sender,
                                          gpointer self)
{
	chess_scene_paused_cb ((ChessScene*) self, _sender);
}


static void
_chess_scene_unpaused_cb_chess_game_unpaused (ChessGame* _sender,
                                              gpointer self)
{
	chess_scene_unpaused_cb ((ChessScene*) self, _sender);
}


static void
_chess_scene_undo_cb_chess_game_undo (ChessGame* _sender,
                                      gpointer self)
{
	chess_scene_undo_cb ((ChessScene*) self, _sender);
}


void
chess_scene_set_game (ChessScene* self,
                      ChessGame* value)
{
	guint _tmp0_;
	ChessGame* _tmp2_;
	ChessGame* _tmp3_;
	ChessGame* _tmp4_;
	ChessGame* _tmp5_;
	ChessGame* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->animate_timeout_id;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_;
		_tmp1_ = self->priv->animate_timeout_id;
		g_source_remove (_tmp1_);
		self->priv->animate_timeout_id = (guint) 0;
		self->animating = FALSE;
	}
	_tmp2_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_game);
	self->priv->_game = _tmp2_;
	self->priv->_move_number = -1;
	self->selected_rank = -1;
	self->selected_file = -1;
	_tmp3_ = self->priv->_game;
	g_signal_connect_object (_tmp3_, "moved", (GCallback) _chess_scene_moved_cb_chess_game_moved, self, 0);
	_tmp4_ = self->priv->_game;
	g_signal_connect_object (_tmp4_, "paused", (GCallback) _chess_scene_paused_cb_chess_game_paused, self, 0);
	_tmp5_ = self->priv->_game;
	g_signal_connect_object (_tmp5_, "unpaused", (GCallback) _chess_scene_unpaused_cb_chess_game_unpaused, self, 0);
	_tmp6_ = self->priv->_game;
	g_signal_connect_object (_tmp6_, "undo", (GCallback) _chess_scene_undo_cb_chess_game_undo, self, 0);
	chess_scene_update_board (self);
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_GAME_PROPERTY]);
}


gint
chess_scene_get_move_number (ChessScene* self)
{
	gint result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_move_number;
	result = _tmp0_;
	return result;
}


void
chess_scene_set_move_number (ChessScene* self,
                             gint value)
{
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_move_number;
	if (_tmp0_ == value) {
		return;
	}
	self->priv->_move_number = value;
	chess_scene_update_board (self);
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_MOVE_NUMBER_PROPERTY]);
}


gboolean
chess_scene_get_show_numbering (ChessScene* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_show_numbering;
	result = _tmp0_;
	return result;
}


void
chess_scene_set_show_numbering (ChessScene* self,
                                gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_show_numbering = value;
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_SHOW_NUMBERING_PROPERTY]);
}


gboolean
chess_scene_get_show_move_hints (ChessScene* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_show_move_hints;
	result = _tmp0_;
	return result;
}


void
chess_scene_set_show_move_hints (ChessScene* self,
                                 gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_show_move_hints = value;
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY]);
}


const gchar*
chess_scene_get_theme_name (ChessScene* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_theme_name;
	result = _tmp0_;
	return result;
}


void
chess_scene_set_theme_name (ChessScene* self,
                            const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_theme_name);
	self->priv->_theme_name = _tmp0_;
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_THEME_NAME_PROPERTY]);
}


gboolean
chess_scene_get_show_3d_smooth (ChessScene* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_show_3d_smooth;
	result = _tmp0_;
	return result;
}


void
chess_scene_set_show_3d_smooth (ChessScene* self,
                                gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_show_3d_smooth = value;
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY]);
}


const gchar*
chess_scene_get_board_side (ChessScene* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_board_side;
	result = _tmp0_;
	return result;
}


void
chess_scene_set_board_side (ChessScene* self,
                            const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_board_side);
	self->priv->_board_side = _tmp0_;
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_BOARD_SIDE_PROPERTY]);
}


gdouble
chess_scene_get_board_angle (ChessScene* self)
{
	gdouble result;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GQuark _tmp4_ = 0U;
	static GQuark _tmp3_label0 = 0;
	static GQuark _tmp3_label1 = 0;
	static GQuark _tmp3_label2 = 0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = chess_scene_get_board_side (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = _tmp1_;
	_tmp4_ = (NULL == _tmp2_) ? 0 : g_quark_from_string (_tmp2_);
	if (_tmp4_ == ((0 != _tmp3_label0) ? _tmp3_label0 : (_tmp3_label0 = g_quark_from_static_string ("black")))) {
		switch (0) {
			default:
			{
				result = 180.0;
				return result;
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label1) ? _tmp3_label1 : (_tmp3_label1 = g_quark_from_static_string ("human")))) {
		switch (0) {
			default:
			{
				ChessGame* _tmp5_;
				ChessGame* _tmp6_;
				ChessPlayer* _tmp7_;
				ChessPlayer* _tmp8_;
				gboolean _tmp9_ = FALSE;
				_tmp5_ = chess_scene_get_game (self);
				_tmp6_ = _tmp5_;
				_tmp7_ = chess_game_get_black (_tmp6_);
				_tmp8_ = _tmp7_;
				g_signal_emit (self, chess_scene_signals[CHESS_SCENE_IS_HUMAN_SIGNAL], 0, _tmp8_, &_tmp9_);
				if (_tmp9_) {
					result = 180.0;
					return result;
				} else {
					result = 0.0;
					return result;
				}
			}
		}
	} else if (_tmp4_ == ((0 != _tmp3_label2) ? _tmp3_label2 : (_tmp3_label2 = g_quark_from_static_string ("current")))) {
		switch (0) {
			default:
			{
				gdouble _tmp10_ = 0.0;
				ChessGame* _tmp11_;
				ChessGame* _tmp12_;
				ChessPlayer* _tmp13_;
				ChessPlayer* _tmp14_;
				Color _tmp15_;
				_tmp11_ = chess_scene_get_game (self);
				_tmp12_ = _tmp11_;
				_tmp13_ = chess_game_get_current_player (_tmp12_);
				_tmp14_ = _tmp13_;
				_tmp15_ = _tmp14_->color;
				if (_tmp15_ == COLOR_WHITE) {
					_tmp10_ = 0.0;
				} else {
					_tmp10_ = 180.0;
				}
				result = _tmp10_;
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				result = 0.0;
				return result;
			}
		}
	}
}


const gchar*
chess_scene_get_move_format (ChessScene* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_move_format;
	result = _tmp0_;
	return result;
}


void
chess_scene_set_move_format (ChessScene* self,
                             const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_move_format);
	self->priv->_move_format = _tmp0_;
	g_signal_emit (self, chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL], 0);
	g_object_notify_by_pspec ((GObject *) self, chess_scene_properties[CHESS_SCENE_MOVE_FORMAT_PROPERTY]);
}


static void
g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__OBJECT) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
	g_return_if_fail (return_value != NULL);
	g_return_if_fail (n_param_values == 2);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_BOOLEAN__OBJECT) (marshal_data ? marshal_data : cc->callback);
	v_return = callback (data1, g_value_get_object (param_values + 1), data2);
	g_value_set_boolean (return_value, v_return);
}


static void
g_cclosure_user_marshal_POINTER__VOID (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef gpointer (*GMarshalFunc_POINTER__VOID) (gpointer data1, gpointer data2);
	register GMarshalFunc_POINTER__VOID callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gpointer v_return;
	cc = (GCClosure *) closure;
	g_return_if_fail (return_value != NULL);
	g_return_if_fail (n_param_values == 1);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_POINTER__VOID) (marshal_data ? marshal_data : cc->callback);
	v_return = callback (data1, data2);
	g_value_set_pointer (return_value, v_return);
}


static void
chess_scene_class_init (ChessSceneClass * klass)
{
	chess_scene_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ChessScenePrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_scene_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_chess_scene_set_property;
	G_OBJECT_CLASS (klass)->finalize = chess_scene_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_GAME_PROPERTY, chess_scene_properties[CHESS_SCENE_GAME_PROPERTY] = g_param_spec_object ("game", "game", "game", TYPE_CHESS_GAME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_MOVE_NUMBER_PROPERTY, chess_scene_properties[CHESS_SCENE_MOVE_NUMBER_PROPERTY] = g_param_spec_int ("move-number", "move-number", "move-number", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_SHOW_NUMBERING_PROPERTY, chess_scene_properties[CHESS_SCENE_SHOW_NUMBERING_PROPERTY] = g_param_spec_boolean ("show-numbering", "show-numbering", "show-numbering", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY, chess_scene_properties[CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY] = g_param_spec_boolean ("show-move-hints", "show-move-hints", "show-move-hints", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_THEME_NAME_PROPERTY, chess_scene_properties[CHESS_SCENE_THEME_NAME_PROPERTY] = g_param_spec_string ("theme-name", "theme-name", "theme-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY, chess_scene_properties[CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY] = g_param_spec_boolean ("show-3d-smooth", "show-3d-smooth", "show-3d-smooth", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_BOARD_SIDE_PROPERTY, chess_scene_properties[CHESS_SCENE_BOARD_SIDE_PROPERTY] = g_param_spec_string ("board-side", "board-side", "board-side", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_BOARD_ANGLE_PROPERTY, chess_scene_properties[CHESS_SCENE_BOARD_ANGLE_PROPERTY] = g_param_spec_double ("board-angle", "board-angle", "board-angle", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_SCENE_MOVE_FORMAT_PROPERTY, chess_scene_properties[CHESS_SCENE_MOVE_FORMAT_PROPERTY] = g_param_spec_string ("move-format", "move-format", "move-format", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	chess_scene_signals[CHESS_SCENE_IS_HUMAN_SIGNAL] = g_signal_new ("is-human", TYPE_CHESS_SCENE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__OBJECT, G_TYPE_BOOLEAN, 1, TYPE_CHESS_PLAYER);
	chess_scene_signals[CHESS_SCENE_CHOOSE_PROMOTION_TYPE_SIGNAL] = g_signal_new ("choose-promotion-type", TYPE_CHESS_SCENE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_POINTER__VOID, G_TYPE_POINTER, 0);
	chess_scene_signals[CHESS_SCENE_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_CHESS_SCENE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void
chess_scene_instance_init (ChessScene * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	self->priv = CHESS_SCENE_GET_PRIVATE (self);
	self->pieces = NULL;
	self->animating = FALSE;
	self->selected_rank = -1;
	self->selected_file = -1;
	self->priv->animate_timeout_id = (guint) 0;
	self->priv->_game = NULL;
	self->priv->_move_number = -1;
	self->priv->_show_numbering = TRUE;
	self->priv->_show_move_hints = TRUE;
	_tmp0_ = g_strdup ("simple");
	self->priv->_theme_name = _tmp0_;
	self->priv->_show_3d_smooth = FALSE;
	_tmp1_ = g_strdup ("human");
	self->priv->_board_side = _tmp1_;
	_tmp2_ = g_strdup ("human");
	self->priv->_move_format = _tmp2_;
}


static void
chess_scene_finalize (GObject * obj)
{
	ChessScene * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_SCENE, ChessScene);
	__g_list_free__g_object_unref0_0 (self->pieces);
	_g_timer_destroy0 (self->priv->animation_timer);
	_g_object_unref0 (self->priv->_game);
	_g_free0 (self->priv->_theme_name);
	_g_free0 (self->priv->_board_side);
	_g_free0 (self->priv->_move_format);
	G_OBJECT_CLASS (chess_scene_parent_class)->finalize (obj);
}


GType
chess_scene_get_type (void)
{
	static volatile gsize chess_scene_type_id__volatile = 0;
	if (g_once_init_enter (&chess_scene_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessSceneClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_scene_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessScene), 0, (GInstanceInitFunc) chess_scene_instance_init, NULL };
		GType chess_scene_type_id;
		chess_scene_type_id = g_type_register_static (G_TYPE_OBJECT, "ChessScene", &g_define_type_info, 0);
		g_once_init_leave (&chess_scene_type_id__volatile, chess_scene_type_id);
	}
	return chess_scene_type_id__volatile;
}


static void
_vala_chess_scene_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ChessScene * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_SCENE, ChessScene);
	switch (property_id) {
		case CHESS_SCENE_GAME_PROPERTY:
		g_value_set_object (value, chess_scene_get_game (self));
		break;
		case CHESS_SCENE_MOVE_NUMBER_PROPERTY:
		g_value_set_int (value, chess_scene_get_move_number (self));
		break;
		case CHESS_SCENE_SHOW_NUMBERING_PROPERTY:
		g_value_set_boolean (value, chess_scene_get_show_numbering (self));
		break;
		case CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY:
		g_value_set_boolean (value, chess_scene_get_show_move_hints (self));
		break;
		case CHESS_SCENE_THEME_NAME_PROPERTY:
		g_value_set_string (value, chess_scene_get_theme_name (self));
		break;
		case CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY:
		g_value_set_boolean (value, chess_scene_get_show_3d_smooth (self));
		break;
		case CHESS_SCENE_BOARD_SIDE_PROPERTY:
		g_value_set_string (value, chess_scene_get_board_side (self));
		break;
		case CHESS_SCENE_BOARD_ANGLE_PROPERTY:
		g_value_set_double (value, chess_scene_get_board_angle (self));
		break;
		case CHESS_SCENE_MOVE_FORMAT_PROPERTY:
		g_value_set_string (value, chess_scene_get_move_format (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_chess_scene_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	ChessScene * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_SCENE, ChessScene);
	switch (property_id) {
		case CHESS_SCENE_GAME_PROPERTY:
		chess_scene_set_game (self, g_value_get_object (value));
		break;
		case CHESS_SCENE_MOVE_NUMBER_PROPERTY:
		chess_scene_set_move_number (self, g_value_get_int (value));
		break;
		case CHESS_SCENE_SHOW_NUMBERING_PROPERTY:
		chess_scene_set_show_numbering (self, g_value_get_boolean (value));
		break;
		case CHESS_SCENE_SHOW_MOVE_HINTS_PROPERTY:
		chess_scene_set_show_move_hints (self, g_value_get_boolean (value));
		break;
		case CHESS_SCENE_THEME_NAME_PROPERTY:
		chess_scene_set_theme_name (self, g_value_get_string (value));
		break;
		case CHESS_SCENE_SHOW_3D_SMOOTH_PROPERTY:
		chess_scene_set_show_3d_smooth (self, g_value_get_boolean (value));
		break;
		case CHESS_SCENE_BOARD_SIDE_PROPERTY:
		chess_scene_set_board_side (self, g_value_get_string (value));
		break;
		case CHESS_SCENE_MOVE_FORMAT_PROPERTY:
		chess_scene_set_move_format (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



