/* chess-view.c generated by valac 0.40.3, the Vala compiler
 * generated from chess-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright (C) 2010-2014 Robert Ancell
 * Copyright (C) 2015-2016 Sahil Sareen
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <cairo.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <math.h>
#include <float.h>
#include <librsvg/rsvg.h>
#include <stdio.h>
#include "libchess.h"
#include <glib/gi18n-lib.h>


#define TYPE_CHESS_VIEW (chess_view_get_type ())
#define CHESS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_VIEW, ChessView))
#define CHESS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_VIEW, ChessViewClass))
#define IS_CHESS_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_VIEW))
#define IS_CHESS_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_VIEW))
#define CHESS_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_VIEW, ChessViewClass))

typedef struct _ChessView ChessView;
typedef struct _ChessViewClass ChessViewClass;
typedef struct _ChessViewPrivate ChessViewPrivate;

#define TYPE_CHESS_SCENE (chess_scene_get_type ())
#define CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_SCENE, ChessScene))
#define CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_SCENE, ChessSceneClass))
#define IS_CHESS_SCENE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_SCENE))
#define IS_CHESS_SCENE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_SCENE))
#define CHESS_SCENE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_SCENE, ChessSceneClass))

typedef struct _ChessScene ChessScene;
typedef struct _ChessSceneClass ChessSceneClass;
enum  {
	CHESS_VIEW_0_PROPERTY,
	CHESS_VIEW_SCENE_PROPERTY,
	CHESS_VIEW_NUM_PROPERTIES
};
static GParamSpec* chess_view_properties[CHESS_VIEW_NUM_PROPERTIES];
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
typedef struct _ChessScenePrivate ChessScenePrivate;

#define TYPE_CHESS_MODEL (chess_model_get_type ())
#define CHESS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CHESS_MODEL, ChessModel))
#define CHESS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CHESS_MODEL, ChessModelClass))
#define IS_CHESS_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CHESS_MODEL))
#define IS_CHESS_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CHESS_MODEL))
#define CHESS_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CHESS_MODEL, ChessModelClass))

typedef struct _ChessModel ChessModel;
typedef struct _ChessModelClass ChessModelClass;
typedef struct _ChessModelPrivate ChessModelPrivate;

struct _ChessView {
	GtkDrawingArea parent_instance;
	ChessViewPrivate * priv;
};

struct _ChessViewClass {
	GtkDrawingAreaClass parent_class;
};

struct _ChessViewPrivate {
	gint border;
	gint square_size;
	gint selected_square_size;
	cairo_surface_t* model_surface;
	cairo_surface_t* selected_model_surface;
	gchar* loaded_theme_name;
	ChessScene* _scene;
};

struct _ChessScene {
	GObject parent_instance;
	ChessScenePrivate * priv;
	GList* pieces;
	gboolean animating;
	gint selected_rank;
	gint selected_file;
};

struct _ChessSceneClass {
	GObjectClass parent_class;
};

struct _ChessModel {
	GObject parent_instance;
	ChessModelPrivate * priv;
	ChessPiece* piece;
	gdouble x;
	gdouble y;
	gdouble target_x;
	gdouble target_y;
	gboolean under_threat;
	gboolean is_selected;
};

struct _ChessModelClass {
	GObjectClass parent_class;
};


static gpointer chess_view_parent_class = NULL;

GType chess_view_get_type (void) G_GNUC_CONST;
GType chess_scene_get_type (void) G_GNUC_CONST;
#define CHESS_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_CHESS_VIEW, ChessViewPrivate))
ChessView* chess_view_new (void);
ChessView* chess_view_construct (GType object_type);
static gboolean chess_view_real_configure_event (GtkWidget* base,
                                          GdkEventConfigure* event);
static void chess_view_render_piece (ChessView* self,
                              cairo_t* c1,
                              cairo_t* c2,
                              const gchar* name,
                              gint offset);
ChessScene* chess_view_get_scene (ChessView* self);
const gchar* chess_scene_get_theme_name (ChessScene* self);
static void chess_view_load_theme (ChessView* self,
                            cairo_t* c);
static gboolean chess_view_real_draw (GtkWidget* base,
                               cairo_t* c);
gdouble chess_scene_get_board_angle (ChessScene* self);
static gdouble chess_view_get_border_size (ChessView* self);
gboolean chess_scene_get_show_numbering (ChessScene* self);
ChessGame* chess_scene_get_game (ChessScene* self);
void chess_view_draw_paused_overlay (ChessView* self,
                                     cairo_t* c);
GType chess_model_get_type (void) G_GNUC_CONST;
gboolean chess_scene_get_show_move_hints (ChessScene* self);
static void chess_view_draw_piece (ChessView* self,
                            cairo_t* c,
                            cairo_surface_t* surface,
                            gint size,
                            ChessPiece* piece,
                            gdouble alpha);
gboolean chess_scene_can_move (ChessScene* self,
                               gint rank,
                               gint file);
ChessPiece* chess_scene_get_selected_piece (ChessScene* self);
static gboolean chess_view_real_button_press_event (GtkWidget* base,
                                             GdkEventButton* event);
void chess_scene_select_square (ChessScene* self,
                                gint file,
                                gint rank);
static void chess_view_scene_changed_cb (ChessView* self,
                                  ChessScene* scene);
void chess_view_set_scene (ChessView* self,
                           ChessScene* value);
static void _chess_view_scene_changed_cb_chess_scene_changed (ChessScene* _sender,
                                                       gpointer self);
static void chess_view_finalize (GObject * obj);
static void _vala_chess_view_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_chess_view_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


ChessView*
chess_view_construct (GType object_type)
{
	ChessView * self = NULL;
	self = (ChessView*) g_object_new (object_type, NULL);
	gtk_widget_add_events ((GtkWidget*) self, (gint) (GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK));
	return self;
}


ChessView*
chess_view_new (void)
{
	return chess_view_construct (TYPE_CHESS_VIEW);
}


static gboolean
chess_view_real_configure_event (GtkWidget* base,
                                 GdkEventConfigure* event)
{
	ChessView * self;
	gboolean result = FALSE;
	gint short_edge = 0;
	gint _tmp0_;
	gint _tmp1_;
	gdouble extra = 0.0;
	gint _tmp2_;
	gdouble _tmp3_;
	gint _tmp4_;
	gdouble _tmp5_;
	self = (ChessView*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	short_edge = MIN (gtk_widget_get_allocated_width ((GtkWidget*) self), gtk_widget_get_allocated_height ((GtkWidget*) self));
	_tmp0_ = short_edge;
	_tmp1_ = self->priv->border;
	self->priv->square_size = (gint) floor ((_tmp0_ - (2 * _tmp1_)) / 9.0);
	_tmp2_ = self->priv->square_size;
	extra = _tmp2_ * 0.1;
	_tmp3_ = extra;
	if (_tmp3_ < ((gdouble) 3)) {
		extra = (gdouble) 3;
	}
	_tmp4_ = self->priv->square_size;
	_tmp5_ = extra;
	self->priv->selected_square_size = _tmp4_ + (2 * ((gint) (_tmp5_ + 0.5)));
	result = TRUE;
	return result;
}


static void
chess_view_render_piece (ChessView* self,
                         cairo_t* c1,
                         cairo_t* c2,
                         const gchar* name,
                         gint offset)
{
	RsvgHandle* handle = NULL;
	gint _tmp15_;
	gint _tmp16_;
	RsvgHandle* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	RsvgHandle* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	RsvgHandle* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	RsvgHandle* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	RsvgHandle* _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	RsvgHandle* _tmp34_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c1 != NULL);
	g_return_if_fail (c2 != NULL);
	g_return_if_fail (name != NULL);
	{
		RsvgHandle* _tmp0_ = NULL;
		ChessScene* _tmp1_;
		ChessScene* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		RsvgHandle* _tmp9_;
		RsvgHandle* _tmp10_;
		RsvgHandle* _tmp11_;
		_tmp1_ = chess_view_get_scene (self);
		_tmp2_ = _tmp1_;
		_tmp3_ = chess_scene_get_theme_name (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_strconcat (name, ".svg", NULL);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_build_filename (PKGDATADIR, "pieces", _tmp4_, _tmp6_, NULL, NULL);
		_tmp8_ = _tmp7_;
		_tmp9_ = rsvg_handle_new_from_file (_tmp8_, &_inner_error_);
		_tmp10_ = _tmp9_;
		_g_free0 (_tmp8_);
		_g_free0 (_tmp6_);
		_tmp0_ = _tmp10_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch6_g_error;
		}
		_tmp11_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (handle);
		handle = _tmp11_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		FILE* _tmp12_;
		GError* _tmp13_;
		const gchar* _tmp14_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp12_ = stderr;
		_tmp13_ = e;
		_tmp14_ = _tmp13_->message;
		fprintf (_tmp12_, "Failed to load piece svg: %s\n", _tmp14_);
		_g_error_free0 (e);
		_g_object_unref0 (handle);
		return;
	}
	__finally6:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (handle);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	cairo_save (c1);
	_tmp15_ = self->priv->square_size;
	cairo_translate (c1, (gdouble) (_tmp15_ * offset), (gdouble) 0);
	_tmp16_ = self->priv->square_size;
	_tmp17_ = handle;
	g_object_get (_tmp17_, "width", &_tmp18_, NULL);
	_tmp19_ = _tmp18_;
	_tmp20_ = self->priv->square_size;
	_tmp21_ = handle;
	g_object_get (_tmp21_, "height", &_tmp22_, NULL);
	_tmp23_ = _tmp22_;
	cairo_scale (c1, ((gdouble) _tmp16_) / _tmp19_, ((gdouble) _tmp20_) / _tmp23_);
	_tmp24_ = handle;
	rsvg_handle_render_cairo (_tmp24_, c1);
	cairo_restore (c1);
	cairo_save (c2);
	_tmp25_ = self->priv->selected_square_size;
	cairo_translate (c2, (gdouble) (_tmp25_ * offset), (gdouble) 0);
	_tmp26_ = self->priv->selected_square_size;
	_tmp27_ = handle;
	g_object_get (_tmp27_, "width", &_tmp28_, NULL);
	_tmp29_ = _tmp28_;
	_tmp30_ = self->priv->selected_square_size;
	_tmp31_ = handle;
	g_object_get (_tmp31_, "height", &_tmp32_, NULL);
	_tmp33_ = _tmp32_;
	cairo_scale (c2, ((gdouble) _tmp26_) / _tmp29_, ((gdouble) _tmp30_) / _tmp33_);
	_tmp34_ = handle;
	rsvg_handle_render_cairo (_tmp34_, c2);
	cairo_restore (c2);
	_g_object_unref0 (handle);
}


static void
chess_view_load_theme (ChessView* self,
                       cairo_t* c)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ChessScene* _tmp2_;
	ChessScene* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gint _tmp10_;
	gint _tmp11_;
	cairo_surface_t* _tmp12_;
	cairo_surface_t* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	cairo_surface_t* _tmp16_;
	cairo_t* c1 = NULL;
	cairo_surface_t* _tmp17_;
	cairo_t* _tmp18_;
	cairo_t* c2 = NULL;
	cairo_surface_t* _tmp19_;
	cairo_t* _tmp20_;
	cairo_t* _tmp21_;
	cairo_t* _tmp22_;
	cairo_t* _tmp23_;
	cairo_t* _tmp24_;
	cairo_t* _tmp25_;
	cairo_t* _tmp26_;
	cairo_t* _tmp27_;
	cairo_t* _tmp28_;
	cairo_t* _tmp29_;
	cairo_t* _tmp30_;
	cairo_t* _tmp31_;
	cairo_t* _tmp32_;
	cairo_t* _tmp33_;
	cairo_t* _tmp34_;
	cairo_t* _tmp35_;
	cairo_t* _tmp36_;
	cairo_t* _tmp37_;
	cairo_t* _tmp38_;
	cairo_t* _tmp39_;
	cairo_t* _tmp40_;
	cairo_t* _tmp41_;
	cairo_t* _tmp42_;
	cairo_t* _tmp43_;
	cairo_t* _tmp44_;
	ChessScene* _tmp45_;
	ChessScene* _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	gchar* _tmp49_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	_tmp2_ = chess_view_get_scene (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = chess_scene_get_theme_name (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = self->priv->loaded_theme_name;
	if (g_strcmp0 (_tmp5_, _tmp6_) == 0) {
		cairo_surface_t* _tmp7_;
		_tmp7_ = self->priv->model_surface;
		_tmp1_ = _tmp7_ != NULL;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gint _tmp8_;
		cairo_surface_t* _tmp9_;
		_tmp8_ = self->priv->square_size;
		_tmp9_ = self->priv->model_surface;
		_tmp0_ = _tmp8_ == cairo_image_surface_get_height (_tmp9_);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	_tmp10_ = self->priv->square_size;
	_tmp11_ = self->priv->square_size;
	_tmp12_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, 12 * _tmp10_, _tmp11_);
	_cairo_surface_destroy0 (self->priv->model_surface);
	self->priv->model_surface = _tmp12_;
	_tmp13_ = cairo_get_target (c);
	_tmp14_ = self->priv->selected_square_size;
	_tmp15_ = self->priv->selected_square_size;
	_tmp16_ = cairo_surface_create_similar (_tmp13_, CAIRO_CONTENT_COLOR_ALPHA, 12 * _tmp14_, _tmp15_);
	_cairo_surface_destroy0 (self->priv->selected_model_surface);
	self->priv->selected_model_surface = _tmp16_;
	_tmp17_ = self->priv->model_surface;
	_tmp18_ = cairo_create (_tmp17_);
	c1 = _tmp18_;
	_tmp19_ = self->priv->selected_model_surface;
	_tmp20_ = cairo_create (_tmp19_);
	c2 = _tmp20_;
	_tmp21_ = c1;
	_tmp22_ = c2;
	chess_view_render_piece (self, _tmp21_, _tmp22_, "whitePawn", 0);
	_tmp23_ = c1;
	_tmp24_ = c2;
	chess_view_render_piece (self, _tmp23_, _tmp24_, "whiteRook", 1);
	_tmp25_ = c1;
	_tmp26_ = c2;
	chess_view_render_piece (self, _tmp25_, _tmp26_, "whiteKnight", 2);
	_tmp27_ = c1;
	_tmp28_ = c2;
	chess_view_render_piece (self, _tmp27_, _tmp28_, "whiteBishop", 3);
	_tmp29_ = c1;
	_tmp30_ = c2;
	chess_view_render_piece (self, _tmp29_, _tmp30_, "whiteQueen", 4);
	_tmp31_ = c1;
	_tmp32_ = c2;
	chess_view_render_piece (self, _tmp31_, _tmp32_, "whiteKing", 5);
	_tmp33_ = c1;
	_tmp34_ = c2;
	chess_view_render_piece (self, _tmp33_, _tmp34_, "blackPawn", 6);
	_tmp35_ = c1;
	_tmp36_ = c2;
	chess_view_render_piece (self, _tmp35_, _tmp36_, "blackRook", 7);
	_tmp37_ = c1;
	_tmp38_ = c2;
	chess_view_render_piece (self, _tmp37_, _tmp38_, "blackKnight", 8);
	_tmp39_ = c1;
	_tmp40_ = c2;
	chess_view_render_piece (self, _tmp39_, _tmp40_, "blackBishop", 9);
	_tmp41_ = c1;
	_tmp42_ = c2;
	chess_view_render_piece (self, _tmp41_, _tmp42_, "blackQueen", 10);
	_tmp43_ = c1;
	_tmp44_ = c2;
	chess_view_render_piece (self, _tmp43_, _tmp44_, "blackKing", 11);
	_tmp45_ = chess_view_get_scene (self);
	_tmp46_ = _tmp45_;
	_tmp47_ = chess_scene_get_theme_name (_tmp46_);
	_tmp48_ = _tmp47_;
	_tmp49_ = g_strdup (_tmp48_);
	_g_free0 (self->priv->loaded_theme_name);
	self->priv->loaded_theme_name = _tmp49_;
	_cairo_destroy0 (c2);
	_cairo_destroy0 (c1);
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static gboolean
chess_view_real_draw (GtkWidget* base,
                      cairo_t* c)
{
	ChessView * self;
	gboolean result = FALSE;
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gint board_size = 0;
	gint _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	ChessScene* _tmp27_;
	ChessScene* _tmp28_;
	gboolean _tmp29_;
	gboolean _tmp30_;
	ChessScene* _tmp146_;
	ChessScene* _tmp147_;
	ChessGame* _tmp148_;
	ChessGame* _tmp149_;
	gboolean _tmp150_;
	gboolean _tmp151_;
	ChessScene* _tmp156_;
	ChessScene* _tmp157_;
	GList* _tmp158_;
	self = (ChessView*) base;
	g_return_val_if_fail (c != NULL, FALSE);
	chess_view_load_theme (self, c);
	cairo_translate (c, (gdouble) (gtk_widget_get_allocated_width ((GtkWidget*) self) / 2), (gdouble) (gtk_widget_get_allocated_height ((GtkWidget*) self) / 2));
	_tmp0_ = chess_view_get_scene (self);
	_tmp1_ = _tmp0_;
	_tmp2_ = chess_scene_get_board_angle (_tmp1_);
	_tmp3_ = _tmp2_;
	cairo_rotate (c, (G_PI * _tmp3_) / 180.0);
	_tmp4_ = self->priv->square_size;
	_tmp5_ = chess_view_get_border_size (self);
	_tmp6_ = _tmp5_;
	board_size = (gint) ceil ((_tmp4_ * 4) + _tmp6_);
	cairo_set_source_rgb (c, 0x2e / 255.0, 0x34 / 255.0, 0x36 / 255.0);
	_tmp7_ = board_size;
	_tmp8_ = board_size;
	_tmp9_ = board_size;
	_tmp10_ = board_size;
	cairo_rectangle (c, (gdouble) (-_tmp7_), (gdouble) (-_tmp8_), (gdouble) (_tmp9_ * 2), (gdouble) (_tmp10_ * 2));
	cairo_fill (c);
	{
		gint file = 0;
		file = 0;
		{
			gboolean _tmp11_ = FALSE;
			_tmp11_ = TRUE;
			while (TRUE) {
				gint _tmp13_;
				if (!_tmp11_) {
					gint _tmp12_;
					_tmp12_ = file;
					file = _tmp12_ + 1;
				}
				_tmp11_ = FALSE;
				_tmp13_ = file;
				if (!(_tmp13_ < 8)) {
					break;
				}
				{
					gint rank = 0;
					rank = 0;
					{
						gboolean _tmp14_ = FALSE;
						_tmp14_ = TRUE;
						while (TRUE) {
							gint _tmp16_;
							gint x = 0;
							gint _tmp17_;
							gint _tmp18_;
							gint y = 0;
							gint _tmp19_;
							gint _tmp20_;
							gint _tmp21_;
							gint _tmp22_;
							gint _tmp23_;
							gint _tmp24_;
							gint _tmp25_;
							gint _tmp26_;
							if (!_tmp14_) {
								gint _tmp15_;
								_tmp15_ = rank;
								rank = _tmp15_ + 1;
							}
							_tmp14_ = FALSE;
							_tmp16_ = rank;
							if (!(_tmp16_ < 8)) {
								break;
							}
							_tmp17_ = file;
							_tmp18_ = self->priv->square_size;
							x = (gint) ((_tmp17_ - 4) * _tmp18_);
							_tmp19_ = rank;
							_tmp20_ = self->priv->square_size;
							y = (gint) ((3 - _tmp19_) * _tmp20_);
							_tmp21_ = x;
							_tmp22_ = y;
							_tmp23_ = self->priv->square_size;
							_tmp24_ = self->priv->square_size;
							cairo_rectangle (c, (gdouble) _tmp21_, (gdouble) _tmp22_, (gdouble) _tmp23_, (gdouble) _tmp24_);
							_tmp25_ = file;
							_tmp26_ = rank;
							if (((_tmp25_ + _tmp26_) % 2) == 0) {
								cairo_set_source_rgb (c, 0xba / 255.0, 0xbd / 255.0, 0xb6 / 255.0);
							} else {
								cairo_set_source_rgb (c, 0xee / 255.0, 0xee / 255.0, 0xec / 255.0);
							}
							cairo_fill (c);
						}
					}
				}
			}
		}
	}
	_tmp27_ = chess_view_get_scene (self);
	_tmp28_ = _tmp27_;
	_tmp29_ = chess_scene_get_show_numbering (_tmp28_);
	_tmp30_ = _tmp29_;
	if (_tmp30_) {
		gdouble _tmp31_;
		gdouble _tmp32_;
		cairo_text_extents_t extents = {0};
		cairo_text_extents_t _tmp33_ = {0};
		gdouble y_offset = 0.0;
		gint _tmp34_;
		cairo_text_extents_t _tmp35_;
		gdouble _tmp36_;
		cairo_text_extents_t _tmp37_;
		gdouble _tmp38_;
		cairo_text_extents_t _tmp39_;
		gdouble _tmp40_;
		gdouble top = 0.0;
		gint _tmp41_;
		gdouble _tmp42_;
		gdouble bottom = 0.0;
		gint _tmp43_;
		gdouble _tmp44_;
		gdouble _tmp45_;
		gdouble _tmp46_;
		gdouble file_offset = 0.0;
		gint _tmp47_;
		gdouble rank_offset = 0.0;
		gint _tmp48_;
		gchar** files = NULL;
		gint files_length1 = 0;
		gint _files_size_ = 0;
		gchar** ranks = NULL;
		gint ranks_length1 = 0;
		gint _ranks_size_ = 0;
		cairo_matrix_t matrix = {0};
		cairo_matrix_t _tmp49_ = {0};
		ChessScene* _tmp50_;
		ChessScene* _tmp51_;
		gdouble _tmp52_;
		gdouble _tmp53_;
		cairo_matrix_t _tmp90_;
		cairo_set_source_rgb (c, 0x88 / 255.0, 0x8a / 255.0, 0x85 / 255.0);
		_tmp31_ = chess_view_get_border_size (self);
		_tmp32_ = _tmp31_;
		cairo_set_font_size (c, _tmp32_ * 0.6);
		cairo_select_font_face (c, "sans-serif", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
		cairo_text_extents (c, "abcdefgh", &_tmp33_);
		extents = _tmp33_;
		_tmp34_ = self->priv->square_size;
		_tmp35_ = extents;
		_tmp36_ = _tmp35_.height;
		_tmp37_ = extents;
		_tmp38_ = _tmp37_.height;
		_tmp39_ = extents;
		_tmp40_ = _tmp39_.y_bearing;
		y_offset = ((((_tmp34_ / 2) - _tmp36_) / 2) + _tmp38_) + _tmp40_;
		_tmp41_ = self->priv->square_size;
		_tmp42_ = y_offset;
		top = -((_tmp41_ * 4) + _tmp42_);
		_tmp43_ = self->priv->square_size;
		_tmp44_ = chess_view_get_border_size (self);
		_tmp45_ = _tmp44_;
		_tmp46_ = y_offset;
		bottom = ((_tmp43_ * 4) + _tmp45_) - _tmp46_;
		_tmp47_ = self->priv->square_size;
		file_offset = -(_tmp47_ * 3.5);
		_tmp48_ = self->priv->square_size;
		rank_offset = -(_tmp48_ * 3.5);
		cairo_get_matrix (c, &_tmp49_);
		matrix = _tmp49_;
		_tmp50_ = chess_view_get_scene (self);
		_tmp51_ = _tmp50_;
		_tmp52_ = chess_scene_get_board_angle (_tmp51_);
		_tmp53_ = _tmp52_;
		if (_tmp53_ == 180.0) {
			gchar* _tmp54_;
			gchar* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
			gchar* _tmp58_;
			gchar* _tmp59_;
			gchar* _tmp60_;
			gchar* _tmp61_;
			gchar** _tmp62_;
			gchar* _tmp63_;
			gchar* _tmp64_;
			gchar* _tmp65_;
			gchar* _tmp66_;
			gchar* _tmp67_;
			gchar* _tmp68_;
			gchar* _tmp69_;
			gchar* _tmp70_;
			gchar** _tmp71_;
			_tmp54_ = g_strdup ("h");
			_tmp55_ = g_strdup ("g");
			_tmp56_ = g_strdup ("f");
			_tmp57_ = g_strdup ("e");
			_tmp58_ = g_strdup ("d");
			_tmp59_ = g_strdup ("c");
			_tmp60_ = g_strdup ("b");
			_tmp61_ = g_strdup ("a");
			_tmp62_ = g_new0 (gchar*, 8 + 1);
			_tmp62_[0] = _tmp54_;
			_tmp62_[1] = _tmp55_;
			_tmp62_[2] = _tmp56_;
			_tmp62_[3] = _tmp57_;
			_tmp62_[4] = _tmp58_;
			_tmp62_[5] = _tmp59_;
			_tmp62_[6] = _tmp60_;
			_tmp62_[7] = _tmp61_;
			files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_free), NULL);
			files = _tmp62_;
			files_length1 = 8;
			_files_size_ = files_length1;
			_tmp63_ = g_strdup ("1");
			_tmp64_ = g_strdup ("2");
			_tmp65_ = g_strdup ("3");
			_tmp66_ = g_strdup ("4");
			_tmp67_ = g_strdup ("5");
			_tmp68_ = g_strdup ("6");
			_tmp69_ = g_strdup ("7");
			_tmp70_ = g_strdup ("8");
			_tmp71_ = g_new0 (gchar*, 8 + 1);
			_tmp71_[0] = _tmp63_;
			_tmp71_[1] = _tmp64_;
			_tmp71_[2] = _tmp65_;
			_tmp71_[3] = _tmp66_;
			_tmp71_[4] = _tmp67_;
			_tmp71_[5] = _tmp68_;
			_tmp71_[6] = _tmp69_;
			_tmp71_[7] = _tmp70_;
			ranks = (_vala_array_free (ranks, ranks_length1, (GDestroyNotify) g_free), NULL);
			ranks = _tmp71_;
			ranks_length1 = 8;
			_ranks_size_ = ranks_length1;
			cairo_matrix_scale (&matrix, (gdouble) -1, (gdouble) -1);
		} else {
			gchar* _tmp72_;
			gchar* _tmp73_;
			gchar* _tmp74_;
			gchar* _tmp75_;
			gchar* _tmp76_;
			gchar* _tmp77_;
			gchar* _tmp78_;
			gchar* _tmp79_;
			gchar** _tmp80_;
			gchar* _tmp81_;
			gchar* _tmp82_;
			gchar* _tmp83_;
			gchar* _tmp84_;
			gchar* _tmp85_;
			gchar* _tmp86_;
			gchar* _tmp87_;
			gchar* _tmp88_;
			gchar** _tmp89_;
			_tmp72_ = g_strdup ("a");
			_tmp73_ = g_strdup ("b");
			_tmp74_ = g_strdup ("c");
			_tmp75_ = g_strdup ("d");
			_tmp76_ = g_strdup ("e");
			_tmp77_ = g_strdup ("f");
			_tmp78_ = g_strdup ("g");
			_tmp79_ = g_strdup ("h");
			_tmp80_ = g_new0 (gchar*, 8 + 1);
			_tmp80_[0] = _tmp72_;
			_tmp80_[1] = _tmp73_;
			_tmp80_[2] = _tmp74_;
			_tmp80_[3] = _tmp75_;
			_tmp80_[4] = _tmp76_;
			_tmp80_[5] = _tmp77_;
			_tmp80_[6] = _tmp78_;
			_tmp80_[7] = _tmp79_;
			files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_free), NULL);
			files = _tmp80_;
			files_length1 = 8;
			_files_size_ = files_length1;
			_tmp81_ = g_strdup ("8");
			_tmp82_ = g_strdup ("7");
			_tmp83_ = g_strdup ("6");
			_tmp84_ = g_strdup ("5");
			_tmp85_ = g_strdup ("4");
			_tmp86_ = g_strdup ("3");
			_tmp87_ = g_strdup ("2");
			_tmp88_ = g_strdup ("1");
			_tmp89_ = g_new0 (gchar*, 8 + 1);
			_tmp89_[0] = _tmp81_;
			_tmp89_[1] = _tmp82_;
			_tmp89_[2] = _tmp83_;
			_tmp89_[3] = _tmp84_;
			_tmp89_[4] = _tmp85_;
			_tmp89_[5] = _tmp86_;
			_tmp89_[6] = _tmp87_;
			_tmp89_[7] = _tmp88_;
			ranks = (_vala_array_free (ranks, ranks_length1, (GDestroyNotify) g_free), NULL);
			ranks = _tmp89_;
			ranks_length1 = 8;
			_ranks_size_ = ranks_length1;
		}
		cairo_save (c);
		_tmp90_ = matrix;
		cairo_set_matrix (c, &_tmp90_);
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp91_ = FALSE;
				_tmp91_ = TRUE;
				while (TRUE) {
					gint _tmp93_;
					gchar** _tmp94_;
					gint _tmp94__length1;
					gint _tmp95_;
					const gchar* _tmp96_;
					cairo_text_extents_t _tmp97_ = {0};
					gdouble _tmp98_;
					cairo_text_extents_t _tmp99_;
					gdouble _tmp100_;
					gdouble _tmp101_;
					gchar** _tmp102_;
					gint _tmp102__length1;
					gint _tmp103_;
					const gchar* _tmp104_;
					gdouble _tmp105_;
					cairo_text_extents_t _tmp106_;
					gdouble _tmp107_;
					gdouble _tmp108_;
					gchar** _tmp109_;
					gint _tmp109__length1;
					gint _tmp110_;
					const gchar* _tmp111_;
					gchar** _tmp112_;
					gint _tmp112__length1;
					gint _tmp113_;
					const gchar* _tmp114_;
					cairo_text_extents_t _tmp115_ = {0};
					cairo_text_extents_t _tmp116_;
					gdouble _tmp117_;
					cairo_text_extents_t _tmp118_;
					gdouble _tmp119_;
					gint _tmp120_;
					gdouble _tmp121_;
					gdouble _tmp122_;
					gdouble _tmp123_;
					gdouble _tmp124_;
					cairo_text_extents_t _tmp125_;
					gdouble _tmp126_;
					gdouble _tmp127_;
					gdouble _tmp128_;
					gchar** _tmp129_;
					gint _tmp129__length1;
					gint _tmp130_;
					const gchar* _tmp131_;
					gint _tmp132_;
					gdouble _tmp133_;
					gdouble _tmp134_;
					cairo_text_extents_t _tmp135_;
					gdouble _tmp136_;
					gdouble _tmp137_;
					gdouble _tmp138_;
					gchar** _tmp139_;
					gint _tmp139__length1;
					gint _tmp140_;
					const gchar* _tmp141_;
					gdouble _tmp142_;
					gint _tmp143_;
					gdouble _tmp144_;
					gint _tmp145_;
					if (!_tmp91_) {
						gint _tmp92_;
						_tmp92_ = i;
						i = _tmp92_ + 1;
					}
					_tmp91_ = FALSE;
					_tmp93_ = i;
					if (!(_tmp93_ < 8)) {
						break;
					}
					_tmp94_ = ranks;
					_tmp94__length1 = ranks_length1;
					_tmp95_ = i;
					_tmp96_ = _tmp94_[_tmp95_];
					cairo_text_extents (c, _tmp96_, &_tmp97_);
					extents = _tmp97_;
					cairo_save (c);
					_tmp98_ = file_offset;
					_tmp99_ = extents;
					_tmp100_ = _tmp99_.width;
					_tmp101_ = top;
					cairo_move_to (c, _tmp98_ - (_tmp100_ / 2), _tmp101_);
					_tmp102_ = files;
					_tmp102__length1 = files_length1;
					_tmp103_ = i;
					_tmp104_ = _tmp102_[_tmp103_];
					cairo_show_text (c, _tmp104_);
					cairo_restore (c);
					cairo_save (c);
					_tmp105_ = file_offset;
					_tmp106_ = extents;
					_tmp107_ = _tmp106_.width;
					_tmp108_ = bottom;
					cairo_move_to (c, _tmp105_ - (_tmp107_ / 2), _tmp108_);
					_tmp109_ = files;
					_tmp109__length1 = files_length1;
					_tmp110_ = i;
					_tmp111_ = _tmp109_[_tmp110_];
					cairo_show_text (c, _tmp111_);
					cairo_restore (c);
					_tmp112_ = ranks;
					_tmp112__length1 = ranks_length1;
					_tmp113_ = i;
					_tmp114_ = _tmp112_[_tmp113_];
					cairo_text_extents (c, _tmp114_, &_tmp115_);
					extents = _tmp115_;
					_tmp116_ = extents;
					_tmp117_ = _tmp116_.y_bearing;
					_tmp118_ = extents;
					_tmp119_ = _tmp118_.height;
					y_offset = -(_tmp117_ + (_tmp119_ / 2));
					cairo_save (c);
					_tmp120_ = self->priv->square_size;
					_tmp121_ = chess_view_get_border_size (self);
					_tmp122_ = _tmp121_;
					_tmp123_ = chess_view_get_border_size (self);
					_tmp124_ = _tmp123_;
					_tmp125_ = extents;
					_tmp126_ = _tmp125_.width;
					_tmp127_ = rank_offset;
					_tmp128_ = y_offset;
					cairo_move_to (c, -(((((gdouble) _tmp120_) * 4) + _tmp122_) - ((_tmp124_ - _tmp126_) / 2)), _tmp127_ + _tmp128_);
					_tmp129_ = ranks;
					_tmp129__length1 = ranks_length1;
					_tmp130_ = i;
					_tmp131_ = _tmp129_[_tmp130_];
					cairo_show_text (c, _tmp131_);
					cairo_restore (c);
					cairo_save (c);
					_tmp132_ = self->priv->square_size;
					_tmp133_ = chess_view_get_border_size (self);
					_tmp134_ = _tmp133_;
					_tmp135_ = extents;
					_tmp136_ = _tmp135_.width;
					_tmp137_ = rank_offset;
					_tmp138_ = y_offset;
					cairo_move_to (c, (((gdouble) _tmp132_) * 4) + ((_tmp134_ - _tmp136_) / 2), _tmp137_ + _tmp138_);
					_tmp139_ = ranks;
					_tmp139__length1 = ranks_length1;
					_tmp140_ = i;
					_tmp141_ = _tmp139_[_tmp140_];
					cairo_show_text (c, _tmp141_);
					cairo_restore (c);
					_tmp142_ = file_offset;
					_tmp143_ = self->priv->square_size;
					file_offset = _tmp142_ + _tmp143_;
					_tmp144_ = rank_offset;
					_tmp145_ = self->priv->square_size;
					rank_offset = _tmp144_ + _tmp145_;
				}
			}
		}
		cairo_restore (c);
		ranks = (_vala_array_free (ranks, ranks_length1, (GDestroyNotify) g_free), NULL);
		files = (_vala_array_free (files, files_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp146_ = chess_view_get_scene (self);
	_tmp147_ = _tmp146_;
	_tmp148_ = chess_scene_get_game (_tmp147_);
	_tmp149_ = _tmp148_;
	_tmp150_ = chess_game_get_should_show_paused_overlay (_tmp149_);
	_tmp151_ = _tmp150_;
	if (_tmp151_) {
		ChessScene* _tmp152_;
		ChessScene* _tmp153_;
		gdouble _tmp154_;
		gdouble _tmp155_;
		_tmp152_ = chess_view_get_scene (self);
		_tmp153_ = _tmp152_;
		_tmp154_ = chess_scene_get_board_angle (_tmp153_);
		_tmp155_ = _tmp154_;
		cairo_rotate (c, (G_PI * _tmp155_) / 180.0);
		chess_view_draw_paused_overlay (self, c);
		result = TRUE;
		return result;
	}
	_tmp156_ = chess_view_get_scene (self);
	_tmp157_ = _tmp156_;
	_tmp158_ = _tmp157_->pieces;
	{
		GList* model_collection = NULL;
		GList* model_it = NULL;
		model_collection = _tmp158_;
		for (model_it = model_collection; model_it != NULL; model_it = model_it->next) {
			ChessModel* _tmp159_;
			ChessModel* model = NULL;
			_tmp159_ = _g_object_ref0 ((ChessModel*) model_it->data);
			model = _tmp159_;
			{
				ChessModel* _tmp160_;
				gdouble _tmp161_;
				gint _tmp162_;
				ChessModel* _tmp163_;
				gdouble _tmp164_;
				gint _tmp165_;
				gint _tmp166_;
				gint _tmp167_;
				ChessScene* _tmp168_;
				ChessScene* _tmp169_;
				gdouble _tmp170_;
				gdouble _tmp171_;
				cairo_surface_t* _tmp172_ = NULL;
				ChessModel* _tmp173_;
				gboolean _tmp174_;
				gint _tmp177_ = 0;
				ChessModel* _tmp178_;
				gboolean _tmp179_;
				gdouble _tmp182_ = 0.0;
				gboolean _tmp183_ = FALSE;
				ChessModel* _tmp184_;
				gboolean _tmp185_;
				ChessModel* _tmp190_;
				ChessPiece* _tmp191_;
				cairo_save (c);
				_tmp160_ = model;
				_tmp161_ = _tmp160_->x;
				_tmp162_ = self->priv->square_size;
				_tmp163_ = model;
				_tmp164_ = _tmp163_->y;
				_tmp165_ = self->priv->square_size;
				cairo_translate (c, (_tmp161_ - 4) * _tmp162_, (3 - _tmp164_) * _tmp165_);
				_tmp166_ = self->priv->square_size;
				_tmp167_ = self->priv->square_size;
				cairo_translate (c, (gdouble) (_tmp166_ / 2), (gdouble) (_tmp167_ / 2));
				_tmp168_ = chess_view_get_scene (self);
				_tmp169_ = _tmp168_;
				_tmp170_ = chess_scene_get_board_angle (_tmp169_);
				_tmp171_ = _tmp170_;
				cairo_rotate (c, ((-G_PI) * _tmp171_) / 180.0);
				_tmp173_ = model;
				_tmp174_ = _tmp173_->is_selected;
				if (_tmp174_) {
					cairo_surface_t* _tmp175_;
					_tmp175_ = self->priv->selected_model_surface;
					_tmp172_ = _tmp175_;
				} else {
					cairo_surface_t* _tmp176_;
					_tmp176_ = self->priv->model_surface;
					_tmp172_ = _tmp176_;
				}
				_tmp178_ = model;
				_tmp179_ = _tmp178_->is_selected;
				if (_tmp179_) {
					gint _tmp180_;
					_tmp180_ = self->priv->selected_square_size;
					_tmp177_ = _tmp180_;
				} else {
					gint _tmp181_;
					_tmp181_ = self->priv->square_size;
					_tmp177_ = _tmp181_;
				}
				_tmp184_ = model;
				_tmp185_ = _tmp184_->under_threat;
				if (_tmp185_) {
					ChessScene* _tmp186_;
					ChessScene* _tmp187_;
					gboolean _tmp188_;
					gboolean _tmp189_;
					_tmp186_ = chess_view_get_scene (self);
					_tmp187_ = _tmp186_;
					_tmp188_ = chess_scene_get_show_move_hints (_tmp187_);
					_tmp189_ = _tmp188_;
					_tmp183_ = _tmp189_;
				} else {
					_tmp183_ = FALSE;
				}
				if (_tmp183_) {
					_tmp182_ = 0.8;
				} else {
					_tmp182_ = 1.0;
				}
				_tmp190_ = model;
				_tmp191_ = _tmp190_->piece;
				chess_view_draw_piece (self, c, _tmp172_, _tmp177_, _tmp191_, _tmp182_);
				cairo_restore (c);
				_g_object_unref0 (model);
			}
		}
	}
	{
		gint rank = 0;
		rank = 0;
		{
			gboolean _tmp192_ = FALSE;
			_tmp192_ = TRUE;
			while (TRUE) {
				gint _tmp194_;
				if (!_tmp192_) {
					gint _tmp193_;
					_tmp193_ = rank;
					rank = _tmp193_ + 1;
				}
				_tmp192_ = FALSE;
				_tmp194_ = rank;
				if (!(_tmp194_ < 8)) {
					break;
				}
				{
					gint file = 0;
					file = 0;
					{
						gboolean _tmp195_ = FALSE;
						_tmp195_ = TRUE;
						while (TRUE) {
							gint _tmp197_;
							gboolean _tmp198_ = FALSE;
							ChessScene* _tmp199_;
							ChessScene* _tmp200_;
							gboolean _tmp201_;
							gboolean _tmp202_;
							if (!_tmp195_) {
								gint _tmp196_;
								_tmp196_ = file;
								file = _tmp196_ + 1;
							}
							_tmp195_ = FALSE;
							_tmp197_ = file;
							if (!(_tmp197_ < 8)) {
								break;
							}
							_tmp199_ = chess_view_get_scene (self);
							_tmp200_ = _tmp199_;
							_tmp201_ = chess_scene_get_show_move_hints (_tmp200_);
							_tmp202_ = _tmp201_;
							if (_tmp202_) {
								ChessScene* _tmp203_;
								ChessScene* _tmp204_;
								gint _tmp205_;
								gint _tmp206_;
								_tmp203_ = chess_view_get_scene (self);
								_tmp204_ = _tmp203_;
								_tmp205_ = rank;
								_tmp206_ = file;
								_tmp198_ = chess_scene_can_move (_tmp204_, _tmp205_, _tmp206_);
							} else {
								_tmp198_ = FALSE;
							}
							if (_tmp198_) {
								gint _tmp207_;
								gint _tmp208_;
								gint _tmp209_;
								gint _tmp210_;
								gint _tmp211_;
								gint _tmp212_;
								ChessScene* _tmp213_;
								ChessScene* _tmp214_;
								gdouble _tmp215_;
								gdouble _tmp216_;
								cairo_surface_t* _tmp217_;
								gint _tmp218_;
								ChessScene* _tmp219_;
								ChessScene* _tmp220_;
								ChessPiece* _tmp221_;
								ChessPiece* _tmp222_;
								cairo_save (c);
								_tmp207_ = file;
								_tmp208_ = self->priv->square_size;
								_tmp209_ = rank;
								_tmp210_ = self->priv->square_size;
								cairo_translate (c, (gdouble) ((_tmp207_ - 4) * _tmp208_), (gdouble) ((3 - _tmp209_) * _tmp210_));
								_tmp211_ = self->priv->square_size;
								_tmp212_ = self->priv->square_size;
								cairo_translate (c, (gdouble) (_tmp211_ / 2), (gdouble) (_tmp212_ / 2));
								_tmp213_ = chess_view_get_scene (self);
								_tmp214_ = _tmp213_;
								_tmp215_ = chess_scene_get_board_angle (_tmp214_);
								_tmp216_ = _tmp215_;
								cairo_rotate (c, ((-G_PI) * _tmp216_) / 180.0);
								_tmp217_ = self->priv->model_surface;
								_tmp218_ = self->priv->square_size;
								_tmp219_ = chess_view_get_scene (self);
								_tmp220_ = _tmp219_;
								_tmp221_ = chess_scene_get_selected_piece (_tmp220_);
								_tmp222_ = _tmp221_;
								chess_view_draw_piece (self, c, _tmp217_, _tmp218_, _tmp222_, 0.1);
								_g_object_unref0 (_tmp222_);
								cairo_restore (c);
							}
						}
					}
				}
			}
		}
	}
	result = TRUE;
	return result;
}


static void
chess_view_draw_piece (ChessView* self,
                       cairo_t* c,
                       cairo_surface_t* surface,
                       gint size,
                       ChessPiece* piece,
                       gdouble alpha)
{
	gint offset = 0;
	PieceType _tmp0_;
	Color _tmp1_;
	Color _tmp2_;
	gint _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	g_return_if_fail (surface != NULL);
	g_return_if_fail (piece != NULL);
	cairo_translate (c, (gdouble) ((-size) / 2), (gdouble) ((-size) / 2));
	_tmp0_ = piece->type;
	offset = (gint) _tmp0_;
	_tmp1_ = chess_piece_get_color (piece);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == COLOR_BLACK) {
		gint _tmp3_;
		_tmp3_ = offset;
		offset = _tmp3_ + 6;
	}
	_tmp4_ = offset;
	cairo_set_source_surface (c, surface, (gdouble) ((-_tmp4_) * size), (gdouble) 0);
	cairo_rectangle (c, (gdouble) 0, (gdouble) 0, (gdouble) size, (gdouble) size);
	cairo_clip (c);
	cairo_paint_with_alpha (c, alpha);
}


static gboolean
chess_view_real_button_press_event (GtkWidget* base,
                                    GdkEventButton* event)
{
	ChessView * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ChessScene* _tmp2_;
	ChessScene* _tmp3_;
	ChessGame* _tmp4_;
	ChessGame* _tmp5_;
	ChessScene* _tmp13_;
	ChessScene* _tmp14_;
	ChessGame* _tmp15_;
	ChessGame* _tmp16_;
	ChessResult _tmp17_;
	gint file = 0;
	gdouble _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint rank = 0;
	gdouble _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	ChessScene* _tmp24_;
	ChessScene* _tmp25_;
	gdouble _tmp26_;
	gdouble _tmp27_;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gint _tmp33_;
	ChessScene* _tmp37_;
	ChessScene* _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	self = (ChessView*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp2_ = chess_view_get_scene (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = chess_scene_get_game (_tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_ == NULL) {
		_tmp1_ = TRUE;
	} else {
		guint _tmp6_;
		_tmp6_ = event->button;
		_tmp1_ = _tmp6_ != ((guint) 1);
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		ChessScene* _tmp7_;
		ChessScene* _tmp8_;
		ChessGame* _tmp9_;
		ChessGame* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
		_tmp7_ = chess_view_get_scene (self);
		_tmp8_ = _tmp7_;
		_tmp9_ = chess_scene_get_game (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = chess_game_get_should_show_paused_overlay (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp0_ = _tmp12_;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp13_ = chess_view_get_scene (self);
	_tmp14_ = _tmp13_;
	_tmp15_ = chess_scene_get_game (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = _tmp16_->result;
	if (_tmp17_ != CHESS_RESULT_IN_PROGRESS) {
		result = FALSE;
		return result;
	}
	_tmp18_ = event->x;
	_tmp19_ = self->priv->square_size;
	_tmp20_ = self->priv->square_size;
	file = (gint) floor (((_tmp18_ - (0.5 * gtk_widget_get_allocated_width ((GtkWidget*) self))) + (_tmp19_ * 4)) / _tmp20_);
	_tmp21_ = event->y;
	_tmp22_ = self->priv->square_size;
	_tmp23_ = self->priv->square_size;
	rank = 7 - ((gint) floor (((_tmp21_ - (0.5 * gtk_widget_get_allocated_height ((GtkWidget*) self))) + (_tmp22_ * 4)) / _tmp23_));
	_tmp24_ = chess_view_get_scene (self);
	_tmp25_ = _tmp24_;
	_tmp26_ = chess_scene_get_board_angle (_tmp25_);
	_tmp27_ = _tmp26_;
	if (_tmp27_ == 180.0) {
		gint _tmp28_;
		gint _tmp29_;
		_tmp28_ = rank;
		rank = 7 - _tmp28_;
		_tmp29_ = file;
		file = 7 - _tmp29_;
	}
	_tmp33_ = file;
	if (_tmp33_ < 0) {
		_tmp32_ = TRUE;
	} else {
		gint _tmp34_;
		_tmp34_ = file;
		_tmp32_ = _tmp34_ >= 8;
	}
	if (_tmp32_) {
		_tmp31_ = TRUE;
	} else {
		gint _tmp35_;
		_tmp35_ = rank;
		_tmp31_ = _tmp35_ < 0;
	}
	if (_tmp31_) {
		_tmp30_ = TRUE;
	} else {
		gint _tmp36_;
		_tmp36_ = rank;
		_tmp30_ = _tmp36_ >= 8;
	}
	if (_tmp30_) {
		result = FALSE;
		return result;
	}
	_tmp37_ = chess_view_get_scene (self);
	_tmp38_ = _tmp37_;
	_tmp39_ = file;
	_tmp40_ = rank;
	chess_scene_select_square (_tmp38_, _tmp39_, _tmp40_);
	result = TRUE;
	return result;
}


static void
chess_view_scene_changed_cb (ChessView* self,
                             ChessScene* scene)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (scene != NULL);
	gtk_widget_queue_draw ((GtkWidget*) self);
}


void
chess_view_draw_paused_overlay (ChessView* self,
                                cairo_t* c)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	cairo_text_extents_t extents = {0};
	cairo_text_extents_t _tmp1_ = {0};
	cairo_text_extents_t _tmp2_;
	gdouble _tmp3_;
	cairo_text_extents_t _tmp4_;
	gdouble _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	cairo_save (c);
	cairo_set_source_rgba (c, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.75);
	cairo_paint (c);
	cairo_select_font_face (c, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
	cairo_set_font_size (c, gtk_widget_get_allocated_width ((GtkWidget*) self) * 0.125);
	_tmp0_ = g_strdup (_ ("Paused"));
	text = _tmp0_;
	cairo_text_extents (c, text, &_tmp1_);
	extents = _tmp1_;
	_tmp2_ = extents;
	_tmp3_ = _tmp2_.width;
	_tmp4_ = extents;
	_tmp5_ = _tmp4_.height;
	cairo_move_to (c, (-_tmp3_) / 2.0, _tmp5_ / 2.0);
	cairo_set_source_rgb (c, (gdouble) 1, (gdouble) 1, (gdouble) 1);
	cairo_show_text (c, text);
	cairo_restore (c);
	_g_free0 (text);
}


ChessScene*
chess_view_get_scene (ChessView* self)
{
	ChessScene* result;
	ChessScene* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_scene;
	result = _tmp0_;
	return result;
}


static void
_chess_view_scene_changed_cb_chess_scene_changed (ChessScene* _sender,
                                                  gpointer self)
{
	chess_view_scene_changed_cb ((ChessView*) self, _sender);
}


void
chess_view_set_scene (ChessView* self,
                      ChessScene* value)
{
	ChessScene* _tmp0_;
	ChessScene* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_scene);
	self->priv->_scene = _tmp0_;
	_tmp1_ = self->priv->_scene;
	g_signal_connect_object (_tmp1_, "changed", (GCallback) _chess_view_scene_changed_cb_chess_scene_changed, self, 0);
	gtk_widget_queue_draw ((GtkWidget*) self);
	g_object_notify_by_pspec ((GObject *) self, chess_view_properties[CHESS_VIEW_SCENE_PROPERTY]);
}


static gdouble
chess_view_get_border_size (ChessView* self)
{
	gdouble result;
	gint _tmp0_;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->square_size;
	result = (gdouble) (_tmp0_ / 2);
	return result;
}


static void
chess_view_class_init (ChessViewClass * klass)
{
	chess_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ChessViewPrivate));
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget *, GdkEventConfigure*)) chess_view_real_configure_event;
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget *, cairo_t*)) chess_view_real_draw;
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget *, GdkEventButton*)) chess_view_real_button_press_event;
	G_OBJECT_CLASS (klass)->get_property = _vala_chess_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_chess_view_set_property;
	G_OBJECT_CLASS (klass)->finalize = chess_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), CHESS_VIEW_SCENE_PROPERTY, chess_view_properties[CHESS_VIEW_SCENE_PROPERTY] = g_param_spec_object ("scene", "scene", "scene", TYPE_CHESS_SCENE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void
chess_view_instance_init (ChessView * self)
{
	gchar* _tmp0_;
	self->priv = CHESS_VIEW_GET_PRIVATE (self);
	self->priv->border = 6;
	_tmp0_ = g_strdup ("");
	self->priv->loaded_theme_name = _tmp0_;
}


static void
chess_view_finalize (GObject * obj)
{
	ChessView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CHESS_VIEW, ChessView);
	_cairo_surface_destroy0 (self->priv->model_surface);
	_cairo_surface_destroy0 (self->priv->selected_model_surface);
	_g_free0 (self->priv->loaded_theme_name);
	_g_object_unref0 (self->priv->_scene);
	G_OBJECT_CLASS (chess_view_parent_class)->finalize (obj);
}


GType
chess_view_get_type (void)
{
	static volatile gsize chess_view_type_id__volatile = 0;
	if (g_once_init_enter (&chess_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ChessViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) chess_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ChessView), 0, (GInstanceInitFunc) chess_view_instance_init, NULL };
		GType chess_view_type_id;
		chess_view_type_id = g_type_register_static (gtk_drawing_area_get_type (), "ChessView", &g_define_type_info, 0);
		g_once_init_leave (&chess_view_type_id__volatile, chess_view_type_id);
	}
	return chess_view_type_id__volatile;
}


static void
_vala_chess_view_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	ChessView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_VIEW, ChessView);
	switch (property_id) {
		case CHESS_VIEW_SCENE_PROPERTY:
		g_value_set_object (value, chess_view_get_scene (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_chess_view_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	ChessView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CHESS_VIEW, ChessView);
	switch (property_id) {
		case CHESS_VIEW_SCENE_PROPERTY:
		chess_view_set_scene (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



